*CMZ :          05/07/96  10.27.35  by  Hartwig Albrecht
*CMZ :  2.01/03 16/02/96  14.13.42  by  Hartwig Albrecht
*CMZ :  2.01/02 10/01/96  15.29.41  by  Hartwig Albrecht
*CMZ :  2.01/01 22/12/95  13.24.04  by  Hartwig Albrecht
*CMZ :  2.01/00 14/02/95  11.11.35  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   02/02/95

      SUBROUTINE ATINIT

************************************************************************
*
* Description: Program initialization
*
* Called from: ATMAIN
*
* External references: ...
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"

      INTEGER IZEB(4),PAWCOM, DUMMY, FAINIT, DBINIT
      COMMON /PAWC/ PAWCOM(NARPAW)
      DATA IZEB /4, -2, LLOGF, LSTDO/

#include "arte/Arte.ff"

C general initialization

      CALL UTINIT

C Default units

      CALL IOINIT

C Geant version

      CALL HGVERS

C Print title

      CALL LITITL ('TPL')

C Zebra initialization

      CALL MZEBRA (IZEB)

C length of working space declared in user routines:

      CALL USPACE

C Zebra working space

      CALL MZSTOR (IXSTOR, '/GCBANK/', ' ' ,QFENCE, LQ, LQ(2), LQ(3),
     +             IQ(1000), IQ(NZEBRA))

C Zebra divisions

      CALL MZDIV (IXSTOR, IXCONS, 'constant', 2000, 8*NZEBRA/10, 'LRC')
      IXEVNT = IXSTOR + 2
      CALL MZXREF (IXCONS, IXEVNT, 'C')
      CALL MZXREF (IXEVNT, IXCONS, 'C')

C initialize MM package

      CALL USTABL
      CALL USAUTT

      CALL MMHIER

      C78 = 'ATINIT: working space'
      CALL CH78BI (NZEBRA)
      CALL CH78BC ('words')
      CALL ME78WC (187349)

C Kuip initialization

      CALL KUINIT (100 000)
      CALL ATKUIP
      CALL DIKUIP
      CALL L1KUIP
      CALL SUSIKUIP
      CALL USKUIP
      CALL USAUTH
      CALL GINTRI

C Quasi BLOCK DATA for Lund

      CALL ALDATA

C FARM initialization

      DUMMY = FAINIT ()

C DB initialization

C      DUMMY = DBINIT ()

C read constants

      CALL ATCONS

C Geant initialization - part I

      CALL GINIT
      CALL HGCONS

C check validity of program arguments

      IF (IBATCH .GT. 1)  CALL MEERRC (1783645,
     +  'ATINIT: parameter BATCH or INTERACTIVE not given')

      END

************************************************************************
* End of ATINIT
************************************************************************
