*CMZ :  2.01/01 16/05/95  13.28.45  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   16/05/95

      SUBROUTINE CHHTOC (IARR, CTEXT)

************************************************************************
*
* Description: copy integer (real) array IARR into CTEXT.
*              Every element of IARR contains up to 4 characters.
*
* Called from: anywhere
*
* External references: UHTOC
*
* Argument in/out description
*   IARR   in     integer (real) array. Its dimension is given by
*                 LEN((CTEXT+3)/4)
*   CTEXT  out    output charcter string.
*
************************************************************************

      IMPLICIT NONE

      INTEGER IARR(*)
      CHARACTER CTEXT*(*)

      CALL UHTOC  (IARR, 4, CTEXT, LEN(CTEXT))

      END

************************************************************************
* End of CHHTOC
************************************************************************
