*CMZ :  2.01/01 24/03/95  15.40.43  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   16/02/95

      SUBROUTINE IFINQU (LUN, IDIR, IFOR, IOPE, IOS, CNAM)

************************************************************************
*
* Description: inquire logical unit LUN
*
* Called from: anywhere
*
* External references: none
*
* Argument in/out description
*   LUN    in     logical unit number (1 ... 99)
*   IDIR   out    record length (direct access); 0 (sequential)
*   IFOR   out    1: formatted
*   IOPE   out    1: opened
*   IOS    out    io status
*   CNAM   out    data set name
*
************************************************************************

      IMPLICIT NONE

      CHARACTER CNAM*(*), CDIR*3, CFOR*3
      INTEGER LUN, IDIR, IFOR, IOPE, IOS
      LOGICAL LOP

      INQUIRE (LUN, DIRECT = CDIR, FORMATTED = CFOR, IOSTAT = IOS,
     +         NAME = CNAM, OPENED = LOP, RECL = IDIR)

      IF (LOP) THEN
        IF (CDIR .NE. 'YES')  IDIR = 0
        IFOR = 0
        IF (CFOR .EQ. 'YES')  IFOR = 1
        IOPE = 1
      ELSE
        IDIR = -1
        IFOR = -1
        IOPE = 0
      END IF

 90   END

************************************************************************
* End of IFINQU
************************************************************************

