*CMZ :  2.01/01 14/07/95  18.46.15  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   16/02/95

      SUBROUTINE IOINQU (LUN)

************************************************************************
*
* Description: check file: inquire logical unit LUN
*                          update i/o info
*
* Called from: anywhere
*
* External references: IFINQU, IOCONC
*
* Argument in/out description
*   LUN    in     logical unit number (1 ... 99)
*
************************************************************************

      IMPLICIT NONE

#include "arte/ZIOCOM.fi"

      CHARACTER CNAM*(NIONMX)
      INTEGER L, LUN, IDIR, IFOR, IOPE, IOS

      CALL IFINQU (LUN, IDIR, IFOR, IOPE, IOS, CNAM)

      IF (IOPE .EQ. 0)  GO TO 90

      L = LUN
 10   IF (IIOFLG(L) .LE. 3)  GO TO 30
      IF (IIONXT(L) .EQ. 0)  GO TO 20
      IF (IIOFLG(IIONXT(L)) .LE. 1 .AND. CIONAM(L) .EQ. CNAM)  THEN
        CALL MEERRC (469,
     +    'INQUIRE: file not properly closed: ' // CIONAM(L))
        IIOFLG(L) = 3
      END IF
      L = IIONXT(L)
      GO TO 10

 20   CALL IOCONC (-L, CNAM, ' ', 0)
      L = NIOUSD

 30   IF (IIOFLG(L) .LE. 0)  THEN
        CIONAM(L) = CNAM
      ELSE IF (CIONAM(L) .NE. CNAM .AND. CIONAM(L) .NE. ' ')  THEN
        CALL MEERRC (951,
     +    'INQUIRE: file not properly closed: ' // CIONAM(L))
        IIOFLG(L) = 4
        GO TO 20
      END IF

      IIOSTA(L) = IOS
      IIOFLG(L) = 3
      NIOLEN(L) = IDIR
      IIOFMT(L) = IFOR

 90   END

************************************************************************
* End of IOINQU
************************************************************************
