*CMZ :          14/05/96  17.33.07  by  Hartwig Albrecht
*CMZ :  2.01/01 21/11/95  16.42.25  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   17/02/95

      SUBROUTINE ME78ER

************************************************************************
*
* Description: Write error message on all printer units.
*              Batch: stop program.
*              Interactive: stop or continue
*
* Called from: anywhere
*
* External references: ATSTOP
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"

      CHARACTER*1 CH1(78)
      CHARACTER CHYN*(3), CHST*(78)
      EQUIVALENCE (CH1,CHST)
      INTEGER L
      DATA CH1 /'*',77*'-'/

#include "arte/Arte.ff"

      PROGERR = PROGERR + 1

      CALL MEALLP (CHST)
      CALL MEALLP ('*')
      CALL MEALLP
     +    ('* Severe error condition:')
      CALL MEALLP ('*')
      IF (IBATCH .NE. 0)  CALL ATSTOP (C78)

      CALL MEALLP ('* === ' // C78)
 10   CHYN = 'n'
      CALL KUPROC (' * Terminate program ?', CHYN, L)
      IF (L .EQ. 0)  GO TO 20
      IF (CHYN(1:1) .EQ. 'Y')
     +  CALL ATSTOP ('Stop due to severe error condition')
      IF (CHYN(1:1) .NE. 'N')  GO TO 10

 20   CALL MEALLP ('* Continue on your own risk ...')
      CALL MEALLP ('*')
      CALL MEALLP (CHST)
      NEVENTL = 0

      END

************************************************************************
* End of ME78ER
************************************************************************
