*CMZ :  2.01/01 14/11/95  20.37.50  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   08/03/95

      SUBROUTINE MMTABL (JL, CN, IDIV)

************************************************************************
*
* Description: initialize a Zebra table
*
* Called from: ARBANK
*
* External references: MEERRO
*                      CERNLIB: CHCTOH
*
* Argument in/out description
*   JL     pntr   link
*   CN     in     table name
*   IDIV   in     Zebra division
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"

      INTEGER JL(1),IDIV,I,IL,HN,LOCF
      CHARACTER*(*) CN
      CHARACTER C4*4

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      C4 = CN
      CALL CLTOU (C4)
      CALL CHCTOH (C4, HN, 1)

      IF (IDIV .NE. IXEVNT .AND. IDIV .NE. IXCONS)  THEN
         C78 = 'MMTABL: Zebra division not properly given'
         GO TO 80
      END IF

      IL = LOCF(JL)

      IF (IL .LE. LARLN1 .OR. IL .GT. LARLNL)  THEN
         C78 = 'MMTABL: Zebra link outside link area'
         GO TO 80
      END IF
      IL = IL - LARLN1

      IF (HMEMO_NAME(IL) .NE. HBLANKSP .AND.
     +    HMEMO_NAME(IL) .NE. HN)  THEN
         C78 = 'MMTABL: bank name was already defined:'
         CALL CH78BC (C4)
         GO TO 80
      END IF

      IF (HMEMO_NAME(IL) .EQ. HBLANKSP .AND. HN .EQ. HBLANKSP)  THEN
         C78 = 'MMTABL: bank name is not given'
         GO TO 80
      END IF

      DO 10 I = 1, NARLNK
         IF (IL .NE. I .AND. HMEMO_NAME(IL) .EQ. HN .AND. HN .NE.
     +   HBLANKSP) THEN
            C78 = 'MMTABL: bank name'
            CALL CH78BC (C4)
            CALL CH78BC ('is used for another table')
            GO TO 80
         END IF
   10 CONTINUE

      IQ(HQMEMO_NAME(IL)) = HN
      IQ(IQMEMO_DIV(IL)) = IDIV
      IQ(IQMEMO_FLAG(IL)) = 0

      GO TO 90

   80 CALL ME78EC (2548154)

   90 END
