*CMZ :  2.01/01 14/11/95  20.37.50  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   16/03/95

      SUBROUTINE MMTFMT (JL, NC, NE, CF)

************************************************************************
*
* Description: handle row size and format of tables
*
* Called from: ARBANK etc.
*
* External references:
*
* Argument in/out description
* JL       in     link
* NC       in     number of columns/row
* CF       in     format
*                 IF CF = ' ': ignore
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"

      INTEGER JL,IX,NC,NE,LOCF
      CHARACTER CF*(*), CNAME*4

#include "arte/Arte.ff"
#include "auto/MEMO.ff"


      IX = LOCF(JL)

      IF (IX .LE. LARLN1 .OR. IX .GT. LARLNL)  THEN
        CALL MEERRC (2784526, 'MMTFMT: Zebra link outside link area')
        GO TO 90
      END IF
      IX = IX - LARLN1

      IQ(IQMEMO_EXT(IX)) = NE
      IF (NC .GE. 0)  IQ(IQMEMO_COL(IX)) = NC
      CALL CHHTOC (IQ(HQMEMO_NAME(IX)), CNAME)
      IF (CF .NE. ' ')  CALL MMFORM (CNAME, CF, IQ(IQMEMO_FMT(1,IX)))

 90   END

************************************************************************
* End of MMTFMT
************************************************************************
