*CMZ :  2.01/01 05/12/95  14.49.39  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   14/07/95

      SUBROUTINE MMWTAB (LUN, IL, IFLAG)

************************************************************************
*
* Description: write one table
*
* Called from: MMWRIT etc.
*
* External references: Zebra FZ
*
* Argument in/out description
*   LUN    in     logical unit
*   IL     in     pointer
*   IFLAG  out    0: ok; > 0: error; < 0: file is full
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MEMO.fi"
#include "arte/ZQUEST.fi"

      INTEGER LUN, IL, INEW, IFLAG, IHEAD(2), FAWTAB
      CHARACTER C4*4

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      IFLAG = 0

      IF (N_F(JLINK(IL)) .GT. 0)  CALL MMFREE (JLINK(IL))

      IHEAD(1) = IQ(JLINK(IL)-4)
      IHEAD(2) = HBLANKSP
      INEW = 0
      IF (IMEMO_SUP(1,IL) .EQ. 0)  INEW = 1

 10   IF (BITTEST(INOUTFARM, 2) .EQ. 0)  THEN
        CALL FZOUT
     +    (LUN, IMEMO_DIV(IL), JLINK(IL), INEW, 'S', 5, 2, IHEAD)
      ELSE
        IQUEST(1) = FAWTAB (IL)
      END IF

      IF (IQUEST(1) .LT. 0)  THEN
        C78 = 'MMWTAB: write error on lun'
        CALL CH78BI (LUN)
        CALL CH78BC ('for table')
        CALL CHHTOC (IQ(HQMEMO_NAME(IL)), C4)
        CALL CH78BC (C4)
        CALL ME78EC (5135734)
        IFLAG = 1
        GO TO 90

      ELSE IF (IQUEST(1) .GT. 0)  THEN
        CALL FZLIMI (LUN, 0.)
        IFLAG = -1
        GO TO 10
      END IF

      IQ(IQMEMO_NOUT(IL)) = IQ(IQMEMO_NOUT(IL)) + 1

 90   END

************************************************************************
* End of MMWTAB
************************************************************************
