/*CMZ :          06/05/96  15.02.34  by  Hartwig Albrecht*/
/*-- Author :    Andreas Gellrich   02/02/96*/
 
// *****************************************************************************
//
// Source:    utcarg.c
//
// functions: void utcarg();
//
// externals: void utfarg_();
//
// Created:   27 Oct 95
// Updated:   31 Jul 96
//
// Author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY-Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: gellrich@ifh.de
//
// *****************************************************************************
 
// includes
#include <stdio.h>
#include <string.h>
 
// prototypes
extern "C"
{
  void utcarg_();
  void utfarg_(int*, char*);
}

// globals
extern int  nArg;
extern char **vArg;

// *****************************************************************************
//
// Name:      utcarg
//
// Purpose:   prepare and pass shell arguments to Fortran routine utfarg_
//
// Hints:     Fortran expects spaces as filling of character variables
//
// *****************************************************************************
 
void
utcarg_( void )
{
 
// locals
  int  i, j, n;
  char Strg[78];
  char *p_Strg = Strg;
 
// prepare argument string
  for( i=0; i<nArg; i++ ){
      p_Strg = strncpy( p_Strg, vArg[i], 78 );
      n = strlen( vArg[i] );
      for( j=n; j<78; j++ ){
          p_Strg[j] = 32;
      }
      utfarg_( &i, p_Strg );
  }
}

