*CMZ :          22/04/96  15.06.14  by  Hartwig Albrecht
*-- Author :    Andreas Gellrich   02/02/96


      SUBROUTINE UTFARG( IARG, CARG )

************************************************************************
*
* Description: fill character variables with arguments of program
*
* Called from: C function utcarg
*
* External references:
*
* Argument in/out description
*          in     IARG argument number
*          in     CARG character string
*
* Created: 27 Oct 95
* Updated:  5 Feb 96
*
* Author:  Andreas Gellrich
*          HERA-B Collaboration
*          DESY-Zeuthen
*          Platanenallee 6
*          D-15738 Zeuthen
*          Germany
*          phone: (033762) 77-441
*          email: gellrich@ifh.de
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"

* local variables
      INTEGER      J, IARG, CARG(*), JBATCH(-1:1), KBATCH(-1:1)
      DATA JBATCH /4HFARM, 4HINTE, 4HBATC/
      DATA KBATCH /4Hfarm, 4Hinte, 4Hbatc/

#include "arte/Arte.ff"

* fill character variables for steering in common (used in UTINIT)
      IF( IARG .EQ. 1 )  THEN
        PROGNAME = ' '
        CALL CHHTOC (CARG, PROGNAME)
      END IF
      IF( IARG .EQ. 2 ) THEN
        DO J = -1, 1
          IF (CARG(1) .EQ. JBATCH(J)) IBATCH = J
          IF (CARG(1) .EQ. KBATCH(J)) IBATCH = J
        END DO
      END IF

      END

************************************************************************
* End of UTFARG
************************************************************************
