#include "database/Lists.h"
#include "database/DbLists.h"
#include "database/DbStop.h"

int dbstop_(void) {

  /*************************************************************************
   *
   * Author: HERA-B Bologna.
   *
   * Description: Close files before exit.
   *
   * Called from: ATSTOP
   *
   * External references: DbClose
   *
   ************************************************************************/

  ListIterator i;
  List(DbFiles) *F;

  for(i = ListReset( DbFiles ) ; ListMore( i ) ; ListNext( i ) ) {
    F = ListCurrent( i );
    DbClose( F->Csym );
  }
  return 1;

}
