#ifndef _GEDE_H_
#define _GEDE_H_
typedef struct {
   int CMP;
   int LAY;
   int SEC;
   int SHP;
   float XMIN;
   float XMAX;
   float YMIN;
   float YMAX;
   float ZMIN;
   float ZMAX;
   float SXMN;
   float SXMX;
   float SYMN;
   float SYMX;
   float COS;
   float SIN;
   float ROT[9];
   float ACC;
   float EFF;
   float DOD;
   float PIT;
   float MS;
   float XFW[4];
   float ZFW[4];
   int NWI[4];
   int NSL;
   int oGESL;
   int oGMAT;
   int NWL;
   int FWL;
   float XMAD;
   float YMAD;
   float ZMAD;
   float Y1W[4];
   float Y2W[4];
   char GVOL[4];
} gede;
#define  JGEDE (gcbank_.iq+artelink_.jgede)
#define  NGEDE() N_U(JGEDE)
#define NCGEDE() N_C(JGEDE)
#define GEDE(i) (*((gede*)(JGEDE+2)+(i)-1))
#define GEDE_oGESL(i) GEDE(i).oGESL
#define GEDE_oGMAT(i) GEDE(i).oGMAT
#endif
