#ifndef _HITC_H_
#define _HITC_H_
typedef struct {
   float X;
   float Y;
   float Q;
   float R;
   int GCAL;
   int pRTRA;
   int pMCAL;
   int pRCCL;
} hitc;
#define  JHITC (gcbank_.iq+artelink_.jhitc)
#define  NHITC() N_U(JHITC)
#define NCHITC() N_C(JHITC)
#define HITC(i) (*((hitc*)(JHITC+2)+(i)-1))
#include "auto/RTHC.h"
#define HITC_pRTRA(i) HITC(i).pRTRA
#define HITC_mRTRA(i) M_1(i,JRTHC)
#define HITC_xRTRA(i) X_1(i,JRTHC)
#include "auto/MCHC.h"
#define HITC_pMCAL(i) HITC(i).pMCAL
#define HITC_mMCAL(i) M_1(i,JMCHC)
#define HITC_xMCAL(i) X_1(i,JMCHC)
#include "auto/HCRC.h"
#define HITC_pRCCL(i) HITC(i).pRCCL
#define HITC_mRCCL(i) M_2(i,JHCRC)
#define HITC_xRCCL(i) X_2(i,JHCRC)
#endif
