#ifndef _HITC_HH_
#define _HITC_HH_
struct HITC_RTRA;
struct HITC_MCAL;
struct HITC_RCCL;
struct HITC {
   float x;
   float y;
   float q;
   float r;
   int gcal;
   ArteRelationPointer<HITC_RTRA> rtra;
   ArteRelationPointer<HITC_MCAL> mcal;
   ArteRelationPointer<HITC_RCCL> rccl;
};
#include "auto/RTRX.hh"
#include "auto/RTHC.hh"
#include "auto/MCAX.hh"
#include "auto/MCHC.hh"
#include "auto/RCLX.hh"
#include "auto/HCRC.hh"
#include "auto/HITC.icc"
#endif
