#ifndef _MTRX_HH_
#define _MTRX_HH_
struct MTRX_ETRA;
struct MTRX_EVER;
struct MTRX_MIMP;
struct MTRX_MCAL;
struct MTRX_RTRA;
struct MTRX_RSEG;
struct MTRX_RCCL;
struct MTRX {
   float mass;
   float leng;
   ArtePointer<MVEX> bver;
   ArtePointer<MTRX> btra;
   ArteRelationPointer<MTRX_ETRA> etra;
   ArteRelationPointer<MTRX_EVER> ever;
   ArteRelationPointer<MTRX_MIMP> mimp;
   ArteRelationPointer<MTRX_MCAL> mcal;
   ArteRelationPointer<MTRX_RTRA> rtra;
   ArteRelationPointer<MTRX_RSEG> rseg;
   ArteRelationPointer<MTRX_RCCL> rccl;
   ArtePointer<MTCP> mtcp;
};
#include "auto/MVEX.hh"
#include "auto/MVMT.hh"
#include "auto/MTMT.hh"
#include "auto/MTMT.hh"
#include "auto/MVER.hh"
#include "auto/MTMV.hh"
#include "auto/MIMP.hh"
#include "auto/MTMI.hh"
#include "auto/MCAL.hh"
#include "auto/MTMC.hh"
#include "auto/RTRX.hh"
#include "auto/RTMT.hh"
#include "auto/RSEG.hh"
#include "auto/RSMT.hh"
#include "auto/RCLX.hh"
#include "auto/MTRC.hh"
#include "auto/MTCP.hh"
#include "auto/MTMP.hh"
#include "auto/MTRX.icc"
#endif
