#ifndef _RSEG_H_
#define _RSEG_H_
typedef struct {
   float ZF;
   float XF;
   float YF;
   float TXF;
   float TYF;
   float PF;
   float CVF[15];
   float TIME;
   float DTIM;
   float ZE;
   float XE;
   float YE;
   float TXE;
   float TYE;
   float PE;
   float CVE[15];
   float CHI;
   int FIT;
   int CMP;
   int pHITB;
   int pRTRA;
   int pRPNT;
   int pMTRA;
   int pRHIT;
   int pRCCL;
   int pRBEG;
   int pREND;
} rseg;
#define  JRSEG (gcbank_.iq+artelink_.jrseg)
#define  NRSEG() N_U(JRSEG)
#define NCRSEG() N_C(JRSEG)
#define RSEG(i) (*((rseg*)(JRSEG+2)+(i)-1))
#include "auto/RSHI.h"
#define RSEG_pHITB(i) RSEG(i).pHITB
#define RSEG_mHITB(i) M_2(i,JRSHI)
#define RSEG_xHITB(i) X_2(i,JRSHI)
#include "auto/RTRS.h"
#define RSEG_pRTRA(i) RSEG(i).pRTRA
#define RSEG_mRTRA(i) M_1(i,JRTRS)
#define RSEG_xRTRA(i) X_1(i,JRTRS)
#include "auto/RSRP.h"
#define RSEG_pRPNT(i) RSEG(i).pRPNT
#define RSEG_mRPNT(i) M_R(i,JRSRP)
#define RSEG_xRPNT(i) X_R(i,JRSRP)
#include "auto/RSMT.h"
#define RSEG_pMTRA(i) RSEG(i).pMTRA
#define RSEG_mMTRA(i) M_2(i,JRSMT)
#define RSEG_xMTRA(i) X_2(i,JRSMT)
#include "auto/RSRH.h"
#define RSEG_pRHIT(i) RSEG(i).pRHIT
#define RSEG_mRHIT(i) M_R(i,JRSRH)
#define RSEG_xRHIT(i) X_R(i,JRSRH)
#include "auto/RSRC.h"
#define RSEG_pRCCL(i) RSEG(i).pRCCL
#define RSEG_mRCCL(i) M_2(i,JRSRC)
#define RSEG_xRCCL(i) X_2(i,JRSRC)
#include "auto/RSRS.h"
#define RSEG_pRBEG(i) RSEG(i).pRBEG
#define RSEG_mRBEG(i) M_1(i,JRSRS)
#define RSEG_xRBEG(i) X_1(i,JRSRS)
#include "auto/RSRS.h"
#define RSEG_pREND(i) RSEG(i).pREND
#define RSEG_mREND(i) M_2(i,JRSRS)
#define RSEG_xREND(i) X_2(i,JRSRS)
#endif
