#ifndef _RTRA_HH_
#define _RTRA_HH_
struct RTRA {
   float zf;
   float xf;
   float yf;
   float txf;
   float tyf;
   float pf;
   float cvf[15];
   int hsi;
   int hin;
   int hou;
   int hri;
   int hca;
   int htr;
   int hmu;
   int fit;
   float chi;
   float e;
   float mu;
   float pi;
   float k;
   float p;
   ArtePointer<TOPX> topp;
};
#include "auto/TOPX.hh"
#include "auto/RTTO.hh"
#include "auto/RTRA.icc"
#endif
