*CMZ :  2.00/02 07/03/96  18.33.14  by  Siegmund Nowak
*CMZ :  2.00/01 05/02/96  18.13.17  by  Siegmund Nowak
*CMZ :  2.00/00 07/12/95  10.08.28  by  HBSTAFF
*CMZ :  1.03/07 28/03/95  18.35.23  by  Siegmund Nowak
*-- Author :    Siegmund Nowak   23/11/94
************************************************************************
*
* DGSELE
* written by Siegmund Nowak, 23/11/94 18.07.24
*
* This routines selects the wanted set of sensitive detectors
*
*     called from RCINIT
*
************************************************************************

      SUBROUTINE DGSELE

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/ZGESL.fi"
#include "arte/ZUTSEL.fi"

      INTEGER ISELEC, I, NSIDE, NMAGN, NPATT, NFLTR
      PARAMETER (NSIDE=7, NMAGN=17, NPATT=8, NFLTR=17)
      CHARACTER*4 LSELEC(4),SIDNAM(NSIDE),MAGNAM(NMAGN),PATNAM(NPATT),
     +            FLTNAM(NFLTR),NAME, KSELEC(80)
      DATA LSELEC /'SIDE','MAGN','PATT','FLTR'/
      DATA SIDNAM /'SI01','SI02','SI03','SI04','SI05','SI06','SI07'/
      DATA MAGNAM /'SI08','SI09','SI10','MS01','MS03','MS05','MS07',
     +             'MS09','MT01','MT02','MT03','MT04','MT05','WT06',
     +             'WT07','WT08','WT09'                            /
      DATA PATNAM /'MS10','MS11','MS12','MS13','PC01','PC02','PC03',
     +             'PC04'                                          /
      DATA FLTNAM /'PC01','PC04','TC01','TC02','MS10','MS13','MS14',
     +             'MS15','CALW','MUD1','MUD2','MUD3','MUD4','MXD1',
     +             'MXD2','MXD3','MXD4'                            /
#include "arte/Arte.ff"

      IF(GEANINIT.NE.0) GO TO 99
      ISELEC = 0
      DO I=1,NGSEL
      CALL UHTOC(HGSEL(I),4,NAME,4)
      IF(NAME.EQ.' ') GO TO 10
      IF(NAME.EQ.'SIDE') THEN
         CALL UCOPY(SIDNAM,KSELEC(ISELEC+1),NSIDE)
         ISELEC = ISELEC + NSIDE
      ELSE IF(NAME.EQ.'MAGN') THEN
         CALL UCOPY(MAGNAM,KSELEC(ISELEC+1),NMAGN)
         ISELEC = ISELEC + NMAGN
      ELSE IF(NAME.EQ.'PATT') THEN
         CALL UCOPY(PATNAM,KSELEC(ISELEC+1),NPATT)
         ISELEC = ISELEC + NPATT
      ELSE IF(NAME.EQ.'FLTR') THEN
         CALL UCOPY(FLTNAM,KSELEC(ISELEC+1),NFLTR)
         ISELEC = ISELEC + NFLTR
      ELSE
         ISELEC = ISELEC + 1
         KSELEC(ISELEC) = NAME
      ENDIF
      ENDDO

 10   NGSEL= ISELEC
      IF(NGSEL.GT.0) THEN
         C78 = 'The following detectors are selected: '
         CALL ME78WA
         C78 = ' '
         DO I=1,NGSEL
          CALL UCTOH(KSELEC(I),HGSEL(I),4,4)
          CALL CH78BC(KSELEC(I))
         ENDDO
         CALL ME78WA
      ENDIF
      DO I=ISELEC+1,NSELMX
      CALL UCTOH('    ',HGSEL(I),4,4)
      ENDDO
 99   RETURN
      END

