#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "gean/hgdat.h"
#include "arte/Arte.hh"
#include "gean/ZGMAG.hh"
#include "gean/ZGMOTH.hh"

// ------------------------------------------------------------------------
static int fpp=0;
  FILE *MAG_inp, *utfilp(char*,char*);  
  fpos_t fmagpos;
// ------------------------------------------------------------------------  

extern "C" {
  void meerro_(char*);
  int magdat_(char *name);
  extern CommonZGMOTH zgmoth_; 
  extern ZGMAG magbuf_;   }
  ZGMAG magbuf_;
// ------------------------------------------------------------------------  
  void magdaterror(char *tag) {
  fprintf(stderr,"magdat: Error in format scanning %s\n",tag);
  exit(1);
  }
// ------------------------------------------------------------------------  

int magdat_(char* name) {
  int nitem, i, tagid;
  static volid=0;
  char  buffer[256], C78[78], tag[80], taga[16], tagb[16], tagc[16];    
  char *card, *stop, *ptr ;
  ZGMAG& mag=magbuf_;
  CommonZGMOTH& mut=zgmoth_;

  if(!fpp){
  MAG_inp = utfilp(name,"\n"); 
  if(!MAG_inp) {
     strcpy(C78,"Can not open ");
     int len=strlen(name);
     int i;
     for (i=len;i<64;i++) name[i]=' ';
        name[64]='\0';
        strncat(C78,name,len);
        meerro_(C78);      }
     fpp=1;
  }

  for(;;) {
     int i=0;
     fgetpos(MAG_inp, &fmagpos);
     if(fgets(buffer,256,MAG_inp) == NULL) {
       tagid = 0;
        if(feof(MAG_inp)) {
           if(volid!=0) {
           }
          fclose(MAG_inp);
           tagid = -1; 
           fprintf(stdout," === CLOSE FILE  %s\n",name);  }
        return tagid; }
     card=&buffer[0];
     nitem=sscanf(card,"%s",tag);
     if (nitem==-1) continue;   
     card+=itemlength(card,nitem);
     ToLower(tag);
    
     if (!strncmp(tag,"vol",3)) { 
      if(volid!=0) {
        fsetpos(MAG_inp, &fmagpos);
        tagid = 1;
        volid = 0;
        return tagid;}
      volid = 1;  
      nitem=sscanf(card,"%s %s",taga,tagb);
      if (nitem!=2) magdaterror(tag);
      ptr =strstr(tagb,"*");
      fillstr(taga,12);
      fillstr(tagb,4);
      strncpy(mag.name,taga,12);
      strncpy(mag.object,tagb,4);            
      if(ptr == NULL) {
         mag.type = mag.seen = mag.color = 1;    // default values    
         mag.npar = mag.rotation = 0; 
         mag.dx =mag.dy = mag.dz = mag.du = mag.dv;
         strncpy(mag.material,"            ",12);
         strncpy(mag.shape,"    ",4);         
         strncpy(mag.mother,"    ",4);
         strncpy(mag.only,"ONLY",4); }   }

    else if(!strncmp(tag,"shap",4)) {
      nitem=sscanf(card,"%s ",taga);
      if(nitem!=1) magdaterror(taga);
      fillstr(taga,4);            
      strncpy(mag.shape,taga,4);
      if(!strncmp(taga,"BOX" ,3) || !strncmp(taga,"TUBE",4)) mag.npar =3; 
      if(!strncmp(taga,"TRD1",4)) mag.npar =4; 
      if(!strncmp(taga,"TUBS",5)) mag.npar =5; }
 
    else if (!strncmp(tag,"moth",4)) {
      nitem=sscanf(card,"%s",taga);
      if (nitem!=1) magdaterror(tag);
      fillstr(taga,4);       
      strncpy(mag.mother,taga,4);   }   

    else if (!strncmp(tag,"dim",3)) {
      if(mag.npar == 3) {
        nitem=sscanf(card,"%f %f %f",&mag.dx,&mag.dy,&mag.dz); 
        if (nitem!=3) magdaterror(tag); } 
      if(mag.npar == 4) {
        nitem=sscanf(card,"%f %f %f %f",&mag.dx,&mag.dy,&mag.dz,&mag.du); 
        if (nitem!=4) magdaterror(tag); } 
      if(mag.npar == 5) {
        nitem=sscanf(card,"%f %f %f %f %f ",&mag.dx,&mag.dy,&mag.dz,&mag.du,
                                            &mag.dv); 
        if (nitem!=5) magdaterror(tag); } }

    else if (!strncmp(tag,"typ",3)) {
      nitem=sscanf(card,"%d",&mag.type);
      if (nitem!=1) magdaterror(tag);      }

    else if (!strncmp(tag,"mat",3)) {
      nitem=sscanf(card,"%s",taga);
      if (nitem!=1) magdaterror(tag);
      fillstr(taga,12);       
      strncpy(mag.material,taga,12);   }   

    else if (!strncmp(tag,"only",4)) {
      nitem=sscanf(card,"%s",taga);
      if (nitem!=1) magdaterror(tag);
      fillstr(taga,4);       
      strncpy(mag.only,taga,4);   }   

    else if(!strncmp(tag,"posit",4)) {
      nitem=sscanf(card,"%f %f %f ",&mag.xpos,&mag.ypos,&mag.zpos);
      if(nitem!=3) magdaterror(tag);
      ptr =strstr(tag,"*");
      if(ptr != NULL) mag.zpos -= mut.ZMAGM; }
 
    else if (!strncmp(tag,"rel_p",5)) {
      nitem=sscanf(card,"%s %s %s",taga,tagb,tagc); 
        if (nitem!=3) magdaterror(tag); 
        mag.xpos = mag.xpos + strtod(taga,&stop);
        mag.ypos = mag.ypos + strtod(tagb,&stop);
        mag.zpos = mag.zpos + strtod(tagc,&stop);  }

    else if (!strncmp(tag,"rot",3)) {
      nitem=sscanf(card,"%d",&mag.rotation); 
      if (nitem!=1) magdaterror(tag);    }

    else if (!strncmp(tag,"sens_fl",7)) {
      nitem=sscanf(card,"%d",&mag.sens_flag);
      if (nitem!=1) magdaterror(tag);} 

    else if (!strncmp(tag,"col",3)) {
      nitem=sscanf(card,"%d",&mag.color);
      if (nitem!=1) magdaterror(tag);      
      if(mag.color!=0) mag.seen=1;  }

     else  {
      if(strncmp(tag,"*",1) && strncmp(tag,"#",1))
        printf("tag not found:   %s\n",tag);}
    }
}
