
      SUBROUTINE SILDAT(CNAME)

************************************************************************
* written by Siegmund Nowak, 16/03/95 09.18.12
*
* Description: Reads ASCII geometry file and stores the data 
*
* called from  SILGEO
*
* External references: IO..., FF..., ...KEY,
************************************************************************

      IMPLICIT NONE
      INTEGER LENOCC
      CHARACTER*(*) CNAME

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/ZGSILD.fi"
#include "arte/Arte.ff"

C---             Initialize geo dat input

      CALL GEOPEN(CNAME(1:LENOCC(CNAME)))
      CALL FFINIT(0)

C     set keys for reading SIL data cards by ffread

      CALL FFKEY('DESI' ,DESI  ,NSLSI,'MIXED')
      CALL FFKEY('ZASI' ,ZASI  ,NSLSI,'REAL')
      CALL FFKEY('DLSI' ,DLSI  ,NSLSI,'REAL')
      CALL FFKEY('OVSI' ,OVSI  ,NSLSI,'REAL')
      CALL FFKEY('TYSI' ,ITPSI ,NSLSI,'INTE')
      CALL FFKEY('XRSI' ,XRSI  ,NSLSI,'REAL')           	
      CALL FFKEY('XOSI' ,XOSI  ,NSLSI,'REAL')           	
      CALL FFKEY('XBAG' ,XBAG  ,NSLSI,'REAL')           	
      CALL FFKEY('NPSI' ,NPLSI ,NSLSI,'INTE')
      CALL FFKEY('IRSI' ,IROSI ,NSLSI,'INTE')
      CALL FFKEY('DBSI' ,DXBGSI,    3,'REAL')
      CALL FFKEY('DSSI' ,DXSISI,    3,'REAL')
      CALL FFKEY('DASI' ,DXA1SI,    6,'REAL')
      CALL FFKEY('DHSI' ,DXHYSI,    3,'REAL')
      CALL FFKEY('DCSI' ,DXC1SI,    6,'REAL')
      CALL FFKEY('XBSI' ,PXBGSI,NSLSI,'REAL')
      CALL FFKEY('YBSI' ,PYBGSI,NSLSI,'REAL')
      CALL FFKEY('ZBSI' ,PZBGSI,NSLSI,'REAL')
      CALL FFKEY('YSSI' ,PYSISI,NSLSI,'REAL')
      CALL FFKEY('YASI' ,PYA1SI,NSLSI,'REAL')
      CALL FFKEY('YDSI' ,PYA2SI,NSLSI,'REAL')
      CALL FFKEY('XHSI' ,PXH1SI,NSLSI,'REAL')
      CALL FFKEY('YHSI' ,PYH1SI,NSLSI,'REAL')
      CALL FFKEY('XISI' ,PXH2SI,NSLSI,'REAL')
      CALL FFKEY('YISI' ,PYH2SI,NSLSI,'REAL')
      CALL FFKEY('YCSI' ,PYC1SI,NSLSI,'REAL')
      CALL FFKEY('YESI' ,PYC2SI,NSLSI,'REAL')
      CALL FFKEY('ZCSI' ,PZC1SI,NSLSI,'REAL')
      CALL FFKEY('ZLSI' ,PZLYSI,NSLSI,'REAL')
      CALL FFKEY('RASI' ,RANDSI,    1,'REAL')
      CALL FFKEY('ANSI' ,ANGSI ,    1,'REAL')
      CALL FFKEY('EFSI' ,EFFSI ,    1,'REAL')
      CALL FFKEY('ACSI' ,SIGSI ,    1,'REAL')
      CALL FFKEY('PISI' ,PITSI ,    1,'REAL')
      CALL FFKEY('DMSI' ,DMSI  ,    1,'REAL')

C     Read in of data cards
      CALL FFSET('LINP',LREAD)
      CALL FFSET('LOUT',LLOGF)
      CALL FFGO
      CALL IOCLOS(LREAD)


 999  RETURN
      END

************************   END    SILDAT    *****************************




