*CMZ :  2.01/02 26/01/96  12.58.20  by  Hartwig Albrecht
*CMZ :  2.01/01 18/10/95  14.02.40  by  HERA-B
*-- Author :    Hartwig Albrecht   19/05/95

      SUBROUTINE KADINI

************************************************************************
*
* Description: DINIT command
*
* Called from: KUIP
*
* External references:
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      IF (IBATCH .NE. 0)  CALL MEERRC (87964,
     +  'DINIT: a data definition job must run in interactive mode')
      IF (LUNDINIT + GEANINIT + RECOINIT + PRISINIT .NE. 0)
     +  CALL MEERRC (1346, 'DINIT: job is flagged for another task')
      IF (DATDINIT .EQ. 0)  THEN
        CALL MEWARC (132476,
     +    'DINIT: job is flagged for the data definition task.')
        CALL MEALLP
     +  ('Start DD with command RUN when all DD commands are read in')
      END IF
      DATDINIT = 1

      IF (JDDEF .EQ. 0)  GO TO 10
      IF (NDDEF() .EQ. 0)  GO TO 10
      IF (IDDEF_FLAG(N_U(JDDEF)-1) .EQ. LDDEF_INI)  GO TO 90

 10   CALL KADZZI (LDDEF_INI)

 90   END

************************************************************************
* End of KADINI
************************************************************************
