*CMZ :  2.01/01 15/07/95  11.47.38  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   19/05/95

      SUBROUTINE KADTA1 (IFLAG)

************************************************************************
*
* Description: DTABLE, DRELAT, DMENU command
*
* Called from: KADTAB, KADREL, KADMEN
*
* External references: KADINI
*
* Arguments: in/out description
*   IFLAG    in     1: KADTAB; 2: KADREL; 3: KADMEN
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER L, IFLAG

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      CALL KADZZI (IFLAG)

      CALL KADZZN

      IF (IFLAG .EQ. LDDEF_TAB)  CALL KUGETI (IQ(IQDDEF_DIM_L()))

      IF (IFLAG .LE. LDDEF_REL)  THEN
        C78 = ' '
        CALL KUGETC (C78, L)
        IF (C78(1:1) .EQ. 'C')  THEN
          IQ(L_L(JDDEF_DIV,JDDEF)) = 1
        ELSE IF (C78(1:1) .EQ. 'E')  THEN
          IQ(L_L(JDDEF_DIV,JDDEF)) = 2
        ELSE
        CALL LIDDE0 (NDDEF(), 'TL')
          CALL MEERRC (836541, 'DD: Zebra division must be C or E')
        END IF
      END IF

      CALL KADZZC

      C78 = ' '
      CALL KUGETC (C78, L)
      CALL CH78TH (IQ(L_L(JDDEF_NAM2,JDDEF)), 1)
      IF (L .GT. 4)  THEN
        CALL LIDDE0 (NDDEF(), 'TL')
        CALL MEERRC (675765,
     +  'DD: menu names must consist of at most 4 characters')
      END IF

      END

************************************************************************
* End of KADTA1
************************************************************************
