*CMZ :  2.01/02 26/01/96  12.58.39  by  Hartwig Albrecht
*CMZ :  2.01/01 18/10/95  11.55.30  by  HERA-B
*-- Author :    Hartwig Albrecht   19/05/95

      SUBROUTINE KADZZI (IFLAG)

************************************************************************
*
* Description: init next row for DD commands
*
* Called from: KAD* routines
*
* External references:
*
* Arguments: in/out description
*   IFLAG    in     flag for JDDEF_FLAG
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/DDEF.fi"

      INTEGER IFLAG

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      IF (DATDINIT .EQ. 0)  THEN
        CALL MEERRC (83764,
     +   'DD: data description not initialized by DDEFINIT')
        CALL KADINI
      END IF

      CALL MMBOOK (JDDEF, 1)

      IQ(L_L(JDDEF_FLAG,JDDEF)) = IFLAG
      IQ(L_L(JDDEF_NAME,JDDEF)) = HBLANKSP
      IQ(L_L(JDDEF_NAM2,JDDEF)) = HBLANKSP
      IQ(L_L(JDDEF_NAM3,JDDEF)) = HBLANKSP
      CALL CHCTOH (' ', IQ(L_L(JDDEF_TEXT,JDDEF)), NDDEF_TEXT)

      END

************************************************************************
* End of KADZZI
************************************************************************
