*CMZ :  2.01/01 22/11/95  10.49.59  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   05/03/95

      SUBROUTINE KAGLUN (LUN)

************************************************************************
*
* Description: Get unit number from KUIP
*
* Called from: anywhere
*
* External references: UTKUGC, IOUNIT
*
* Argument in/out description
*   LUN    out    output unit
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZIOCOM.fi"

      INTEGER L, LUN
      CHARACTER*(NIOSMX) CSYM

#include "arte/Arte.ff"

      CALL UTKUGC (0, LUN, CSYM, L)
      IF (L .NE. 0)  THEN
        CALL IOUNIT (CSYM, LUN)
        IF (LUN .EQ. 0)  CALL MEERRC (27,
     +   'IO: symbolic name is invalid: ' // CSYM)
      ELSE
        IF (LUN .LE. 0 .OR. LUN .GE. 100)  THEN
          CALL MEERRC (28,
     +     'IO: logical unit number is not in the range 1 ... 99')
          LUN = 0
        END IF
      END IF

      END

************************************************************************
* End of KAGLUN
************************************************************************
