*CMZ :          02/07/96  13.18.24  by  Hartwig Albrecht
*CMZ :  2.01/02 28/01/96  17.07.30  by  Hartwig Albrecht
*CMZ :  2.01/01 12/09/95  20.18.20  by  HERA-B
*-- Author :    Hartwig Albrecht   19/05/95

      SUBROUTINE LIDDE1 (LUN, IR)

************************************************************************
*
* Description: list entry in the data description table
*
* Called from: KUIP etc.
*
* External references:
*
* Argument in/out description
*   LUN    in     logical unit number for output
*                 (not necessarily a printer)
*   IR     in     row number
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER LUN, IR, LENOCC
      CHARACTER COMMAND(15)*7, CDIV(2)*1
      DATA COMMAND /'Ddefini','Dtable ','Drelat ','Dmenu  ','Dnamseq',
     +    'Dattrib','Dalias ','Drelone','Drelman','Dinvone','Dinvman',
     +    'Dfile  ','Dtext  ','Dsub_of','Dpar_to'/
      DATA CDIV /'C','E'/

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

C command

      IF (IDDEF_FLAG(IR) .LE. LDDEF_SKP)  GO TO 900
      C78 = COMMAND(IDDEF_FLAG(IR)+1)
      IF (IDDEF_FLAG(IR) .EQ. LDDEF_INI)  GO TO 200

C comment

      C78(27:27) = ''''
      CALL CHHTOC (IQ(HQDDEF_TEXT(1,IR)), C78(28:75))
      CALL CH78AC ('''')
      IF (C78(27:75) .EQ. '''''')  C78(27:28) = ' '

      IF (IDDEF_FLAG(IR) .EQ. LDDEF_FIL)  GO TO 200
      IF (IDDEF_FLAG(IR) .EQ. LDDEF_TEX)  GO TO 200

C name

      CALL CHHTOC (IQ(HQDDEF_NAME(IR)), C78(9:12))

      IF (IDDEF_FLAG(IR) .EQ. LDDEF_NAM)  GO TO 200
      IF (IDDEF_FLAG(IR) .EQ. LDDEF_ATT)  GO TO 50
      IF (IDDEF_FLAG(IR) .EQ. LDDEF_TAB)  GO TO 20
      IF (IDDEF_FLAG(IR) .LE. LDDEF_REM)  GO TO 30
      IF (IDDEF_FLAG(IR) .LE. LDDEF_INM)  GO TO 40
      GO TO 200

C extension

 20   WRITE (C78(14:17), '(I4)') IDDEF_DIM(IR)

C division

 30   IF (IDDEF_FLAG(IR) .NE. LDDEF_MEN)
     +  C78(19:19) = CDIV(IDDEF_DIV(IR))

C menu name

      IF (HDDEF_NAM2(IR) .NE. HBLANKSP)  THEN
        C78(21:21) = '-'
        CALL CHHTOC (IQ(HQDDEF_NAM2(IR)), C78(22:25))
      END IF
      IF (IDDEF_FLAG(IR) .LE. LDDEF_MEN)  GO TO 200

C relation name

 40   CALL CHHTOC (IQ(HQDDEF_NAM3(IR)), C78(14:17))
      GO TO 200

C attribute

 50   CALL CHHTOC (IQ(HQDDEF_NAM2(IR)), C78(14:14))
      WRITE (C78(16:19), '(I4)')  IDDEF_DIM(IR)

 200  WRITE (LUN, '(1X,A)') C78(1:LENOCC(C78))

 900  END

************************************************************************
* End of LIDDE1
************************************************************************
