*CMZ :  2.01/01 23/10/95  19.04.26  by  HERA-B
*-- Author :    Hartwig Albrecht   13/09/95

      SUBROUTINE LILUPA (KC, CTPL)

************************************************************************
*
* Description: Write Lund decay table.
*
* Called from: ?
*
* External references:
*
* Argument in/out description
*   KC     in     particle number (Lund: "compressed" code)
*   CTPL   in     terminal/printer/log_file
*
************************************************************************

      IMPLICIT NONE

#include "jets/LUDAT2.fi"
#include "jets/LUDAT3.fi"
#include "jets/LUDAT4.fi"
#include "jets/LUCODE.fi"
#include "arte/ArteIOlun.fi"

      INTEGER L, KC, K, K1, K2, J
      CHARACTER CTPL*(*)

      IF (KC .EQ. 0)  THEN
        K1 = 1
        K2 = 500
      ELSE
        K1 = KC
        K2 = KC
      END IF

      CALL UTPOPT (CTPL)

      DO 20 K = K1, K2
        IF (CHAF(K) .EQ. ' ')  GO TO 20
        DO 10 L = 1, 3
          IF (LIOTPL(L) .NE. 0)  WRITE (LIOTPL(L), 5000)
     +      K, CHAF(K), (KCHG(K,J),J=1,3), (PMAS(K,J),J=1,4),
     +      MDCY(K,1), LCOD(K)
 10     CONTINUE
 20   CONTINUE

 5000 FORMAT(1X,I4,1X,A8,3I3,4(1X,G11.5),I3,I6)

      END

************************************************************************
* End of LILUPA
************************************************************************
