*CMZ :  2.01/01 30/11/95  14.29.20  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   30/11/95

      SUBROUTINE LIMIM1 (IMI, CTPL)

************************************************************************
*
* Description: List one MIMP
*
* Called from: LIMIMP etc.
*
* External references: none
*
* Argument in/out description
*   IMI    in     row number in MIMP
*   CTPL   in     printer destination
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MIMP.fi"
#include "auto/GEDE.fi"
#include "auto/GESL.fi"

      INTEGER IMI
      CHARACTER*(*) CTPL

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/GEDE.ff"
#include "auto/GESL.ff"

      IF (IMI .LE. 0 .OR. IMI .GT. NMIMP())  THEN
        C78 = 'LIMIMP: invalid mimp number'

      ELSE

        C78 = ' '
        WRITE (C78, 1001) IMI, FMIMP_X(IMI), FMIMP_Y(IMI), FMIMP_Z(IMI),
     +    FMIMP_TX(IMI), FMIMP_TY(IMI), FMIMP_P(IMI), OMIMP_MTRA(IMI),
     +    IMIMP_GEDE(IMI), OGEDE_GESL(IMIMP_GEDE(IMI)),
     +    HGESL_NAME(OGEDE_GESL(IMIMP_GEDE(IMI)))
      END IF

      CALL ME78SP (CTPL)

 1001 FORMAT (I5,2F8.3,F9.3,2F7.3,F9.3,2I5,I3,A5)

      END

************************************************************************
* End of LIMIM1
************************************************************************
