*-- Author :    Rainer Mankel   11/12/95


      subroutine prgwal()

*     **** print plane information
      implicit none
      integer id1, id2, nch, pl1, pl2, iwl
      character*80 chopts
#include "arte/Arte.fi"

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"

*     **** parameters
      call kugeti(id1)
      call kugeti(id2)
      call kugetc(chopts,nch)

*     **** fixup
      if (jgwal.le.0) then
         call mewarn('prgwal: table GWAL is not booked')
         go to 999
      endif

      if (id2.eq.0.and.id1.ne.0) id2 = id1
      id1 = max(id1,1)
      if (id2.eq.0) then
       id2 = iq(jgwal+2)
      else
       id2 = min(id2,iq(jgwal+2))
      endif

*     **** print headline
      print 102,'iwl',
     +          'shp','xmi','xma','ymi','yma','zmi',
     +          'ms','rot1','rot2',
     +          'rot4','rot5'
 101  format(i3,i4,3f8.2,2f5.2,e12.4,4f6.3)
 102  format(a3,a4,3a8  ,2a5,  a12,  4a6  )

*     **** loop over plane range
      pl1 = max(id1,1)
      pl2 = min(id2,iq(jgwal+2))
      do 10 iwl=pl1,pl2
       print 101,iwl,
     +           igwal_shp(iwl),  fgwal_xmin(iwl), fgwal_xmax(iwl),
     +           fgwal_ymin(iwl), fgwal_ymax(iwl), fgwal_zmin(iwl),
     +           fgwal_ms(iwl),
     +           fgwal_rot(1,iwl), fgwal_rot(2,iwl),
     +           fgwal_rot(4,iwl), fgwal_rot(5,iwl)
 10   continue
 999  end


