*CMZ :  4.05/00 14/04/96  14.30.38  by  Rainer Mankel
*-- Author :    Rainer Mankel   11/04/96

      subroutine prmcal()

*     **** print hit information
      implicit none
      integer id1, id2, jauxhc, ialia, hitc, mcal, line, gcal

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/MCAL.fi"
#include "auto/MCAX.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MCAL.ff"
#include "auto/MCAX.ff"

*     **** parameters
      call kugeti(id1)
      call kugeti(id2)
      call kugeti(gcal)

*     **** fixup
      if (jmcal.le.0) then
         call mewarn('prmcal: table MCAL is not booked')
         go to 999
      endif

      if (id1.eq.0) then
         id1 = 1
         if (id2.eq.0) id2 = nmcal()
      else
         if (id2.eq.0) id2 = id1
      endif

*     **** loop over range
      id1 = max(id1,1)
      id2 = min(id2,nmcal())

      line = 0                  ! printed row counter

      do 10 mcal=id1,id2
         if (gcal.ne.0) then
            if ((imcal_gcal(mcal)/100).ne.gcal) go to 10
         endif
*        **** loop over associated HITCs
         do 20 ialia=1,99
            if (ialia.eq.1) then
               jauxhc = pmcax_hitc(mcal)
            else
               jauxhc = xmcax_hitc(jauxhc)
            endif
            if (jauxhc.gt.0) then
               hitc = mmcax_hitc(jauxhc)
            else
               if (ialia.gt.1) go to 21
               hitc = 0
            endif
            if (ialia.eq.1) then
               if (mod(line,20).eq.0) then
*                 **** print headline
                  print '(a6,a10,a8,a6,a6)',
     +                 'mcal','de','gcal','mtra','hitc'
               endif
               print '(i6,f10.3,i8,i6,i6)',
     +              mcal,fmcal_de(mcal),imcal_gcal(mcal),
     +              omcal_mtra(mcal),hitc
               line = line + 1
            else
               print '(6x,10x,8x,6x,i6)',hitc
            endif
            if (jauxhc.eq.0) go to 21
 20      continue
 21      continue

 10   continue

      print *,' total number of mcal rows:', nmcal()


 999  end
