*
* B.Fominykh  21.08.97
*
* initialization of muon hit table MUHT
      SUBROUTINE MURHTIN(IMU2,IPIX)
C-    =============================
* input:  IMU2 - if =0 don't take hits from MU2
*         IPIX - if =0 don't take pixels
*
      IMPLICIT NONE
      INTEGER NHB,IHB,JHB,NHTB,IH,JH,I,J
      INTEGER IV,ICMP,ISL,IMIN,LL,IMU2,IPIX
      INTEGER JAUX,NI,JIP,MC,NMC,ITYP
      REAL Z,ZMIN,SINR,COSR,XD,YD1,YD2,DXDIM,DYDIM
*
#include "murec/MUCTAB.fi"
#include "murec/MUCZDT.fi"
      INTEGER IIHTB(NMHMXP),IFHTB(NMHMXP)
      REAL    ZHTB(NMHMXP)
*
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/MC.fi"
#include "auto/HITB.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MC.ff"
#include "auto/HITB.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
*
* how many hits in table HITB
      NHB=IQ(JHITB+2)
      IF(NHB.LE.0) THEN
**        WRITE(LPRNT,*) '*** MURHTIN: no hits in table HITB'
        GOTO 200
      ENDIF
* collect muon hits from HITB
      CALL VZERO(NMUDTL,NMRLAY)
      CALL VZERO(JHTPT1,NMRLAY)
      NHTB=0
      DO 10 IHB=1,NHB
        JHB=JHITB+IQ(JHITB+1)*(IHB-1)+2
        IV=IQ(JHB+JHITB_GEDE)
        ICMP=IGEDE_CMP(IV)
        IF(ICMP.NE.8.AND.ICMP.NE.9) GOTO 10
        IF(ICMP.EQ.8) THEN
          IF(Q(JHB+JHITB_Y).EQ.0.) THEN
            ITYP=1
          ELSE
            ITYP=2
          ENDIF
        ELSE
            ITYP=3
        ENDIF
        ISL=OGEDE_GESL(IV)
*
* don't take pixels if IPIX=0
        IF(IPIX.EQ.0.AND.ICMP.EQ.9) GOTO 10
* don't take hits from MU2 if IMU2=0
        IF(IMU2.EQ.0.AND.ITYP.NE.3.AND.
     +         IGESL_NSL(ISL).EQ.2) GOTO 10
*
        Z=Q(JHB+JHITB_Z)
        LL=0
        DO 2 I=1,NMRLAY
          IF(ZMUDT1(I).EQ.0.) GOTO 2
          IF(Z.GT.ZMUDT2(I)) GOTO 2
          IF(Z.LT.ZMUDT1(I)) GOTO 3
          LL=I
          GOTO 3
  2     CONTINUE
  3     CONTINUE
***        WRITE(LLOGF,*) IHB,Z,IV,LL
        IF(LL.LE.0) GOTO 10
        IF(NHTB.GT.NMHMXP) THEN
***          WRITE(LPRNT,*) '*** MURHTIN: Nhits > MAX= ',NMHMXP
          GOTO 10
        ENDIF
        NHTB=NHTB+1
        IIHTB(NHTB)=IHB+LL*100000
        ZHTB(NHTB) = REAL(LL)*10000.+Z
  10  CONTINUE
      IF(NHTB.LE.0) GOTO 200
* order muon hits on LL*10000.+Z
      DO 15 I=1,NHTB
        ZMIN=1000000.
        IMIN=0
        DO 12 J=1,NHTB
          IF(ZHTB(J).GE.ZMIN) GOTO 12
          ZMIN=ZHTB(J)
          IMIN=J
 12     CONTINUE
        IF(IMIN.LE.0) GOTO 15
        IFHTB(I)=IIHTB(IMIN)
        ZHTB(IMIN)=2000000.
 15   CONTINUE
* fill the table MUHT
      DO 50 IH=1,NHTB
        CALL MMBOOK(JTMP9,1)
        JH=JTMP9+IQ(JTMP9+1)*(IH-1)+2
        LL=IFHTB(IH)/100000
        IF(JHTPT1(LL).EQ.0) JHTPT1(LL)=IH
        NMUDTL(LL)=NMUDTL(LL)+1
        IHB=IFHTB(IH)-LL*100000
        JHB=JHITB+IQ(JHITB+1)*(IHB-1)+2
        IQ(JH+1)=IHB                  ! link to HITB
        IQ(JH+2)=LL
        IV=IQ(JHB+JHITB_GEDE)
        ICMP=IGEDE_CMP(IV)
        ISL=OGEDE_GESL(IV)
        IQ(JH+3)=IGESL_NSL(ISL)       ! muon superlayer
        IQ(JH+4)=IGEDE_LAY(IV)        ! layer
        IF(ICMP.EQ.8) THEN
          IF(Q(JHB+JHITB_Y).EQ.0.) THEN
            IQ(JH+5)=1                ! hit type
          ELSE
            IQ(JH+5)=2                ! hit type
          ENDIF
        ENDIF
        IF(ICMP.EQ.9) IQ(JH+5)=3      ! hit type
        Q(JH+6)=Q(JHB+JHITB_Z)        ! z-coordinate
        COSR=FGEDE_ROT(1,IV)
        SINR=FGEDE_ROT(2,IV)
        Q(JH+7)=SINR                  ! SIN_ROT
        XD=Q(JHB+JHITB_X)
        Q(JH+8)=XD                    ! d or x-coordinate
* the case of wire
        IF(IQ(JH+5).EQ.1) THEN
          YD1=FGEDE_YMIN(IV)
          YD2=FGEDE_YMAX(IV)
          Q(JH+9) =YD1
          Q(JH+10)=YD2
          DXDIM=FGEDE_PIT(IV)
          DYDIM=0.
        ENDIF
* the case of pads, pixels
        IF(IQ(JH+5).EQ.2.OR.IQ(JH+5).EQ.3) THEN
          Q(JH+9) =Q(JHB+JHITB_Y)      ! Y-coordinate
          Q(JH+10)=0.
          DXDIM=ABS(Q(JHB+JHITB_Q))
          DYDIM=ABS(Q(JHB+JHITB_R))
        ENDIF
        Q(JH+11)=DXDIM/SQRT(12.)    ! measurement error 1
        Q(JH+12)=DYDIM/SQRT(12.)    ! measurement error 2
        IQ(JH+13)=0                 ! cluster number
* the case of MC
*        IF(MCFLAG.NE.1) GOTO 50
        IQ(JH+14)=0                 ! number of related MC tracks
* use relations to find MC-tracks related with hit
        JAUX=PHITB_MIMP(IHB)
  17    IF(JAUX.EQ.0) GOTO 20
        NI=MHITB_MIMP(JAUX)
        JIP = JMIMP+IQ(JMIMP+1)*(NI-1)+2
        MC  = IQ(JIP+JMIMP_MTRA)
* collect MC-track numbers
        NMC=IQ(JH+14)+1
        IF(NMC.GT.5) GOTO 20
        IQ(JH+14)=NMC
        IQ(JH+NMC+14)=MC
        JAUX=XHITB_MIMP(JAUX)
        GOTO 17
  20    CONTINUE
*
  50  CONTINUE
 200  CONTINUE
      RETURN
      END
