*CMZ :  4.06/02 19/10/96  16.01.07  by  Rainer Mankel
*CMZ :  4.04/01 26/03/96  15.00.20  by  Rainer Mankel
*-- Author :    Rainer Mankel   17/02/96

      subroutine diplac(sl,chopt)

*     **** display all ECAL blocks
      implicit none
#include "arte/Arte.fi"
#include "pris/zgraf.fi"

      character*(*) chopt
      real xxx(5), yyy(5), wc(3,4)
      integer ii, pl, sl

#include "auto/GEO.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"

*     **** loop over ECAL blocks
      do 10 pl=1,ngcal()

         if (sl.gt.0) then      ! check SL
            if (ogcal_gesl(pl).ne.sl) go to 10
         endif

         wc(1,1) = fgcal_xmin(pl)
         wc(2,1) = fgcal_ymin(pl)
         wc(3,1) = fgcal_zmin(pl)
         wc(1,2) = fgcal_xmax(pl)
         wc(2,2) = fgcal_ymin(pl)
         wc(3,2) = fgcal_zmin(pl)
         wc(1,3) = fgcal_xmax(pl)
         wc(2,3) = fgcal_ymax(pl)
         wc(3,3) = fgcal_zmin(pl)
         wc(1,4) = fgcal_xmin(pl)
         wc(2,4) = fgcal_ymax(pl)
         wc(3,4) = fgcal_zmin(pl)

*        **** projection
         do ii=1,4
            call dipro(wc(1,ii),xxx(ii),yyy(ii))
         enddo

*        **** close the parallelogram
         xxx(5) = xxx(1)
         yyy(5) = yyy(1)

*        **** draw plane
         call isplci(int(coplbzg))
         call igsg(1)
         call isln(1)

*        **** draw plane volume if opaque option active
         if (lopaquezg) then
            call igset('PLCI',coplvzg)
            call igset('FACI',coplvzg)
            call igset('FAIS',1.)
            call igset('BORD',0.)
            call ifa(5,xxx,yyy)
         endif
*        **** draw plane border
         call igset('PLCI',coplbzg)
         call igset('FAIS',0.)
         call igset('LWID',1.)
         call ipl(5,xxx,yyy)

         call isfaci(0)
         call isfais(0)
 10   continue

      end





