*-- Author :    Rainer Mankel   23/06/97

      subroutine dmdef()

*     **** set up /zdomdef/, this is the default domain assignment
      implicit none

#include "rang/zdomdef.fi"

      integer max_domain
      parameter (max_domain=21)
      integer scope_domain(max_domain), domain, idsl,ii,jj
      logical active_domain(max_domain)
      character*4 name_domain(max_domain),c_domain(3,max_domain)
      data (name_domain(jj),(c_domain(ii,jj),ii=1,3), scope_domain(jj),
     +                          active_domain(jj),jj=1,max_domain)/
     +    'SI1','SI01', '    ', '    ', 1, .true.,
     +    'SI2','SI02', '    ', '    ', 1, .true.,
     +    'SI3','SI03', '    ', '    ', 1, .true.,
     +    'SI4','SI04', '    ', '    ', 1, .true.,
     +    'SI5','SI05', '    ', '    ', 1, .true.,
     +    'SI6','SI06', '    ', '    ', 1, .true.,
     +    'SI7','SI07', '    ', '    ', 1, .true.,
     +    'MC1','MC01', 'MS01', '    ', 2, .true.,
     +    'MC2','MC02', '    ', '    ', 2, .true.,
     +    'MC3','MC03', 'MS03', '    ', 2, .true.,
     +    'MC4','MC04', '    ', '    ', 2, .true.,
     +    'MC5','MC05', 'MS05', '    ', 2, .true.,
     +    'MC6','MC06', '    ', '    ', 2, .true.,
     +    'MC7','MC07', 'MS07', '    ', 2, .true.,
     +    'MC8','MC08', '    ', '    ', 2, .true.,
     +    'PC1','PC01', 'MS10', '    ', 3, .true.,
     +    'PC2','PC02', 'MS11', '    ', 3, .true.,
     +    'PC3','PC03', 'MS12', '    ', 3, .true.,
     +    'PC4','PC04', 'MS13', '    ', 3, .true.,
     +    'TC1','TC01', 'MS14', '    ', 4, .true.,
     +    'TC2','TC02', 'MS15', '    ', 4, .true./

      n_df = 0                  ! reset df table

      do domain=1,max_domain    ! loop over domains
         if (n_df.lt.maxdom_df) then
            n_df = n_df + 1
            cdom_df(n_df) = name_domain(domain)
            scope_df(n_df) = scope_domain(domain)
            active_df(n_df) = active_domain(domain)
            do idsl=1,maxsl_df
               if (idsl.le.3) then
                  csl_df(idsl,n_df) = c_domain(idsl,domain)
               else
                  csl_df(idsl,n_df) = ' '
               endif
            enddo
         else
            print *,' () dmdef: overflowing n_df=',n_df
            go to 999
         endif
      enddo
            
 999  end
      



