*CMZ :  4.04/00 02/09/96  14.12.57  by  Rainer Mankel
*CMZ :  4.03/01 19/08/96  16.58.30  by  Rainer Mankel
*CMZ :  4.03/00 29/07/96  10.52.21  by  Rainer Mankel
*CMZ :  4.02/00 19/07/96  13.56.50  by  Rainer Mankel
*-- Author :    Rainer Mankel   25/05/96

      subroutine tflft(ift,chopt)

*     **** print track candidate ift
      implicit none
#include "arte/Arte.fi"

#include "rang/zf.fi"
#include "rang/zfmode.fi"

      integer ift, nstring, iii, ih, imc, mimp, nnmimp, nch,
     +        jj, i, j
      real tfmitoqpt, ex, ey, etx, ety, ecu, tfangl
      double precision x(5), c(5,5)
      character*10 c_alive
      character*500 cstring
      character*1 csig
      character*(*) chopt
      logical lsmoo
#include "auto/GESL.fi"
#include "auto/GEDE.fi"
#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "arte/Arte.ff"
#include "auto/GESL.ff"
#include "auto/GEDE.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"


*     **** fixup
      if (ift.lt.1.or.ift.gt.nca_ft) then
         print *,' () tflft: invalid ift=', ift
         go to 999
      endif

      lsmoo = stat_ft(ift).eq.3.or.stat_ft(ift).eq.5

      print *,' ++++++++++++++++++++  ft   listing ++++++++++++++++++ '
     +     ,' smoothed=', lsmoo
      print '(12a6,a8)', 'ift', 'stat', '1st', 'lst', 'pre',
     +      'gen', 'nhit', 'nflt',
     +      'qlty', 'badh', 'bads', 'status', 'alive?'

*     **** alive ?
      if (alive_ft(ift)) then
         if (mature_ft(ift)) then
            c_alive = ' mature'
         else
            c_alive = '  alive'
         endif
      else
         c_alive = '  --  '
      endif

      cstring = ' '
      call tfstrg(ift,cstring,nstring)

*     **** print global information
      print '(8i6,f6.2,3i6,a8,2x,(a))',
     +     ift, stat_ft(ift), first_ft(ift), last_ft(ift),
     +     prev_ft(ift),
     +     gen_ft(ift), nhit_ft(ift), nfault_ft(ift),
     +     quality_ft(ift), badhits_ft(ift), badsigs_ft(ift),
     +     stat_ft(ift), c_alive, cstring(1:nstring)

*     **** print corresponding zf entries
      print *,' '
      print *,
     +     ' ++++++++++++++++++++ /zf/ listing ++++++++++++++++++ '
      if (index(chopt,'R').gt.0) then
         print '(a5,a6,a5,a10  ,5a12  )',
     +        'izf','ih','pla','z','m','cm','r','dr','chi**2'
      elseif (index(chopt,'TX').gt.0) then
         print '(a5,a6,2a5,1x,a4,2a8,3a10)',
     +        '#', 'hit', 'pl', 'mc', 'fau',
     +        'ch2', 'z', 'tx', 'txmc', 'etx'
      elseif (index(chopt,'TY').gt.0) then
         print '(a5,a6,2a5,1x,a4,2a8,3a10)',
     +        '#', 'hit', 'pl', 'mc', 'fau',
     +        'ch2', 'z', 'ty', 'tymc', 'ety'
      elseif (index(chopt,'X').gt.0) then
         print '(a5,a6,2a5,1x,a4,2a8,3a10)',
     +        '#', 'hit', 'pl', 'mc', 'fau',
     +        'ch2', 'z', 'x', 'xmc', 'ex'
      elseif (index(chopt,'Y').gt.0) then
         print '(a5,a6,2a5,1x,a4,2a8,3a10)',
     +        '#', 'hit', 'pl', 'mc', 'fau',
     +        'ch2', 'z', 'y', 'ymc', 'ey'
      elseif (index(chopt,'CU').gt.0) then
         print '(a5,a6,2a5,1x,a4,2a8,3a10)',
     +        '#', 'hit', 'pl', 'mc', 'fau',
     +        'ch2', 'z', 'qpt', 'qptmc', 'eqpt'
      else
         print '(a5,2a6,2a5,a4,a5,1x,2a4,2a6,10a10)',
     +        'izf', 'hit', 'ang', 'pla', 'dl','pre', 'mc', 'nh',
     +        'fau',
     +        'ch2', 'z', 'x', 'mx', 'y', 'my', 'qpt',
     +        'xmc', 'mxmc', 'ymc', 'mymc', 'qptmc'
      endif

      do 10 iii=1,999
         if (iii.eq.1) then
            jj = last_ft(ift)
         else
            if (lsmoo) then
               jj = prevs_zf(jj)
            else
               jj = prev_zf(jj)
            endif
         endif
         if (jj.le.0) go to 11

         if (lsmoo) then
            do i=1,5
               x(i) = xs_zf(i,jj)
               do j=1,5
                  c(i,j) = cs_zf(i,j,jj)
               enddo
            enddo
         else
            do i=1,5
               x(i) = xx_zf(i,jj)
               do j=1,5
                  c(i,j) = cx_zf(i,j,jj)
               enddo
            enddo
         endif
*        **** sign
         call tfsign(jj,csig)
         ih = hit_zf(jj)
         call tuhmimp(ih,imc,mimp,nnmimp)
         if (mimp.lt.0.or.mimp.gt.iq(jmimp+2)) stop '() tfkpzf'
         if (index(chopt,'R').gt.0) then
            print '(i5,i6,i5,f10.2,5f12.4)',
     +           jj, ih, plane_zf(jj), z_zf(jj), xm_zf(1,jj),
     +           dsqrt(cm_zf(1,1,jj)),
     +           xr_zf(1,jj), dsqrt(cr_zf(1,1,jj)), ch_zf(jj)
         elseif (index(chopt,'TX').ne.0) then
            if (c(3,3).ge.0.d0) then
               etx = dsqrt(c(3,3))
            else
               etx = -1.
            endif

            print '(i5,i6,2i5,a1,i4,2f8.2,3f10.5)',
     +           iii, ih,
     +           plane_zf(jj), mc_zf(jj),
     +           csig, fault_zf(jj),
     +           ch_zf(jj), z_zf(jj), x(3),
     +           fmimp_tx(mimp), etx
         elseif (index(chopt,'TY').ne.0) then
            if (c(4,4).ge.0.d0) then
               ety = dsqrt(c(4,4))
            else
               ety = -1.
            endif

            print '(i5,i6,2i5,a1,i4,2f8.2,3f10.5)',
     +           iii, ih,
     +           plane_zf(jj), mc_zf(jj),
     +           csig, fault_zf(jj),
     +           ch_zf(jj), z_zf(jj), x(4),
     +           fmimp_ty(mimp), ety
         elseif (index(chopt,'X').ne.0) then
            if (c(1,1).ge.0.d0) then
               ex = dsqrt(c(1,1))
            else
               ex = -1.
            endif

            print '(i5,i6,2i5,a1,i4,2f8.2,3f10.5)',
     +           iii, ih,
     +           plane_zf(jj), mc_zf(jj),
     +           csig, fault_zf(jj),
     +           ch_zf(jj), z_zf(jj), x(1),
     +           fmimp_x(mimp)
     +           + (z_zf(jj)-fmimp_z(mimp)) * fmimp_tx(mimp), ex
         elseif (index(chopt,'Y').ne.0) then
            if (c(2,2).ge.0.d0) then
               ey = dsqrt(c(2,2))
            else
               ey = -1.
            endif

            print '(i5,i6,2i5,a1,i4,2f8.2,3f10.5)',
     +           iii, ih,
     +           plane_zf(jj), mc_zf(jj),
     +           csig, fault_zf(jj),
     +           ch_zf(jj), z_zf(jj), x(2),
     +           fmimp_y(mimp)
     +           + (z_zf(jj)-fmimp_z(mimp)) * fmimp_ty(mimp), ey
         elseif (index(chopt,'CU').ne.0) then
            if (c(5,5).ge.0.d0) then
               ecu = dsqrt(c(5,5))
            else
               ecu = -1.
            endif

            print '(i5,i6,2i5,a1,i4,2f8.2,3f10.5)',
     +           iii, ih,
     +           plane_zf(jj), mc_zf(jj),
     +           csig, fault_zf(jj),
     +           ch_zf(jj), z_zf(jj), x(5),
     +           tfmitoqpt(mimp), ecu
         else
            print '(i5,i6,f6.2,2i5,i4,i5,a1, 2i4,2f8.2,10f10.5)',
     +           jj, ih,
     +           tfangl(plane_zf(jj)),
     +           plane_zf(jj), domlay_zf(jj), prev_zf(jj), mc_zf(jj),
     +           csig, nhit_zf(jj), fault_zf(jj),
     +           ch_zf(jj), z_zf(jj), x(1), x(3),
     +           x(2), x(4), x(5),
     +           fmimp_x(mimp)
     +           + (z_zf(jj)-fmimp_z(mimp)) * fmimp_tx(mimp),
     +           fmimp_tx(mimp),
     +           fmimp_y(mimp)
     +           + (z_zf(jj)-fmimp_z(mimp)) * fmimp_ty(mimp),
     +           fmimp_ty(mimp), tfmitoqpt(mimp)
         endif
 10   continue
 11   continue

 999  end


