*-- Author :    Rainer Mankel   27/07/95

      subroutine tfpnfill(rp,x,cx)

*     **** fill track parameters into reconstructed point table entry rp
      implicit none
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/RPNT.fi"

      double precision x(5), cx(5,5), d_mx, d_my, d_qpt, sq
      integer rp, i_pack, i, j
#include "pris/zmpack.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/RPNT.ff"

      sq = 1.d0/ dsqrt(1.d0 + x(4)**2 / (1.d0 + x(3)**2))

*     **** fill track parameters
      q(qrpnt_xf(rp))  = x(1)
      q(qrpnt_yf(rp))  = x(2)
      q(qrpnt_txf(rp)) = x(3)
      q(qrpnt_tyf(rp)) = x(4)
      q(qrpnt_pf(rp))  = sq * x(5)

*      **** covariance of track parameters
      do i=1,5
         do j=i,5               ! packing
            i_pack = matrix_pack(i,j)
            q(qrpnt_cvf(i_pack,rp)) = cx(i,j)
         enddo
      enddo

*     **** derivatives of q/p
      d_qpt = sq
      d_mx = x(5) * sq**3 * x(3) * x(4)**2
     +                                     / (1.d0 + x(3)**2)**2
      d_my = - x(5) * sq**3 * x(4) / (1.d0 + x(3)**2)

      i=5
      do j=1,4
         i_pack = matrix_pack(i,j)
         q(qrpnt_cvf(i_pack,rp)) =
     +        d_mx * cx(3,j) + d_my * cx(4,j) + d_qpt * cx(5,j)
      enddo
      i_pack = matrix_pack(5,5)
      q(qrpnt_cvf(i_pack,rp)) =
     +     d_mx**2 * cx(3,3) + d_my**2 * cx(4,4) + d_qpt**2 * cx(5,5)
     +     + 2. * d_mx * d_my * cx(3,4)
     +     + 2. * d_mx * d_qpt * cx(3,5)
     +     + 2. * d_my * d_qpt * cx(4,5)

      end
