*CMZ :          08/09/96  14.48.40  by   Ivan Belyaev
*-- Author :     Ivan Belyaev   08/09/96

      SUBROUTINE SKASNAV

************************************************************************
*
* Description: Create/Modify the SNAV/SNAX ARTE Tables for SUSi
*
* Called from: KUIP
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/SI.fi"

#include "susi/zsiconst.fi"

      INTEGER  NPL,IPL,I,MAX_NEXT,IUSE
      PARAMETER(MAX_NEXT=13)
      INTEGER  NEXT(MAX_NEXT)
      INTEGER  LENOCC 
      EXTERNAL LENOCC
      LOGICAL  LFIRST
      SAVE     LFIRST
      DATA     LFIRST /.TRUE./
     
#include "arte/Arte.ff"
#include "auto/SI.ff"


      IF( LFIRST )THEN
       IF( JSUSI .NE. 0 )THEN
        IF(JSNSN.NE.0)CALL MMDROP(JSNSN)
        IF(JSNAV.NE.0)CALL MMDROP(JSNAV)
        IF(JSNAX.NE.0)CALL MMDROP(JSNAX)
        CALL MMBOOK(JSUSI,0)
        CALL MMBOOK(JSNAV,0)
        CALL MMBOOK(JSNAX,0)
       ELSE
        CALL MMBOOK(JSUSI,1)
       ENDIF
       CALL MMBOOK(JSNAV,0) 
       CALL MMBOOK(JSNAX,0) 
       LFIRST = .FALSE. 
      ENDIF 

      CALL MMBOOK(JSUSI,0)

      NPL = 0
      CALL KUGETI( NPL )

      IF(     NSNAV()     .GE. N_TOTSIPL )THEN
       C78='SUSi==> SNAV Error! Number of planes is'
       CALL CH78BI( NSNAV() )
       CALL MEMESC(48738,ILARGEST,ILARGEST,C78(1:LEN(C78)))
       RETURN
      ELSEIF( NSNAV() .LT. N_TOTSIPL )THEN
       CALL MMBOOK( JSNAV,1)
      ENDIF

      IF( NPL .GE. 1 )THEN
       IUSE = 0
       DO I=1,NPL
        CALL KUGETI( IPL )
        IF( IPL .GE. 0 )THEN
         IF( IPL .LE. N_TOTSIPL )THEN
          IUSE = IUSE + 1
          IF( IUSE .LE. MAX_NEXT)THEN
           NEXT( IUSE ) = IPL
          ELSE
           C78='SUSi==> SNAV Warning! More then'
           CALL CH78BI( MAX_NEXT )
           CALL CH78BC( 'planes to be connected!' )
           CALL MEMESC(247387,ILARGEST,ILARGEST,C78(1:LEN(C78)))
          ENDIF
         ELSE
          C78='SUSi==> SNAV Error! Wrong Plane Number'
          CALL CH78BI( IPL )
          CALL MEMESC(647387,ILARGEST,ILARGEST,C78(1:LEN(C78)))
         ENDIF
        ENDIF
       ENDDO
       DO I = 1 , IUSE
        CALL MMBOOK(JSNAX,1)
        IQ(IQSNAX_NEXT_L())=NEXT(IUSE-I+1)
        IQ(IQSNAV_NPLA_L())=ISNAV_NPLA(NSNAV())+1
        CALL MMBREL(JSNSN,NSNAV(),NSNAX())
       ENDDO
      ENDIF

      END

************************************************************************
* End of KASNAV
************************************************************************
