*CMZ :  1.00/01 02/08/96  18.10.08  by   Ivan Belyaev
*CMZ :  1.04/11 11/12/95  14.25.56  by  joerg f. rieling
*CMZ :  1.04/07 08/08/95  11.21.00  by  joerg f. rieling
*CMZ :  1.04/03 22/05/95  15.50.56  by  joerg f. rieling
*-- Author :

c     ----------------------------------------------------------
      subroutine ssimrem
c     -- filters self-standing tracks from zsirctrk.
c     -- ac_bit of duplicate but worse tracks is set to .false.
c     ----------------------------------------------------------

      implicit none

#include "arte/Arte.fi"
#include "auto/SI.fi"

c     --- common blocks

#include "susi/zsiconst.fi"
#include "susi/zsirctrk.fi"

c     --- local variables / formal parameter
      INTEGER    n_PASS
      INTEGER    i1,i2,iHITB1,iHITB2,jAUX1,jAUX2,iSHRC1,iSHRC2
      INTEGER    iCOM
      REAl       COMP

#include "arte/Arte.ff"
#include "auto/SI.ff"
       
C*    All candidates still alive! 

      DO i1  = 1,NSTRC()
       IF( ISTRC_NHIT(i1) .EQ. 0 )
     & IQ(IQSTRC_AC(i1)) = 0  
       IF( ISTRC_AC(i1) .NE. 0 )THEN 
        DO i2 = i1+1,NSTRC()
         IF( ISTRC_NHIT(i2) .EQ. 0 )
     &   IQ(IQSTRC_AC(i2)) = 0  
         IF( ISTRC_AC(i2) .NE. 0 )THEN 
          ICOM  = 0 
           jAUX1 = PSTRC_SHRC( i1 ) 
           DO WHILE( jAUX1 .NE. 0 )
            iSHRC1 = MSTRC_SHRC( jAUX1  ) 
            iHITB1 = ISHRC_HITB( iSHRC1 ) 
            jAUX2  = PSTRC_SHRC( i2 ) 
            DO WHILE( jAUX2 .NE. 0 )
             iSHRC2 = MSTRC_SHRC( jAUX2 ) 
             iHITB2 = ISHRC_HITB( iSHRC2 ) 
             IF( iHITB1 .EQ. iHITB2 )ICOM=ICOM+1
             jAUX2  = XSTRC_SHRC( jAUX2 ) 
            ENDDO 
            jAUX1  = XSTRC_SHRC( jAUX1 ) 
           ENDDO 
           COMP = 2.0*FLOAT(iCOM)/
     &      FLOAT(ISTRC_NHIT(i1)+ISTRC_NHIT(i2))
           IF( COMP .GT. FSPAR_CRIT(NSPAR()) )THEN 
            IF( FSTRC_QUAL(i1).GT.FSTRC_QUAL(i2))THEN
             IQ(IQSTRC_AC(i2))=0
             GO TO 10 
            ELSE 
             IQ(IQSTRC_AC(i1))=0
             GO TO 20 
            ENDIF 
           ENDIF 
          ENDIF 
 10      CONTINUE 
        ENDDO 
       ENDIF 
 20   CONTINUE 
      ENDDO 

      RETURN
      END 
 


