
      SUBROUTINE SUSIDEFV

************************************************************************
*
* $Source: /afs/desy.de/group/hera-b/repository/ARTE/susi/susidefv.F,v $
* $Revision: 1.2 $
* $Author: hbcvs $
* $Date: 1997/11/23 23:45:42 $
*
* Created: Feb 30, 1991 by The Unknown Hacker
*
* Description: 
* Set the COMMON /ZSISUSI/ to default values 
* Called from: anywhere
*
* Arguments:
* name       in/out/update Argument description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/SI.fi"

#include "susi/zsiconst.fi"

       INTEGER  NMODOLD 
       INTEGER  LENOCC 
       EXTERNAL LENOCC

#include "arte/Arte.ff"
#include "auto/SI.ff"


       IF( JSUSI .LE. 0 )THEN
        C78='SUSi Error! Impossible to Change SUSi Parameters!'
        CALL MEMESC(174697,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
        RETURN
       ENDIF 

       NMODOLD = 0 
       IF( JSPAR .NE. 0 )THEN
        NMODOLD = ISPAR_NMOD(NSPAR())
        CALL MMDROP(JSPAR)
       ENDIF 

       CALL MMBOOK(JSPAR,1)
C*     General Parameters:
       IQ(IQSPAR_NMOD_L()) = NMODOLD 
       IQ(IQSPAR_SEED_L()) = 2 
       IQ(IQSPAR_ANGU_L()) = 1
       IQ(IQSPAR_DFLA_L()) = 1 
       IQ(IQSPAR_PROP_L()) = 1  
       IQ(IQSPAR_ALGO_L()) = 1  
       IQ(IQSPAR_RPNT_L()) = 1  
       
       IQ(IQSPAR_MHSL_L()) = MIN_HITSL 
        Q( QSPAR_QUAL_L()) = MIN_QUAL 
        Q( QSPAR_PERC_L()) = 0.70 
        Q( QSPAR_WMIS_L()) = WEIGHT_MISS
        Q( QSPAR_WCH2_L()) = WEIGHT_CHI2
        Q( QSPAR_MNTO_L()) = MIN_TOL   
        Q( QSPAR_MXTO_L()) = MAX_TOL   
        Q( QSPAR_ANTO_L()) = TOL_ANGLE   
        Q( QSPAR_CRIT_L()) = CRITICAL 
        Q( QSPAR_TWIN_L()) = TARGET_WINDOW 
        Q( QSPAR_PMIN_L()) = P_MIN
 
      END
