*-- Author :    T. Oest   24/10/96

      SUBROUTINE V0SELL(ITK,IRET)

************************************************************************
*
* Description: track selection
*
* Called from:
*
* External references:
*
* Argument in/out description
* ITK      in     track row in RTRA bank
* IRET     out    = 1  muon
* IRET     out    = 2  electron
*
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/EV.fi"

      INTEGER          ITK, IRET

      INTEGER          IERR, IVER
      DOUBLE PRECISION Z, PTRK(5), VTRK(5,5), CHI, V(2,2), W(2,2)
      REAL*4           CHIMAI

      INTEGER          NHITS

#include "arte/Arte.ff"
#include "auto/EV.ff"

      DATA CHIMAI /10./
*-----------------------------------------------------------------------
* initialization
*-----------------------------------------------------------------------
      IRET = 0
*-----------------------------------------------------------------------
* charged track
*-----------------------------------------------------------------------
      IF (PRTRX_HITB(ITK).EQ.0) THEN
       IRET = -1
       GOTO 9000
      ENDIF
*-----------------------------------------------------------------------
*  particle id
*-----------------------------------------------------------------------
      IF (FRTRA_E(ITK).GT.0.9)  IRET = 1
      IF (FRTRA_MU(ITK).GT.0.9) IRET = 2
*-----------------------------------------------------------------------
*  ztrk         < 300 cm
*  p            > 5. GeV
*  nhits        > 20
*-----------------------------------------------------------------------
      NHITS = IRTRA_HSI(ITK) + IRTRA_HIN(ITK) + IRTRA_HOU(ITK)

      IF (IRET.EQ.0 .OR.
     +    FRTRA_ZF(ITK).GT.300. .OR. NHITS.LT.20 .OR.
     +   ABS(FRTRA_PF(ITK)).GT.0.2 )THEN
       IRET = -3
       GOTO 9000
      ENDIF
*-----------------------------------------------------------------------
* the end
*-----------------------------------------------------------------------
 9000 END
