*CMZ :          20/05/96  12.58.00  by  Unknown
*-- Author :   T.Lohse
c
c-------------------------------------------------------------
c
c       subroutine:   VTRECO(flag)
c
c       input:    none
c
c       output:   flag (<0 if fail)                 Int
c
c       action:   reconstruct primary and secondary vertices
c                 for normal events (no B---J/Psi Ks)
c
c-------------------------------------------------------------
c
      subroutine  VTRECO(flag)

      implicit none

      integer flag
      integer flag1, flag2

      flag = 0

      call VTPRIM(0,flag1)
      call VTSEC( 0,flag2)

      if (flag1.lt.0.or.flag2.lt.0)   flag=-1
      if (flag1.eq.-2.or.flag2.eq.-2) flag=-2

      return
      end
