*CMZ :  2.01/02 22/12/95  16.32.10  by  Hartwig Albrecht
*CMZ :  2.01/01 25/10/95  18.22.05  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   25/10/95

      SUBROUTINE ALMCIN

************************************************************************
*
* Description: fill tables MCIN and MCME
*
* Called from: ALPYTH, ALFRIT
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MCIN.fi"
#include "auto/MCME.fi"
#include "arte/ZIOCOM.fi"
#include "pyth/PYSUBS.fi"

#include "arte/Arte.ff"
#include "auto/MCIN.ff"
#include "auto/MCME.ff"

      IF (JMCIN .EQ. 0)  CALL MMBOOK (JMCIN, 1)
      CALL MMBOOK (JMCME, 1)
      IQ(IQMCME_EVT_L()) = NUMEVT
      IQ(IQMCME_RUN_L()) = NUMRUN
      IQ(IQMCME_EXP_L()) = NUMEXP

C further specification necessary in future:
      IQ(IQMCME_PHY_L()) = MSEL * 1000

      Q(QMCME_VLUN_L()) = LUNDVERS

c Lund random seed for this event

      IQ(IQMCME_RLUN_L(1)) = LUNDSEED(1)
      IQ(IQMCME_RLUN_L(2)) = LUNDSEED(2)

      END

************************************************************************
* End of ALMCIN
************************************************************************
