*CMZ :  2.01/02 26/01/96  10.27.20  by  Hartwig Albrecht
*CMZ :  2.01/01 19/05/95  13.50.44  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   12/05/95

      SUBROUTINE CHCTOH (CTEXT, IARR, NARR)

************************************************************************
*
* Description: copy CTEXT into integer (real) array IARR.
*              4 characters / word are stored.
*              If LEN(CTEXT) > 4*NARR: truncate
*              IF LEN(CTEXT) < 4*NARR: fill with blank spaces
*
* Called from: anywhere
*
* External references: CHCTOH
*
* Argument in/out description
*   CTEXT  in     character string to be copied
*   IARR   out    integer or real array (e.g. in the Zebra working space)
*                 The appropriate Zebra format is H.
*   NARR   in     length of IARR.
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"

      INTEGER NARR, IARR(NARR), N, NCH
      CHARACTER CTEXT*(*)

#include "arte/Arte.ff"

      NCH = MIN (LEN(CTEXT), 4 * NARR)
      DO 10 N = (NCH + 7) / 4, NARR
 10   IARR(N) = HBLANKSP
      CALL UCTOH (CTEXT, IARR, 4, NCH)

      END

************************************************************************
* End of CHCTOH
************************************************************************
