*-- Author :    Hartwig Albrecht   21/05/95

      SUBROUTINE DDEXEC

************************************************************************
*
* Description: execute the data definition task
*
* Called from: KAEXEC
*
* External references:
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZDDCOM.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER L

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      IF (JDDEF .EQ. 0)  CALL MMBOOK (JDDEF, 0)

C end of users DD commands

      NDDUSR = NDDEF()

C Make drelat commands

      CALL DDRELA

C end of new DD commands

      NDDNEW = NDDEF()

C read DD commands from hbcdes

c      C78 = 'EXEC /afs/desy.de/group/hera-b/arte/arteware/' //
c     +      'ARTE-01-05/dd/auto.inc/dd.kumac'
      C78 = 'EXEC $HB/$HBVERS/dd/auto.inc/dd.kumac'
      CALL MEWARC (35648, 'DDEXEC: ' // C78)
      CALL KUEXEC (C78)

C check syntax

      CALL DDCHCK

      IF (PROGERR .NE. 0)  CALL MEERRC (1834,
     +  'DDEXEC: job ran with errors. Give up ?')

C output kumac file

      CALL DDOPEN ('dd', 'kumac')

      DO 10 L = 1, NDDEF()
 10   IF (IDDEF_FLAG(L) .GE. LDDEF_INI)  CALL LIDDE1 (LDDEF, L)

      NDDCRD = 1
      NDDIND = 1

C write include directory

      CALL DDNAMF
      CALL DDNAMC

      CALL DDATTF
      CALL DDATCP
      CALL DDATCC

      CALL DDMENF
      CALL DDMENC

      CALL DDHELP
      CALL DDFORT

      CALL IOCLOS (LDDEF)

      END

************************************************************************
* End of DDEXEC
************************************************************************
