*CMZ :  2.01/01 12/09/95  20.18.21  by  HERA-B
*-- Author :    Hartwig Albrecht   23/05/95

      SUBROUTINE DDHEL1 (K1)

************************************************************************
*
* Description: make help sequence YAUTHELP
*
* Called from: DDHELP
*
* External references: ...
*
* Argument in/out description
*   K1     in     menu row in DDEF
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER K1, K2, K3, K4, K5, LL, LENOCC
      CHARACTER CM*4, CT*4, CA*9, CF*1, CS*5, CI*15, CE*4
      DATA CI /'#include "auto/'/, CE /'.xx"'/

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      IF (HDDEF_NAME(K1) .NE. HBLANKSP)  THEN

C menu header

        C78 = '>MENU'
        CALL CHHTOC (IQ(HQDDEF_NAME(K1)), C78(7:10))
        WRITE (LDDEF, 1001)  C78(1:LENOCC(C78))
        WRITE (LDDEF, 1001) '>GUIDANCE'

        C78 = ' '
        CALL CHHTOC (IQ(HQDDEF_TEXT(1,K1)), C78(1:48))
        WRITE (LDDEF, 1001)  C78(1:LENOCC(C78))

        DO 10 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .NE. LDDEF_TEX)  GO TO 20
          CALL LIDDE1 (LDDEF, K2)
 10     CONTINUE

      END IF

C loop over tables

 20   DO 200 K2 = 1, NDDEF()

        IF (IDDEF_FLAG(K2) .NE. LDDEF_TAB .AND.
     +      IDDEF_FLAG(K2) .NE. LDDEF_REL)  GO TO 200
        IF (HDDEF_NAM2(K2) .NE. HDDEF_NAME(K1))  GO TO 200

C help_item header

        C78 = '>HELP_ITEM'
        CALL CHHTOC (IQ(HQDDEF_NAME(K2)), C78(12:15))
        WRITE (LDDEF, 1001) C78(1:LENOCC(C78))
        WRITE (LDDEF, 1001) '>GUIDANCE'

        CALL LIDDE1 (LDDEF, K2)
        DO 30 K3 = K2 + 1, NDDEF()
          IF (IDDEF_FLAG(K3) .LE. LDDEF_SKP)  GO TO 30
          IF (IDDEF_FLAG(K3) .LE. LDDEF_NAM)  GO TO 40
          CALL LIDDE1 (LDDEF, K3)
 30     CONTINUE

 40     WRITE (LDDEF, 1001)

C stop here for relations

        IF (IDDEF_FLAG(K2) .EQ. LDDEF_REL)  GO TO 200

C help for #include, ...

        C78 = 'Header files: ' // CI
        CALL CHHTOC (IQ(HQDDEF_NAME(K2)), C78(30:33))
        IF (HDDEF_NAME(K1) .EQ. HBLANKSP)  GO TO 70
        CALL CH78AC (CE) 
        CALL CH78BC ('or')
        CALL CH78BC (CI)
        CALL CHHTOC (IQ(HQDDEF_NAME(K1)), CM)
        CALL CH78AC (CM)
        CALL CH78AC (CE) 

        IF (HDDEF_NAM2(K1) .EQ. HBLANKSP)  GO TO 70
        DO 60 K3 = 1, NDDEF()
          IF (IDDEF_FLAG(K3) .NE. LDDEF_MEN .OR.
     +        HDDEF_NAM2(K1) .NE. HDDEF_NAME(K3))  GO TO 60
          CALL CH78AC (CE) 
          CALL CH78BC ('or')
          CALL CH78BC (CI)
          CALL CHHTOC (IQ(HQDDEF_NAME(K3)), CM)
          CALL CH78BC (CM)
          CALL CH78AC (CE) 

          IF (HDDEF_NAM2(K3) .EQ. HBLANKSP)  GO TO 60
          DO 50 K4 = 1, NDDEF()
            IF (IDDEF_FLAG(K4) .NE. LDDEF_MEN .OR.
     +          HDDEF_NAM2(K3) .NE. HDDEF_NAME(K4))  GO TO 50
            CALL CH78AC (CE) 
            CALL CH78BC ('or')
            CALL CH78BC (CI)
            CALL CHHTOC (IQ(HQDDEF_NAME(K4)), CM)
            CALL CH78BC (CM)
            CALL CH78AC (CE) 
 50       CONTINUE
 60     CONTINUE

 70     WRITE (LDDEF, 1001) '.'
        WRITE (LDDEF, 1002) C78(1:LENOCC(C78))
        WRITE (LDDEF,1001)

C number of rows / columns

        C78 = '... =  J        ! Zebra link'
        CALL CHHTOC (IQ(HQDDEF_NAME(K2)), CT)
        C78(9:12) = CT
        WRITE (LDDEF, 1002) C78(1:LENOCC(C78))

        C78(8:8) = 'N'
        C78(13:14) = '()'
        C78(19:) = 'number of rows'
        WRITE (LDDEF, 1002) C78(1:LENOCC(C78))

        C78(7:8) = 'NC'
        C78(19:) = 'number of columns / row'
        WRITE (LDDEF, 1002) C78(1:LENOCC(C78))

C attribute description

        DO 150 K3 = K2 + 1, NDDEF()
          IF (IDDEF_FLAG(K3) .LE. LDDEF_SKP)  GO TO 150
          IF (IDDEF_FLAG(K3) .LE. LDDEF_NAM)  GO TO 200
          IF (IDDEF_FLAG(K3) .GT. LDDEF_INM)  GO TO 150
          WRITE (LDDEF, 1001) '.'

          CALL CHHTOC (IQ(HQDDEF_NAM2(K3)), CF)
          C78 = 'undef'

          IF (IDDEF_FLAG(K3) .EQ. LDDEF_RE1)  THEN
            C78(1:8) = 'relone'
          ELSE IF (IDDEF_FLAG(K3) .EQ. LDDEF_REM)  THEN
            C78(1:8) = 'relmany'
          ELSE IF (IDDEF_FLAG(K3) .EQ. LDDEF_in1)  THEN
            C78(1:8) = 'invmany'
          ELSE IF (IDDEF_FLAG(K3) .EQ. LDDEF_inM)  THEN
            C78(1:8) = 'invmany'
          ELSE IF (CF .EQ. 'I')  THEN
            C78(1:8) = 'integ'
            CS = 'IQ(IQ'
          ELSE IF (CF .EQ. 'F') THEN
            C78(1:8) = 'float'
            CS = '  Q(Q'
          ELSE IF (CF .EQ. 'H') THEN
            C78(1:8) = 'holl'
            CS = 'IQ(HQ'
          ELSE IF (CF .EQ. 'B') THEN
            C78(1:8) = 'bits'
            CS = 'IQ(BQ'
          END IF

          CALL CHHTOC (IQ(HQDDEF_NAME(K3)), C78(10:13))
          CALL CHHTOC (IQ(HQDDEF_TEXT(1,K3)), C78(15:62))
          WRITE (LDDEF, 1002) C78(1:LENOCC(C78))

          C78 = ' '
          DO 90 K4 = K3 + 1, NDDEF()
            IF (IDDEF_FLAG(K4) .NE. LDDEF_TEX)  GO TO 100
            CALL CHHTOC (IQ(HQDDEF_TEXT(1,K4)), C78(12:59))
            WRITE (LDDEF, 1002) C78(1:LENOCC(C78))
 90       CONTINUE

 100      CALL CHHTOC (IQ(HQDDEF_NAME(K2)), CA(1:4))
          CA(5:5) = '_'
          CALL CHHTOC (IQ(HQDDEF_NAME(K3)), CA(6:9))
          C78 = ' '
          C78(9:17) = CA

          LL = LENOCC (C78(1:17))
          IF (IDDEF_FLAG(K3) .GT. LDDEF_ATT)  GO TO 110

          C78(1:8) = ' ... = J'
          C78(33:44) = '! position ='
          CALL CH78BI (IDDEF_POS(K3))
          WRITE (LDDEF, 1002) C78(1:LENOCC(C78))

          IF (IDDEF_DIM(K3) .NE. 0)  THEN
            C78(8:8) = 'N'
            C78(35:) = 'dimension ='
            CALL CH78BI (IDDEF_DIM(K3))
            WRITE (LDDEF, 1002) C78(1:LENOCC(C78))
          END IF

          C78(8:8) = CF
          C78(35:) = 'get value; ir = 1 ... N' // CT // '()'
          IF (IDDEF_DIM(K3) .NE. 0)  THEN
            C78(LL+1:32) = '(iw,ir)'
            WRITE (LDDEF, 1002) C78(1:LENOCC(C78))
            WRITE (LDDEF, 1003) CA
          ELSE
            C78(LL+1:32) = '(ir)'
            WRITE (LDDEF, 1002) C78(1:LENOCC(C78))
          END IF

          C78(1:3) = ' '
          C78(4:8) = CS
          CALL CHAPPC (C78(18:32), ') = ...')
          C78(35:) = 'put value'
          WRITE (LDDEF, 1002) C78(1:LENOCC(C78))

          IF (IDDEF_DIM(K3) .NE. 0)  THEN
            C78(LL+1:32) = '_L(iw)) = ...'
          ELSE
            C78(LL+1:32) = '_L()) = ...'
          END IF
          CALL CH78BC ('into last row')
          WRITE (LDDEF, 1002) C78(1:LENOCC(C78))

          GO TO 150

 110      DO 120 K4 = 1, NDDEF()
            IF (IDDEF_FLAG(K4) .EQ. LDDEF_TAB)  K5 = K4
            IF (K4 .NE. K3 .AND.
     +          HDDEF_NAM3(K3) .EQ. HDDEF_NAM3(K4) .AND.
     +          IDDEF_FLAG(K4) .GE. LDDEF_RE1 .AND.
     +          IDDEF_FLAG(K4) .LE. LDDEF_INM)  GO TO 130
 120      CONTINUE

 130      C78(LL+1:32) = '(ir)'

          IF (IDDEF_FLAG(K3) .EQ. LDDEF_RE1 .OR.
     +        IDDEF_FLAG(K3) .EQ. LDDEF_IN1)  THEN

            C78(1:8) = 'row# = O'
            C78(33:47) = '! row in table'
            CALL CHHTOC (IQ(HQDDEF_NAME(K5)), C78(49:52))

          ELSE
            C78(1:8) = 'indx = P'
            C78(33:47) = '! 1st index'
            WRITE (LDDEF, 1002) C78(1:LENOCC(C78))
            C78(1:8) = 'row# = M'
            C78(LL+1:32) = '(indx)'
            C78(35:47) = 'row in table'
            CALL CHHTOC (IQ(HQDDEF_NAME(K5)), C78(49:52))
            WRITE (LDDEF, 1002) C78(1:LENOCC(C78))
            C78(1:4) = 'indx'
            C78(8:8) = 'X'
            C78(35:) = 'next index'
          END IF

          WRITE (LDDEF, 1002) C78(1:LENOCC(C78))

 150    CONTINUE

 200  CONTINUE

 1001 FORMAT (A)
 1002 FORMAT (1X,A)
 1003 FORMAT (46X,'iw = 1 ... N', A)

      END

************************************************************************
* End of DDHEL1
************************************************************************
