*CMZ :          18/04/96  13.37.51  by  Hartwig Albrecht
*CMZ :  2.01/01 19/06/95  10.33.49  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   23/05/95

      SUBROUTINE DDHELP

************************************************************************
*
* Description: make a help file from DD cards
*
* Called from: DDEXEC
*
* External references:
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER K1, K2, K3, K4

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      CALL DDOPEN ('ArteTable', 'help')

      WRITE (LDDEF, 1001)  ' '
      WRITE (LDDEF, 1001)
     +  '* Created automatically by subroutine DDHELP.'
      WRITE (LDDEF, 1001)  ' '
      WRITE (LDDEF, 1001)  '>MENU /Ddescription'
      WRITE (LDDEF, 1001)  '>GUIDANCE'
      WRITE (LDDEF, 1001)  'Data description'

      DO 310 K1 = 1, NDDEF()
        IF (IDDEF_FLAG(K1) .NE. LDDEF_MEN)  GO TO 310
        IF (HDDEF_NAM2(K1) .NE. HBLANKSP)  GO TO 310
        CALL DDHEL1 (K1)
        IF (HDDEF_NAME(K1) .EQ. HBLANKSP)  GO TO 310

        DO 210 K2 = 1, NDDEF()
          IF (IDDEF_FLAG(K2) .NE. LDDEF_MEN)  GO TO 210
          IF (HDDEF_NAM2(K2) .NE. HDDEF_NAME(K1) )  GO TO 210
          IF (HDDEF_NAME(K2) .EQ. HBLANKSP)  GO TO 210
          CALL DDHEL1 (K2)

          DO 110 K3 = 1, NDDEF()
            IF (IDDEF_FLAG(K3) .NE. LDDEF_MEN)  GO TO 110
            IF (HDDEF_NAM2(K3) .NE. HDDEF_NAME(K2) )  GO TO 110
            IF (HDDEF_NAME(K3) .EQ. HBLANKSP)  GO TO 110
            CALL DDHEL1 (K3)

            DO 10 K4 = 1, NDDEF()
              IF (IDDEF_FLAG(K4) .NE. LDDEF_MEN)  GO TO 10
              IF (HDDEF_NAM2(K4) .NE. HDDEF_NAME(K3) )  GO TO 10
              IF (HDDEF_NAME(K4) .EQ. HBLANKSP)  GO TO 10
              CALL DDHEL1 (K4)
 10         CONTINUE

            WRITE (LDDEF, 1001)  '>MENU ..'
 110      CONTINUE

          WRITE (LDDEF, 1001)  '>MENU ..'
 210    CONTINUE

      WRITE (LDDEF, 1001)  '>MENU /Ddescription'
 310  CONTINUE

 1001 FORMAT (A)

      END

************************************************************************
* End of DDHELP
************************************************************************
