*CMZ :          02/05/96  13.08.56  by  Hartwig Albrecht
*CMZ :  2.01/02 26/01/96  20.04.09  by  Hartwig Albrecht
*CMZ :  2.01/01 22/12/95  14.39.28  by  Hartwig Albrecht
*CMZ :  2.01/00 14/02/95  11.10.09  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   23/03/93

      SUBROUTINE IOINIT

************************************************************************
*
* Description: Default logical units
*
* Called from: ATINIT
*
* External references: /ZUNIT/ Zebra units
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"

      INTEGER K

#include "arte/Arte.ff"

      NIOUSD = 99

      DO 10 K = 1, NIOMAX
        CIONAM(K) = ' '
        CIOZFL(K) = ' '
        CIOZEB(K) = ' '
        IIOSTA(K) = -1
        IIOFLG(K) = -1
        NIOLEN(K) = -1
        IIOFMT(K) = -1
        IIONXT(K) = 0
        NIOREC(K) = 0
 10   CONTINUE

      DO 20 K = 1, 99
        CIOSYM(K) = ' '
        IIOBIT(K) = 0
        IIOCUR(K) = K
        JIOBNK(K) = 0
        NIOSKP(K) = 0
        IIOSKP(K) = 0
 20   CONTINUE

      DO 30 K = 1, 4
 30   FIOMIX(K) = 0.

      IF (IBATCH .EQ. 0)  THEN
        LITRM = LSTDI
        LOTRM = LSTDO
        LPRNT = 4
      ELSE
        LITRM = 0
        LOTRM = 0
        LPRNT = LSTDO
      END IF

      CALL IODECL (LSTDI, 'STDI', '(standard input)')
      CALL IODECL (LSTDO, 'STDO', '(standard output)')

      CALL IODECL (LLOGF, 'LOGF', ' ')
      C78 = JOBNAME
      CALL CH78AC ('.logf')
      CALL IOCONC (LLOGF, C78, 'O', 0)
      CALL IOOPEN (LLOGF, 'F', 0, K)

      IF(IBATCH.EQ.0) THEN
         CALL IODECL (LPRNT, 'PRNT', ' ')
         C78 = JOBNAME
         CALL CH78AC ('.prnt')
         CALL IOCONC (LPRNT, C78, 'O', 0)
         CALL IOOPEN (LPRNT, 'F', 0, K)
      ENDIF

      LHIST = 1
      CALL IODECL (LHIST, 'HIST', '(histogram file)')

      LPRIS = 10
      CALL IODECL (LPRIS, 'PRISM', '(event display)')

      DO 40 K = 11, 15
 40   CALL IODECL (K, ' ', '(reserved for KUIP)')

      LEVI1 = 21
      CALL IODECL (LEVI1, 'EVIN1', '(event input 1)')

      LEVI2 = 22
      CALL IODECL (LEVI2, 'EVIN2', '(event input 2)')

      LEVI3 = 23
      CALL IODECL (LEVI3, 'EVIN3', '(event input 3)')

      LEVI4 = 24
      CALL IODECL (LEVI4, 'EVIN4', '(event input 4)')

      LRAWO = 25
      CALL IODECL (LRAWO, 'RAW', '(event output - raw data)')

      LDSTO = 26
      CALL IODECL (LDSTO, 'DST', '(event output - DST)')

      LMINO = 27
      CALL IODECL (LMINO, 'MINI', '(event output - MINI)')

      LGEOI = 31
      CALL IODECL (LGEOI, 'GEOMIN', '(geometry constants input)')

      LGEOO = 32
      CALL IODECL (LGEOO, 'GEOMOUT', '(geometry constants output)')

      LL1SI = 33
      CALL IODECL (Ll1SI, 'L1SIMU', '(trigger level 1)')

      LDDEF = 34
      CALL IODECL (LDDEF, 'DDEFINI', '(Data Definition files)')

      LREAD = 35
      CALL IODECL (LREAD, 'READ', '(FFREAD)')

c Added by A.Lanyov,  Sep-1997
c      LREAD1 = 36
      CALL IODECL (36, 'READ1', '(FFREAD)')

      END

************************************************************************
* End of IOINIT
************************************************************************
