*CMZ :  2.01/01 26/04/95  09.26.45  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   06/03/95

      SUBROUTINE IOREWI (LUN)

************************************************************************
*
* Description:  Rewind data set
*
* Called from: anywhere
*
* External references: IFREWI, IOCLOS
*
* Argument in/out description
*   LUN    in     logical unit number
*
************************************************************************

      IMPLICIT NONE

#include "arte/ZIOCOM.fi"

      INTEGER L, LUN

      IF (LUN .EQ. 0)  GO TO 90
      L = LUN

 10   IF (IIOFLG(L) .EQ. 2)  THEN
        CALL IOCLOS (LUN)
        IIOFLG(L) = 1
      ELSE IF (IIOFLG(L) .EQ. 3)  THEN
        CALL IFREWI (LUN, IIOSTA(L))
        NIOREC(L) = 0
        IIOFLG(L) = 2
      ELSE IF (IIOFLG(L) .GT. 3)  THEN
        IF (IIONXT(L) .EQ. 0)  THEN
          IIOFLG(L) = 1
        ELSE IF (IIOFLG(IIONXT(L)) .EQ. 1)  THEN
          IIOFLG(L) = 1
        ELSE IF (IIOFLG(IIONXT(L)) .EQ. 2)  THEN
          CALL IOCLOS (LUN)
          IIOFLG(IIONXT(L)) = 1
          IIOFLG(L) = 1
        ELSE
          L = IIONXT(L)
          GO TO 10
        END IF
      END IF

      IIOCUR(LUN) = L

 90   END

************************************************************************
* End of IOREWI
************************************************************************
