*CMZ :  2.01/01 15/07/95  13.05.19  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   09/03/95

      SUBROUTINE MMFORM (CHID, CHFORM, IXIO)

************************************************************************
*
* Description: Declare the format of a table. The format of the 1st and
*              2nd word (# of columns / # of rows) is added.
*
* Called from: Initialization routines
*
* External references: MZFORM
*
* Argument in/out description
*   CHID   in     table name
*   CHFORM in     format of the tables rows
*   IXIO   out    pointer refering to the format
*
************************************************************************

      IMPLICIT NONE

      INTEGER IXIO
      CHARACTER *(*) CHID, CHFORM
      CHARACTER*81 CHNEW
      DATA CHNEW /'2I /'/

      CHNEW(6:) = CHFORM

      CALL MZFORM (CHID, CHNEW, IXIO)

      END

************************************************************************
* End of MMFORM
************************************************************************
