*CMZ :  2.01/01 14/11/95  14.46.34  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   29/03/95

      SUBROUTINE MMREAD (LUN, CNAME)

************************************************************************
*
* Description: Read next Zebra record
*
* Called from: anywhere
*
* External references:
*
* Argument in/out description
*   LUN    in     logical unit
*   CNAME  out    name of the header bank; CNAME = 'EOD' :end of data
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"

      INTEGER LUN, IHD, ILN
      CHARACTER CNAME*(*), C4*4

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      IHD = 0

C read next bank identification

 10   CALL MMRTAB (LUN, ILN)
      IF (ILN)  20, 40, 30

C end of data

 20   CNAME = 'EOD'
      GO TO 90

C header record ?

 30   IF (IHD .EQ. 0)  THEN
        CALL CHHTOC (IQ(HQMEMO_NAME(ILN)), C4)
        CNAME = C4
        IHD = ILN
        IF (JLINK(IHD) .NE. 0)  CALL MMDROP (JLINK(IHD))
      END IF

C read data

      CALL MMRDAT (LUN, ILN)
      GO TO 10

C end of record

 40   IF (IHD .EQ. 0)  GO TO 10

C book parallel tables and relations

      CALL MMBOOK (JLINK(IHD), 0)
      CALL MMRUPD (IHD)
      IHD = JLINK(IHD)

 90   END

************************************************************************
* End of MMREAD
************************************************************************
