
      SUBROUTINE QNEXT

************************************************************************
*-- Author :    Olga Igonkina   02.02.1997
*
* Description: process event, skip event in case of ZEBRA errors
*
* Called from: QNEXTE 
*
* External references:
*
* Argument in/out description
*
************************************************************************
      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZQUEST.fi"
#include "arte/ZIOCOM.fi"
#include "auto/MTRA.fi"
#include "auto/MEMO.fi"
#include "arte/ZTELLC.fi"

      INTEGER IEV, LEOD, LOCF
      REAL T

#include "arte/Arte.ff"
#include "auto/MTRA.ff"
#include "auto/MEMO.ff"
c

      IF( MODE.NE.0 )THEN       ! break from ZEBRA

        EVENTOUT = -1           ! do not write old event
        NUMEVT = NUMEVT - 1     ! regenerate event NUMEVT
                                ! EVHD bank should be checked!

        CALL MZNEED(IXEVNT,1,' ')
        C78 = 'QNEXT: ZFATAL error,MODE='
        CALL CH78BI( MODE)
        CALL CH78CC( 'IQUEST(11/12/13)=') 
        CALL CH78BI( IQUEST(11)) 
        CALL CH78CI( IQUEST(12)) 
        CALL CH78CI( IQUEST(13))
        CALL MEMESC( 3924778,ILARGEST,ILARGEST,C78)
        C78 = 'regenerate event'
        CALL ME78AP
        MODE = 0
      ELSE
         IEV = 0               ! counter of block of events
      ENDIF

C            loop over events

C            write and drop old event

 10   IF (JEVHD .NE. 0)  CALL MMWEVT

C check time limit

      CALL TIMEL (T)

C Does anybody understand the following statement? I do NOT (H.A.).

      IF (T .LE. -360000. + TIMELIMIT)
     +  CALL ATSTOP ('STOP: time limit reached')
      CALL TIMEX (T)
      TIMEEMAX = MAX (TIMEEMAX, T - TIMESTOP)
      TIMESTOP = T

      NEVENTS = NEVENTS + 1
      EVENTOUT = 1

C generate next event a la phase space
      IF(PHSPINIT.NE.0) THEN
         CALL PHEVNT

C read next record from event input file ...
      ELSEIF (LUNDINIT .EQ. 0)  THEN
        CALL MMREVT (LEOD)
C no more events ?
        IF (LEOD .LT. 0)  GO TO 90

      ELSE

C ... or generate event

        CALL ALEVNT

      END IF

C print event number etc. in interactive mode

      IF (IBATCH .EQ. 0)  THEN
        CALL LIEVH1
        CALL ME78SP ('T')
      END IF

C user event routine

      CALL USEVNT

      IEV = IEV + 1
      IF (IEV .LT. NEVENTL)  GO TO 10


 90   END

**************************************************************
*     END of QNEXT
**************************************************************
