*CMZ :  2.01/03 07/02/96  18.39.03  by  Hartwig Albrecht
*CMZ :  2.01/02 25/01/96  19.18.52  by  Hartwig Albrecht
*CMZ :  2.01/01 18/12/95  18.50.15  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   01/12/95

      SUBROUTINE TPRELA

************************************************************************
*
* Description: maintain the relation from TOPP to TDEC
*
* Called from: MMREAD
*
* External references: none
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/TOPP.fi"
#include "auto/TOPX.fi"
#include "auto/TDEC.fi"
#include "auto/TDEX.fi"

      INTEGER I, J, L

#include "arte/Arte.ff"
#include "auto/TOPP.ff"
#include "auto/TOPX.ff"
#include "auto/TDEC.ff"
#include "auto/TDEX.ff"

      IF (JTDEC .EQ. 0 .OR. JTOPP .EQ. 0)  GO TO 90

      DO I = 1, NTOPP()
        IQ(IQTOPX_TDEC(I)) = 0
      END DO

      DO I = 1, NTDEC()
        IQ(IQTDEX_NEXT(I)) = 0
      END DO

      DO 30 I = 1, NTDEC()
        IQ(IQTDEX_NEXT(I)) = 0
        J = ITDEC_MOTH(I)
        IF (J .EQ. 0)  GO TO 30
        L = ITOPX_TDEC(J)
        IF (L .EQ. 0)  THEN
          IQ(IQTOPX_TDEC(J)) = I
          GO TO 30
        END IF

C keep the original order of DECAY statements

 10     IF (ITDEX_NEXT(L) .EQ. 0)  GO TO 20
        L = ITDEX_NEXT(L)
        GO TO 10
 20     IQ(IQTDEX_NEXT(L)) = I

 30   CONTINUE

 90   END

************************************************************************
* End of TPRELA
************************************************************************
