*-- Author :    Mauro Villa   12/08/97


      subroutine prrccl()

*     **** print rccl information
      implicit none
      integer id1, id2, jauxmi, ialia, rccl, mcal, rtra, line, lev,
     .           hitc, mtra, code, ii, rseg
      real p
      character*40 name
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITC.fi"
#include "auto/MCAL.fi"
#include "auto/MIMP.fi"
#include "auto/RCCL.fi"
#include "auto/RCLX.fi"
#include "auto/RTRA.fi"
#include "auto/RSEG.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/TOPP.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITC.ff"
#include "auto/MCAL.ff"
#include "auto/MIMP.ff"
#include "auto/RCCL.ff"
#include "auto/RCLX.ff"
#include "auto/RTRA.ff"
#include "auto/RSEG.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/TOPP.ff"

*     **** parameters
      call kugeti(id1)
      call kugeti(id2)
      call kugeti(lev)

*     **** fixup
      if (id1.eq.0) then
         id1 = 1
         if (id2.eq.0) id2 = nrccl()
      else
         if (id2.eq.0) id2 = id1
      endif
	
*     **** loop over range
      id1 = max(id1,1)
      id2 = min(id2,nrccl())

      line = 0
        
      if(JRCCL.NE.0) THEN
    
      do 10 rccl=id1,id2
*        **** loop over associated mcals
         if (mod(line,20).eq.0) then
*           **** print headline
            print '(a6,7a10)',
     +                 'rccl','x','y','E','n','asym','Lemp','lemh'
         endif
         print '(i6,7f10.3)',
     +              rccl,frccl_x(rccl),frccl_y(rccl),
     +              frccl_esum(rccl),frccl_wid(rccl),
     +              frccl_asym(rccl),frccl_lemp(rccl),
     +              frccl_lhad(rccl)
	 if( lev.gt.0) then
*          loop over linked cells
           jauxmi = prclx_hitc(rccl)  
           if(jauxmi.gt.0) then
             print '(30x,a6,a9,3a10)','Hitc','gcal','e','x','y'
  	     do while(jauxmi.gt.0)
	       hitc = mrclx_hitc(jauxmi)
	       print '(30x,i6,i9,3f10.3)',hitc,ihitc_gcal(hitc),
     +                fhitc_q(hitc), fhitc_x(hitc),fhitc_y(hitc)
	       jauxmi = xrclx_hitc(jauxmi)
	     end do
           endif	  
           if( lev.gt.1) then
*            loop over RC linked tracks
             jauxmi = prclx_rtra(rccl)
             if( jauxmi.gt.0) print '(30x,a6,a10)','Rtra','Momentum'
             do while(jauxmi.gt.0)
               rtra = mrclx_rtra(jauxmi)
               print '(30x,i6,f10.3)',rtra,1./frtra_pf(rtra)
               jauxmi = xrclx_rtra(jauxmi)
             end do
*            loop over RC linked SEGments
             jauxmi = prclx_rseg(rccl)
             if( jauxmi.gt.0) print '(30x,a6,a10)','Rseg','Momentum'
             do while(jauxmi.gt.0)
               rseg = mrclx_rseg(jauxmi)
               print '(30x,i6,f10.3)',rseg,1./frseg_pf(rseg)
               jauxmi = xrclx_rseg(jauxmi)
             end do
*            loop over MC linked tracks
             jauxmi = prclx_mtra(rccl)
             if( jauxmi.gt.0) print '(30x,a6,a10, 4x, a12)',
     .               'Mtra','Momentum','Type        '
             do while(jauxmi.gt.0)  
               mtra = mrclx_mtra(jauxmi)
	       p = sqrt(fmtra_px(mtra)*fmtra_px(mtra)+
     .             fmtra_py(mtra)*fmtra_py(mtra)+
     .             fmtra_pz(mtra)*fmtra_pz(mtra))
	       code = omtra_topp(mtra)
	       write(name,'(100a4)') (htopp_name(ii,code),
     .                                ii=1,ntopp_name)               	
               print '(30x,i6,f10.3,4x,a12)',mtra,p,name
               jauxmi = xrclx_mtra(jauxmi)
             end do

           endif
	 endif
         line = line + 1
 10   continue	
      END IF	
 20   print *,' total number of rccl rows:', nrccl()


      end

