/*
*************************************************************************
**
** Description: Default Error reaction for "Cebra Memory Package".
**              Can be overwritten by the upper package.
**
** Language:	C
**
** Called from: CM package.
**
** Created: 	23 Sep 97
** Updated:	11 May 98
**
** Author:  	Sergey Moukhine
**          	HERA-B Collaboration
**          	JINR-Dubna
**          	Russia
**
*************************************************************************
*/

#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "cmbook.h"

void cmerror_(int *errPtr, char *mess)
{
printf("#%-5d %s\n", *errPtr, mess);
exit(1);
}

