#ifndef _GCAL_H_
#define _GCAL_H_
typedef struct {
   int NCL;
   int SEC;
   float XMIN;
   float XMAX;
   float YMIN;
   float YMAX;
   float ZMIN;
   float ZMAX;
   float XMAD;
   float YMAD;
   float ZMAD;
   float EFF;
   float MS;
   int CMP;
   int oGESL;
   int oGMAT;
   char GVOL[4];
} gcal;
#define  JGCAL (gcbank_.iq+artelink_.jgcal)
#define  NGCAL() N_U(JGCAL)
#define NCGCAL() N_C(JGCAL)
#define GCAL(i) (*((gcal*)(JGCAL+2)+(i)-1))
#define GCAL_oGESL(i) GCAL(i).oGESL
#define GCAL_oGMAT(i) GCAL(i).oGMAT
#endif
