#ifndef _GEDE_HH_
#define _GEDE_HH_
struct GEDE {
   int cmp;
   int lay;
   int sec;
   int shp;
   float xmin;
   float xmax;
   float ymin;
   float ymax;
   float zmin;
   float zmax;
   float sxmn;
   float sxmx;
   float symn;
   float symx;
   float cos;
   float sin;
   float rot[9];
   float acc;
   float eff;
   float dod;
   float pit;
   float ms;
   float xfw[4];
   float zfw[4];
   int nwi[4];
   int nsl;
   ArtePointer<GSLX> gesl;
   ArtePointer<GMAX> gmat;
   int nwl;
   int fwl;
   float xmad;
   float ymad;
   float zmad;
   float y1w[4];
   float y2w[4];
   char gvol[4];
};
#include "auto/GSLX.hh"
#include "auto/GSGD.hh"
#include "auto/GMAX.hh"
#include "auto/GMGD.hh"
#include "auto/GEDE.icc"
#endif
