
      SUBROUTINE EBMDAT(CNAME)

************************************************************************
* written by Siegmund Nowak, 16/03/95 09.18.12
*
* Description: Reads ASCII geometry file and stores the data 
*
* called from  PIPGEO
*
* External references: IO..., FF..., ...KEY,
************************************************************************

      IMPLICIT NONE
      INTEGER LENOCC
      CHARACTER*(*) CNAME

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/ZGBPIP.fi"
#include "arte/Arte.ff"

C---             Initialize geo dat input

      CALL GEOPEN(CNAME(1:LENOCC(CNAME)))
      CALL FFINIT(0)

C     set keys for reading PIP data cards by ffread

      CALL FFKEY('EBXY' ,XETUB,  2,'REAL')
      CALL FFKEY('EBDN' ,RNTUB,  2,'REAL')
      CALL FFKEY('EZCO' ,ZCCOIL, 8,'REAL')
      CALL FFKEY('EBDM' ,RVATUB, 7,'REAL')
      CALL FFKEY('EDFT' ,DIFTCH, 1,'REAL')

C     Read in of data cards
      CALL FFSET('LINP',LREAD)
      CALL FFSET('LOUT',LLOGF)
      CALL FFGO
      CALL IOCLOS(LREAD)


 999  RETURN
      END

************************   END    EBMDAT    *****************************




