


      SUBROUTINE MATNUMC(CINP,L,MATNUM)

************************************************************************
*-- Author :    Siegmund Nowak   05/08/96
*
* Description: calculates the material number MATNUM for a material 
*              called CINP. L is the length of CINP. Equivalence 
*              to function MATNUM(CINP) for C++ programmers      
*
* Called from: everywhere
*
* External references:
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/GMAT.fi"
      INTEGER MATNUM,J,L
      CHARACTER*12 CINP,CNAM,CTAB
#include "arte/Arte.ff"
#include "auto/GMAT.ff"

C       convert lower case into upper case and remove blanks

      CNAM(1:L) = CINP
      CALL CLTOU (CNAM)

      IF(L.LT.12) CNAM(L+1:12) = ' '

C       go through material table GMAT

      MATNUM = 0
      DO J = 1, NGMAT()
       CALL CHHTOC (IQ(HQGMAT_NAME(1,J)), CTAB)
       CALL CLTOU (CTAB)
       IF(CTAB .EQ. CNAM)  THEN
          MATNUM = J
          GO TO 99
       ENDIF
      ENDDO
      C78 = 'Material'
      CALL CH78BC(CINP)
      CALL CH78BC('does not exist')
      CALL ME78ER

 99   RETURN
      END

************************************************************************
* End of MATNUM
************************************************************************




