
      SUBROUTINE MEDMAIN

************************************************************************
*-- Author :    Siegmund Nowak 8/96
*
* This routines stores material constants and media for hera-b detector 
* in GEANT banks
*
* called from GEOMAIN
*
************************************************************************

      IMPLICIT NONE

      INTEGER I,K,L,INMIX,IR_MIX,IOS,LENOCC
      REAL AM(10),ZM(10),WM(10),UBUF
      CHARACTER CNAME*12, CNAM*20,  SDIR*80, VERS*20
      LOGICAL EXS

#include "arte/Arte.fi"
#include "auto/GMAT.fi"
#include "auto/GMIX.fi"
#include "auto/TMP0.fi"

#include "arte/Arte.ff"
#include "auto/GMAT.ff"
#include "auto/GMIX.ff"
#include "auto/TMP0.ff"

c     read in  material table gmat

      INQUIRE(FILE='gmat.kumac',EXIST=exs,IOSTAT=IOS)
      CALL KUEXEC('TRACE OFF')
      CALL KUEXEC('SET/ROOT /HBGEAN/GEOM')
      IF (EXS) THEN
         CALL KUEXEC('EXEC gmat')
      ELSE 
         CALL GETENVF('HB',SDIR)
         CALL GETENVF('HBVERS',VERS)
         SDIR = SDIR(1:LENOCC(SDIR))//'/'//VERS(1:LENOCC(VERS))
         CALL KUEXEC('EXEC '//SDIR(1:LENOCC(SDIR))//'/geo/gmat')
      ENDIF
      CALL KUEXEC('SET/ROOT ')

      DO 10 I=1,NGMAT()

      IF(IGMAT_FLAG(I).EQ.0) GO TO 10
      CALL UHTOC (IQ(HQGMAT_NAME(1,I)),4,CNAME,12)
      L = LENOCC(CNAME)
      CNAM(1:L) = CNAME(1:L)
      CNAM(L+1:L+1) = '$'
      CNAM(L+2:20) = ' '
      IF(IGMAT_NMIX(I).LE.1) THEN
         CALL GSMATE(I,CNAM,FGMAT_A(I),FGMAT_Z(I),FGMAT_DENS(I),
     +                       FGMAT_RADL(I),FGMAT_ABSL(I),UBUF,0)
      ELSE
         IR_MIX = IGMAT_GMIX(I) - 1
         INMIX   = IABS(IGMAT_NMIX(I))
         DO K=1,INMIX
         AM(K) = FGMIX_A(IR_MIX+K)
         ZM(K) = FGMIX_Z(IR_MIX+K)
         WM(K) = FGMIX_W(IR_MIX+K)
         ENDDO
         CALL GSMIXT(I,CNAM,AM,ZM,FGMAT_DENS(I),IGMAT_NMIX(I),WM)
      ENDIF



      CALL CRTMED(I,IGMAT_FLAG(I))      

 10   CONTINUE

      RETURN
      END

