*-- Author :
      SUBROUTINE PICOTR
      IMPLICIT NONE
C----------------------
C   To draw a view of one MT superlayer or its components

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/MVOLUM.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
      CHARACTER*4 NAME(4),PERS,NAM
      INTEGER ICOL(8),IFPL,J,K,NUME(4),ISL,LAY,SEC,ISEC,IUCOMP
      REAL X(2), Y(2)
      DATA ICOL /4,4,2,2,4,4,2,2/

#include "arte/Arte.ff"
#include "auto/GEO.ff"

C
      CALL KUGETC(PERS,J)
      CALL KUGETC(NAM,J)
      ISL = IUCOMP(NAM,DEWT,NSLWT)
      IF(ISL.EQ.0) THEN
         PRINT *,'Superlayer ',NAM,' is not a outer tracker chamber'
         GO TO 999
      ENDIF
      NAME(1) = NAM
      NUME(1) = 1

      DO J=1,IQ(JGESL+2)
      IF(IGESL_CMP(J).EQ.LGESL_WCH) THEN
         IF(IGESL_NSL(J).EQ.ISL) GO TO 10
      ENDIF
      ENDDO
      CALL MEWARN( NAM // 'not found among OTR superlayers')
      GO TO 999

 10   CALL KUGETI(LAY)
      CALL KUGETI(SEC)

      IFPL =IGESL_FPL(J)

      do 20 k=1,IGESL_NPL(J)
      IF(IGEDE_LAY(IFPL+K-1).NE.LAY) GO TO 20
      ISEC = IGEDE_SEC(IFPL+K-1)
      IF(SEC.NE.0 .AND. ISEC.NE.SEC) GO TO 20
      CALL UHTOC(HGEDE_GVOL(IFPL+K-1),4,NAM,4)

      CALL GSATT(DEWT(ISL),'SEEN',0)
      CALL GSATT('WTWA','SEEN',0)

      CALL GSATT(NAM,'COLO',1)
      CALL GSATT(NAM,'FILL',1)

      CALL GDOPT('HIDE','OFF ')
      CALL GDOPT('SHAD','ON ')


      IF(NAM.NE.'    ') NAME(2) = NAM
      NUME(2) = IFPL + K - 1
      CALL GDRVOL(2,NAME,NUME,0,0.,90.,0.,10.,10.,.033,.033)
 20   CONTINUE

      call gdcol(1)
      x(1) = 5.
      y(1) = 5.
      x(2) = 15.
      y(2) = 13.
c      CALL GDRAWV(x,y,2)

c      CALL GDRAWT(1.8,12.4,'RPOT with Si',.3,0.,2,0)
c      CALL GDRAWT(4.,8.5,'WT01-05',.3,0.,2,0)
c      CALL GDRAWT(5.,12.6,'Magnet',.3,0.,2,0)
c      CALL GDRAWT(6.2,7.6,'TT01-08',.3,0.,2,0)
c      CALL GDRAWT(10.,13.0,'RICH',.3,0.,2,0)
c      CALL GDRAWT(10.4,6.1,'TC01-02',.3,0.,2,0)
c      CALL GDRAWT(12.8,13.,'CALO',.3,0.,2,0)
c      CALL GDRAWT(13.5,4.5,'MUON System',.3,0.,2,0)
      CALL GDSCAL(10.,2.)
      CALL GDHEAD(1001,'HERA-B  WT-Superlayer',.6)

 999  RETURN
      END




