*CMZ :  3.01/00 19/08/96  18.52.53  by  Siegmund Nowak
*-- Author :    Siegmund Nowak   31/07/96

      FUNCTION TPORIG(ITRA,SPART)

************************************************************************
*
* Description: gives for track ITRA the track number TPORIG if the track
*              TPORIG has the particle name SPART
*
* Called from:
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
      INTEGER TPORIG,TPNAME,ITRA,ICOD,IM
      CHARACTER*(*) SPART
#include "arte/Arte.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"

      TPORIG = 0

      ICOD = TPNAME(SPART)
      IF(ICOD.EQ.0) GO TO 998

      IM = ITRA
 10   CONTINUE
      IF(OMTRA_TOPP(IM).EQ.ICOD) THEN
         TPORIG = IM
         GO TO 999
      ELSE
         IM = OMTRX_BTRA(IM)
         IF(IM.EQ.0) GO TO 999
         GO TO 10
      ENDIF
 999  RETURN
 998  C78 = SPART
      CALL CH78BC('is not a valid particle name')
      CALL ME78WC(7833449)

      END

************************************************************************
* End of TPORIG
************************************************************************
