*CMZ :  2.01/02 26/01/96  19.27.16  by  Hartwig Albrecht
*CMZ :  2.01/01 23/06/95  17.14.14  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   19/05/95

      SUBROUTINE KADREX (IFLAG)

************************************************************************
*
* Description: DRELxx, DINVxx commands
*
* Called from: KADRE1, KADREM, KADIN1, KADINM
*
* External references: KADINI
*
* Arguments: in/out description
*   IFLAG    in     LDDEF_RE1/LDDEF_REM/...
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER L, IFLAG

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      CALL KADZZI (IFLAG)

      CALL KADZZN

      C78 = ' '
      CALL KUGETC (C78, L)
      CALL CH78TH (IQ(L_L(JDDEF_NAM3,JDDEF)), 1)
      IF (L .NE. 4)  THEN
        CALL LIDDE0 (NDDEF(), 'TL')
        CALL MEERRC (193456,
     +    'DD: relation name must consist of exactly 4 characters')
      END IF

      IF (IFLAG .LE. LDDEF_REM)  THEN
        C78 = ' '
        CALL KUGETC (C78, L)
        IF (C78(1:1) .EQ. 'C')  THEN
          IQ(L_L(JDDEF_DIV,JDDEF)) = 1
        ELSE IF (C78(1:1) .EQ. 'E')  THEN
          IQ(L_L(JDDEF_DIV,JDDEF)) = 2
        ELSE
          CALL LIDDE0 (NDDEF(), 'TL')
          CALL MEERRC (85412141, 'DD: Zebra division must be C or E')
        END IF
      END IF

      CALL KADZZC

      IF (IFLAG .LE. LDDEF_REM)  THEN
        C78 = ' '
        CALL KUGETC (C78, L)
        CALL CH78TH (IQ(L_L(JDDEF_NAM2,JDDEF)), 1)
        IF (L .GT. 4)  THEN
          CALL LIDDE0 (NDDEF(), 'TL')
          CALL MEERRC (675765,
     +      'DD: menu names must consist of at most 4 characters')
        END IF
      END IF

      END

************************************************************************
* End of KADREX
************************************************************************
