*CMZ :          02/05/96  13.06.34  by  Hartwig Albrecht
*CMZ :  2.01/02 26/01/96  20.11.28  by  Hartwig Albrecht
*CMZ :  2.01/01 30/11/95  16.41.57  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   16/02/95

      SUBROUTINE KAHBOO

************************************************************************
*
* Description: HBOOK control card
*
* Called from: KUIP
*
* External references: HROPEN, ACCESSF(Cernlib)
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"

      CHARACTER COPT*3
      INTEGER L, LUN, NREC, CHIND1
      LOGICAL ACCESSF, A
      PARAMETER (NREC = 1024)

#include "arte/Arte.ff"

      LUN = IIOCUR(LHIST)
      CIOZEB(LUN) = 'Z'

      C78 = ' '
      CALL KUGETS (C78, L)

      IF (IIOFLG(LUN) .GT. 0 .AND. IIOFLG(LUN) .LE. 3)  THEN
        CALL MEERRC (33,
     +    'HBOOK: Attempt to open a second HBOOK file')
        GO TO 90
      END IF

C construct file name if not explicitely given

      IF (L .EQ. 0)  THEN
        C78 = JOBNAME
        CALL CH78AC ('.hbook')
      END IF

      CALL IOCONC (LUN, C78, 'O', 0)
      A = ACCESSF (C78, 0)

      C78 = ' '
      CALL KUGETC (C78, L)

      IF (A)  THEN
c what is wrong with the following statements ? --H.A.
c        IF (.NOT. ACCESSF (C78, 2))  CALL MEERRC (1234613,
c     +    'HBOOK: no write permission for HBOOK file')
        IF (CHIND1(C78(1:L), 'N') .NE. 0)  CALL MEERRC (1346459,
     +    'HBOOK: file declared as -N (new) but exists already')
        IF (CHIND1(C78(1:L), 'O') .EQ. 0 .AND.
     +      CHIND1(C78(1:L), 'U') .EQ. 0)  CALL MEERRC (7632436,
     +  'HBOOK: file exists; declare -O (overwrite) or -U (update)')
      END IF

      COPT = 'N'

      IF (CHIND1(C78(1:L), 'U') .NE. 0)  THEN
        IF (A)  THEN
          COPT = 'U'
          CALL CHAPPC (CIOZFL(LUN), 'I')
        ELSE
          CALL MEWARC (4156745,
     +      'HBOOK: file declared as -U (update) but does not exist')
        END IF
      END IF

      IF (.NOT. A .AND. CHIND1(C78(1:L), 'O') .NE. 0)
     +  CALL MEWARC (9345745,
     +  'HBOOK: file declared as -O (overwrite) but does not exist')

      IF (CHIND1(C78(1:L), 'X') .NE. 0)  CALL CHAPPC (COPT, 'X')

      CALL MEWARC (8763445, 'OPEN HBOOK file ' // CIONAM(LUN))
      CALL HROPEN
     +     (LUN, 'ARTE', CIONAM(LUN), COPT, NREC, IIOSTA(LUN))

      IF (IIOSTA(LUN) .NE. 0)  THEN
        IF (IIOSTA(LUN) .EQ. -1)  IIOSTA(LUN) = 999
        CALL MEERRC (31,
     +    'HBOOK: file cannot be opened')
        IIOFLG(LUN) = 0
      ELSE
        NIOLEN(LUN) = 1
        IIOFLG(LUN) = 3
        IIOFMT(LUN) = 0
      END IF

 90   END

************************************************************************
* End of KAHBOO
************************************************************************
