*CMZ :  2.01/01 30/11/95  19.28.13  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   18/03/95

      SUBROUTINE KAIOTA

************************************************************************
*
* Description: change iostatus of a bank
*
* Called from: KUIP
*
* External references: MMTFIL, KUIP
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZIOCOM.fi"
#include "auto/MEMO.fi"

      INTEGER I, HBANK
      CHARACTER CBANK*4, CSYM*80

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      CSYM = ' '
      CALL KUGETC (CSYM, I)
      IF (I .EQ. 0)  GO TO 80
      CBANK = ' '
      CALL KUGETC (CBANK, I)
      IF (I .EQ. 0)  GO TO 80
      CALL CHCTOH (CBANK, HBANK, 1)

      DO 10 I = 1, NARLNK
 10   IF (HMEMO_NAME(I) .EQ. HBANK)  GO TO 20
      CALL MEERRC (26,
     +  'BANK: name ' // CBANK // ' is unknown')
      GO TO 90

 20   CALL MMTFIL (JLINK(I), CSYM)
      GO TO 90

 80   CALL MEERRO ('BANK: parameters must not consist of blank spaces')

 90   END

************************************************************************
* End of KAIOTA
************************************************************************
