*CMZ :          23/08/96  17.00.11  by  Unknown
*-- Author :     Ivan Belyaev   05/11/95

      SUBROUTINE L1PREHF( iP , iErr )

************************************************************************
*
* Description:
*
* Called from:
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "l1si/rclink.fi"
#include "l1si/yl1hpt.fi"
#include "l1si/l1clink.fi"
#include "l1si/l1param.fi"
#include "l1si/l1banks.fi"
#include "l1si/l1runpa.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1prcdf.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/l1user.fi"
#include "l1si/rcfdef.fi"
#include "l1si/ydef.fi"

      INTEGER iP , ierr
      INTEGER nMaxCellPerSection
      PARAMETER(nMaxCellPerSection=10000)
      INTEGER iSection,
     &  iHits(L1HITlen,nMaxCellPerSection),
     &  iHitsLayer1( L1HITlen ) ,
     &  iHitsLayer2( L1HITlen ) ,
     &  iHitsLayer3( L1HITlen ) ,
     &  iSection1 , iLay1 , iSe1 , nCells  ,
     &  iCe1 , i  , iCell1 , index1 ,
     &  iCell2 , iLay2 , iSe2 , index2 ,
     &  nCell2 , iCell3 , iLay3 , iSe3 ,
     &  index3 , iCombinations  , nCell3
        INTEGER
     &  iParticle , iHit1 , iHit2 , iHit3 ,
     &  iParticle1 , iParticle2 , iParticle3 ,
     &  NumOfZones , iPre , NestSuperlayer   ,
     &  iZone , iMessageX , iMessageY ,
     &  nMessageX , nMessagey ,
     &  itime, MessPo, iPoPo  , iCharge , iPath ,
     &  NextSuperlayer , JobPo , iVERT , iC1, iC2 ,
     &  iPairFoundPT , iPairFoundMass , iPairFoundEA ,
     &  iPairFoundPTP , iPairFoundEAP , iMIMP, iMTRA,
     &  iSL , iPlate , iPlate1 , iCC1, iCC2,iplate3,
     *   idet, imimps, nSubmitted , nRealSubmitted


      REAL xCell1Start , yCell1Start , zCell1Start ,
     &     xCell2Start , yCell2Start , zCell2Start ,
     &     xCell3Start , yCell3Start , zCell3Start ,
     &     xCell1Size  , yCell1Size  ,
     &     xCell2Size  , yCell2Size  ,
     &     xCell3Size  , yCell3Size  ,
     &     zExtrapolation , R ,
     &     dxTmpMax ,dyTmpMax , zShift ,
     &     xMaxMEssageSize1 , yMaxMessageSize1 ,
     &     xMaxMEssageSize2 , yMaxMessageSize2 ,
     &     xMaxMEssageSize3 , yMaxMessageSize3 ,
     &     Amass , EnergyAsymmetry , AAA ( 2 , 7 ) ,
     &     XTUPLE( 20 )

      CHARACTER*4 CNAME,CHNAMES(20)

      PARAMETER( xMaxMEssageSize1=15.0 ,
     &           yMaxMessageSize1=15.0 ,
     &           xMaxMessageSize2=50.0 ,
     &           yMaxMessageSize2=50.0 ,
     &           xMaxMessageSize3=99.0 ,
     &           yMaxMessageSize3=99.0 ,
     &           zShift = 2.0          )


      LOGICAL HEXIST, lFirst,BAVALID
      INTEGER JBYT,IOD
      EXTERNAL JBYT,HEXIST,BAVALID

c***


      SAVE lFirst

      CHARACTER*10 NameProg

      DATA lFirst /.TRUE./
      DATA CHNAMES / 'IFPT' , 'IFMA' ,'IFEA' ,
     &               'IPPT' , 'IPEA' ,
     &               'FPT1' , 'FPT2' , 'FPT3' ,
     &               'FPC1' , 'FPC4' , 'FTC1' , 'FTC2' ,
     &               'SPT1' , 'SPT2' , 'SPT3' ,
     &               'SPC1' , 'SPC4' , 'STC1' , 'STC2' ,
     &               'DUMM' /
      DATA NameProg /'L1PREHF==>'/

c***
#include "arte/Arte.ff"
#include "l1si/rcfunc.ff"
#include "l1si/yl1hpt.ff"
#include "l1si/ydef.ff"
#include "l1si/l1mesdf.ff"


C
      IF (L1PARprnlev.ge.1) THEN
       WRITE (L1LUNprn,'(A11,'' START '',58(''#''))') NameProg
      END IF
*    Check wether PT trigger is already initialised.


      IF( lFirst )THEN
       IF( JL1CE       .LE. 0  .OR.
     &      JL1SE       .LE. 0  .OR.
     &      JLXCC       .LE. 0  .OR.
     &      lFirst               ) THEN
        WRITE(L1LUNprn,*) NameProg,'PreTrigger initialization...'
        CALL L1hptIN
       ENDIF
        lFirst = .FALSE.
      ENDIF

      IF( JL1CE       .LE. 0 .OR.
     &    JL1SE       .LE. 0 .OR.
     &    JLXCC       .LE. 0 ) THEN
       WRITE(L1LUNprn,*)NameProg,'PreTrigger is not initialised yet!'
       iErr = 1
       RETURN
      ENDIF

C*    Clear pretrigger counter

      IF( BAVALID(JL1PR,0) )CALL MZDROP(IXDIV,JL1PR,'L')
      CALL UTFTAB('L1PR','200I',IOD)
      CALL UTBTAB(IXDIV,JL1PR,JL1PR,1,'L1PR',0,0,100,IOD)


C*    Loop Over all Sections in the 1st Layer

      DO iSection1 = 1 , NL1SE()
       IF( IL1SE_LAY( iSection1 ) .EQ. 1 ) THEN
        iLay1  = IL1SE_LAY( iSection1 )
        iSe1   = IL1SE_SEC( iSection1 )
        nCells = IL1SE_NC ( iSection1 )
        IF( nCells .GT. nMaxCellPerSection ) THEN
         WRITE(L1LUNprn,
     &        '(A11,''Number of cells'',I5,''Larger then'',I5)') 
     &        NameProg,nCells,nMaxCellPerSection 
         nCells = nMaxCellPerSection
        ENDIF
C*      Fetch all Hits from This Section
        CALL L1HiGet( iP , iSe1 , iLay1 , L1RUNcuBX ,
     &                1  , nCells  , iHits )
        DO iCe1 = 1 , nCells
         IF( iHits( L1HITnpo , iCe1 ) .GT. 0 ) THEN
C*        Hit exists!
          DO i = 1 , L1HITlen
           iHitsLayer1( i ) = iHits( i , iCe1 )
          ENDDO
C*        Cell Number
          iCell1 = IL1SE_FC ( iSection1 ) +
     &             iCe1 - 1
          iLay1  = IL1CE_LAY( iCell1 )
          iSe1   = IL1CE_SEC( iCell1 )
c          print *,'L1PREHF=>hit1found:',iCell1,iLay1,iSe1
C*        Look for connections
          index1 = PL1CE_CEL1( iCell1 )
          DO WHILE( index1 .GT. 0 )
C*         Connected Cell
           iCell2     = ML1CE_CEL1( index1 )
C*         Next index
           index1     = XL1CE_CEL1( index1 )
           iSe2       = IL1CE_SEC ( iCell2 )
           iLay2      = IL1CE_LAY ( iCell2 )
           nCell2     = IL1CE_NUM ( iCell2 )
C*         Fetch hit from the given cell
c           print *,'Look for:',iCell2,iLay2,iSe2
           CALL L1HiGet( iP , iSe2 , iLay2 , L1RUncuBX ,
     &                   nCell2 , 1 , iHits )
           IF( iHits( L1HITnpo , 1 ) .GT. 0 ) THEN
C*          Hit exists!
c           print *,'Found hit 2:',iCell2,iLay2,iSe2
            DO i = 1 , L1HITlen
             iHitsLayer2( i ) = iHits( i , 1 )
            ENDDO
            index2 = PL1CE_CEL1( iCell2 )
            DO WHILE( index2 .GT. 0 )
             iCell3     = ML1CE_CEL1( index2 )
C*           Next index
             index2     = XL1CE_CEL1( index2 )
             iSe3       = IL1CE_SEC ( iCell3 )
             iLay3      = IL1CE_LAY ( iCell3 )
             nCell3     = IL1CE_NUM ( iCell3 )
C*           Fetch hit from the given cell
c           print *,'Look for:',iCell3,iLay3,iSe3
             CALL L1HiGet( iP , iSe3 , iLay3 , L1RUncuBX ,
     &                     nCell3 , 1 , iHits )
             IF( iHits( L1HITnpo , 1 ) .GT. 0 ) THEN
c           print *,'Found hit 3:',iCell2,iLay2,iSe2
              DO i = 1 , L1HITlen
               iHitsLayer3( i ) = iHits( i , 1 )
              ENDDO
C*            Hit exists!
C*            Book and Fill the Pretrigger table
              IF(N_F(JL1PR).LT.1)THEN
               CALL UTETAB(IXDIV,JL1PR,50)
              ENDIF
              IQ( JL1PR    +  2 ) = NL1PR() + 1
              IQ(IQL1PR_STAT_L()) = 1
              IQ(IQL1PR_CEL1_L()) = iCell1
              IQ(IQL1PR_CEL2_L()) = iCell2
              IQ(IQL1PR_CEL3_L()) = iCell3
              IQ(IQL1PR_HIT1_L()) = iHitsLayer1( L1HITpos )
              IQ(IQL1PR_HIT2_L()) = iHitsLayer2( L1HITpos )
              IQ(IQL1PR_HIT3_L()) = iHitsLayer3( L1HITpos )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
      ENDDO

C*    Loop over all found combinations
      DO iCombinations = 1 , NL1PR()
C*     Only valid combinations
       IF( IL1PR_STAT( iCombinations ) .GE. 1 )THEN
C*      Cell numbers
        iCell1 = IL1PR_CEL1( iCombinations )
        iCell2 = IL1PR_CEL2( iCombinations )
        iCell3 = IL1PR_CEL3( iCombinations )
C*      Fetch the geometry information
        xCell1Start = FL1CE_X0 ( iCell1 )
        yCell1Start = FL1CE_Y0 ( iCell1 )
        zCell1Start = FL1CE_Z  ( iCell1 )
        xCell1Size  = FL1CE_CSX( iCell1 )
        yCell1Size  = FL1CE_CSY( iCell1 )
        xCell2Start = FL1CE_X0 ( iCell2 )
        yCell2Start = FL1CE_Y0 ( iCell2 )
        zCell2Start = FL1CE_Z  ( iCell2 )
        xCell2Size  = FL1CE_CSX( iCell2 )
        yCell2Size  = FL1CE_CSY( iCell2 )
        xCell3Start = FL1CE_X0 ( iCell3 )
        yCell3Start = FL1CE_Y0 ( iCell3 )
        zCell3Start = FL1CE_Z  ( iCell3 )
        xCell3Size  = FL1CE_CSX( iCell3 )
        yCell3Size  = FL1CE_CSY( iCell3 )
        IF ( L1PARprnlev.gt.0 )    THEN
         WRITE(L1LUNprn,*) 
     &        'L1PREHF==> High Pt pretrigger pads: x0/dx/y0/dy/z'
         WRITE(L1LUNprn,'(3(4f9.2,f9.0/))')
     &   xCell1Start,xCell1Size,yCell1Start,yCell1Size,zCell1Start,    
     &   xCell2Start,xCell2Size,yCell2Start,yCell2Size,zCell2Start,  
     &   xCell3Start,xCell3Size,yCell3Start,yCell3Size,zCell3Start
        ENDIF
C*      The path type
        IF(   ( xCell1Start + 0.5  * xCell1Size ) *
     &        ( zCell2Start + zShift ) /
     &        ( zCell1Start + zShift )    .LE.
     &        ( xCell2Start + 0.5  * xCell2Size
     &                       - 0.25 * xCell2Size ) ) THEN
         IQ(IQL1PR_PATH(iCombinations))=150
        ELSEIF(
     &        ( xCell1Start + 0.5  * xCell1Size ) *
     &        ( zCell2Start + zShift ) /
     &        ( zCell1Start + zShift )    .GE.
     &        ( xCell2Start + 0.5  * xCell2Size
     &                         + 0.25 * xCell2Size ) ) THEN
         IQ(IQL1PR_PATH(iCombinations))=50
        ELSEIF( ABS(
     &        ( xCell1Start + 0.5  * xCell1Size ) *
     &        ( zCell2Start + zShift ) /
     &        ( zCell1Start + zShift )    -
     &        ( xCell2Start + 0.5  * xCell2Size )
     &                    ) .LE. 0.25 * xCell2Size )  THEN
         IQ(IQL1PR_PATH(iCombinations))=100
         IF(  ( xCell1Start + 0.5 * xCell1Size ) *
     &        ( zCell3Start + zShift ) /
     &        ( zCell1Start + zShift )    -
     &        ( xCell3Start + 0.5 * xCell3Size )
     &              .GE. 0.0                       )   THEN
          IQ(IQL1PR_PATH(iCombinations))=99
         ELSE
          IQ(IQL1PR_PATH(iCombinations))=101
         ENDIF
        ELSE
         IQ(IQL1PR_PATH(iCombinations))=0
         WRITE(L1LUNprn,*)NameProg,'a very strange path combination'
         IQ(IQL1PR_STAT(iCombinations))=0
        ENDIF
C*      MC Hit information
        iParticle = 0
        iHit1   = IL1PR_HIT1( iCombinations )
        iHit2   = IL1PR_HIT2( iCombinations )
        iHit3   = IL1PR_HIT3( iCombinations )

        iParticle = 0
        index1        = PL1ME_MTRA(iHit1)
        DO WHILE( index1 .GT. 0 )
         iParticle1   = ML1ME_MTRA(index1)
         index1       = XL1ME_MTRA(index1)
         index2       = PL1ME_MTRA(iHit2)
         DO WHILE( index2 .GT. 0 )
          iParticle2  = ML1ME_MTRA(index2)
          index2      = XL1ME_MTRA(index2)
          index3      = PL1ME_MTRA(iHit3)
          DO WHILE( index3 .GT. 0 )
           iParticle3 = ML1ME_MTRA(index3)
           index3     = XL1ME_MTRA(index3)
           IF( iParticle1 .EQ. iParticle2 .AND.
     &         iParticle1 .EQ. iParticle3 .AND.
     &         iParticle2 .EQ. iParticle3 .AND.
     &         iParticle1 .NE. 0         ) THEN
            iParticle = iParticle1
           ENDIF
          ENDDO
         ENDDO
        ENDDO

        IQ(IQL1PR_MTRA(iCombinations)) = iParticle
C*      Extrapolation
        Q(QL1PR_L1X0(iCombinations)) = xCell1Start
        Q(QL1PR_L2X0(iCombinations)) = xCell2Start
        Q(QL1PR_L3X0(iCombinations)) = xCell3Start
        Q(QL1PR_L1Y0(iCombinations)) = yCell1Start
        Q(QL1PR_L2Y0(iCombinations)) = yCell2Start
        Q(QL1PR_L3Y0(iCombinations)) = yCell3Start
        Q(QL1PR_L1Z (iCombinations)) = zCell1Start
        Q(QL1PR_L2Z (iCombinations)) = zCell2Start
        Q(QL1PR_L3Z (iCombinations)) = zCell3Start
        Q(QL1PR_L1SX(iCombinations)) = xCell1Size
        Q(QL1PR_L2SX(iCombinations)) = xCell2Size
        Q(QL1PR_L3SX(iCombinations)) = xCell3Size
        Q(QL1PR_L1SY(iCombinations)) = yCell1Size
        Q(QL1PR_L2SY(iCombinations)) = yCell2Size
        Q(QL1PR_L3SY(iCombinations)) = yCell3Size
C*      Distance from Beam Pipe
        Q(QL1PR_RDIS(iCombinations)) =
     &   SQRT(
     &   ( xCell1Start + 0.5 * xCell1Size ) *
     &   ( xCell1Start + 0.5 * xCell1Size ) +
     &   ( yCell1Start + 0.5 * yCell1Size ) *
     &   ( yCell1Start + 0.5 * yCell1Size ) )
        NextSuperLayer  =  L1DEFsupTC02
        zExtrapolation  =  T1DETzSup( NextSuperLayer )
        IQ(IQL1PR_ZNUM(iCombinations)) = 0
        CALL l1extHP( iCombinations , zExtrapolation )
       ENDIF
      ENDDO


      GO TO  555
C*    the fllowing lines only needed for
C*    detailed study of the pretrigger efficiency

      iPairFoundPT   = 0
      iPairFoundMass = 0
      iPairFoundEA   = 0

      DO iC1 = 1 ,NL1PR()
       IF(   IL1PR_STAT(iC1) .GE. 1 .AND.
     &       IL1PR_MTRA(iC1) .GE. 1 .AND.
     &       IL1PR_MTRA(iC1) .LE. 2 ) THEN
        IF( SQRT( F_V(1,IL1PR_MTRA(iC1),JMTRA)**2 +
     &            F_V(2,IL1PR_MTRA(iC1),JMTRA)**2 )
     &            .GE. 1.5     )THEN
         DO iC2 = iC1 + 1 , NL1PR()
          IF(   IL1PR_STAT(iC2) .GE. 1 .AND.
     &          IL1PR_MTRA(iC2) .GE. 1 .AND.
     &          IL1PR_MTRA(iC2) .LE. 2 .AND.
     &          IL1PR_MTRA(iC2) .NE.
     &          IL1PR_MTRA(iC1)        ) THEN
           IF( SQRT( F_V(1,IL1PR_MTRA(iC2),JMTRA)**2 +
     &               F_V(2,IL1PR_MTRA(iC2),JMTRA)**2 )
     &              .GE. 1.5     )THEN
            iPairFoundPT = iPairFoundPT+1
            Amass = 2.0*(
     &       SQRT(F_V(1,IL1PR_MTRA(iC1),JMTRA)**2 +
     &            F_V(2,IL1PR_MTRA(iC1),JMTRA)**2 +
     &            F_V(3,IL1PR_MTRA(iC1),JMTRA)**2 ) *
     &       SQRT(F_V(1,IL1PR_MTRA(iC2),JMTRA)**2 +
     &            F_V(2,IL1PR_MTRA(iC2),JMTRA)**2 +
     &            F_V(3,IL1PR_MTRA(iC2),JMTRA)**2 ) )
             Amass = Amass - 2.0 * (
     &            F_V(1,IL1PR_MTRA(iC1),JMTRA) *
     &            F_V(1,IL1PR_MTRA(iC2),JMTRA) +
     &            F_V(2,IL1PR_MTRA(iC1),JMTRA) *
     &            F_V(2,IL1PR_MTRA(iC2),JMTRA) +
     &            F_V(3,IL1PR_MTRA(iC1),JMTRA) *
     &            F_V(3,IL1PR_MTRA(iC2),JMTRA) )
c            PRINT * , ' amass =', amass,sqrt(abs(amass)),
c     & il1pr_mtra(ic1),il1pr_mtra(ic2),
c     & i_v(6,il1pr_mtra(ic1),jmtra),
c     & i_v(6,il1pr_mtra(ic2),jmtra)
            Amass = SQRT( ABS( Amass ) )
            IF( Amass .GT. 4.5 ) THEN
             iPairFoundMass  = iPairFoundMass + 1
             EnergyAsymmetry = ABS(
     &       SQRT(F_V(1,IL1PR_MTRA(iC1),JMTRA)**2 +
     &            F_V(2,IL1PR_MTRA(iC1),JMTRA)**2 +
     &            F_V(3,IL1PR_MTRA(iC1),JMTRA)**2 ) -
     &       SQRT(F_V(1,IL1PR_MTRA(iC2),JMTRA)**2 +
     &            F_V(2,IL1PR_MTRA(iC2),JMTRA)**2 +
     &            F_V(3,IL1PR_MTRA(iC2),JMTRA)**2 ) ) / (
     &       SQRT(F_V(1,IL1PR_MTRA(iC1),JMTRA)**2 +
     &            F_V(2,IL1PR_MTRA(iC1),JMTRA)**2 +
     &            F_V(3,IL1PR_MTRA(iC1),JMTRA)**2 ) +
     &       SQRT(F_V(1,IL1PR_MTRA(iC2),JMTRA)**2 +
     &            F_V(2,IL1PR_MTRA(iC2),JMTRA)**2 +
     &            F_V(3,IL1PR_MTRA(iC2),JMTRA)**2 ) )
             IF( EnergyAsymmetry .LE. 0.5 ) THEN
              iPairFoundEA = iPairFoundEA + 1
             ENDIF
            ENDIF
           ENDIF
          ENDIF
         ENDDO
        ENDIF
       ENDIF
      ENDDO

      CALL HF1( 600 , FLOAT( iPairFoundPT   ) , 1.0 )
      CALL HF1( 601 , FLOAT( iPairFoundMass ) , 1.0 )
      CALL HF1( 602 , FLOAT( iPairFoundEA   ) , 1.0 )

      iPairFoundPTP=0
      iPairFoundEAP=0

      IF(  SQRT( F_V(1,1,JMTRA)**2 +
     &           F_V(2,1,JMTRA)**2 ) .GT. 1.5 ) THEN
       IF( SQRT( F_V(1,2,JMTRA)**2 +
     &           F_V(2,2,JMTRA)**2 ) .GT. 1.5 ) THEN
        iPairFoundPTP=iPairFoundPTP+1
        EnergyAsymmetry = ABS(
     &       SQRT(F_V(1,1,JMTRA)**2 +
     &            F_V(2,1,JMTRA)**2 +
     &            F_V(3,1,JMTRA)**2 ) -
     &       SQRT(F_V(1,2,JMTRA)**2 +
     &            F_V(2,2,JMTRA)**2 +
     &            F_V(3,2,JMTRA)**2 ) ) / (
     &       SQRT(F_V(1,1,JMTRA)**2 +
     &            F_V(2,1,JMTRA)**2 +
     &            F_V(3,1,JMTRA)**2 ) +
     &       SQRT(F_V(1,2,JMTRA)**2 +
     &            F_V(2,2,JMTRA)**2 +
     &            F_V(3,2,JMTRA)**2 ) )
             IF( EnergyAsymmetry .LE. 0.5 ) THEN
              iPairFoundEAP = iPairFoundEAP + 1
             ENDIF

       ENDIF
      ENDIF

       CALL HF1(700,FLOAT(iPairFoundPTP),1.0)
       CALL HF1(701,FLOAT(iPairFoundEAP),1.0)
       DO iMTRA = 1 , 2
        DO iSL = 1 , 7
         AAA( iMTRA , iSL ) = 0.0
        ENDDO
       ENDDO

c       CALL DZVERI('DZVERY const ',IXCONS,'CFLSU')
c       CALL DZVERI('DZVERY cdiv  ',IXDIV,'CFLSU')

       DO iSL = 1 , N_U(JGESL)
        CALL UHTOC(HGESL_NAME(ISL),4,CNAME,4)
        IF( CNAME .EQ. 'PTL1' .OR.
     &      CNAME .EQ. 'PTL2' .OR.
     &      CNAME .EQ. 'PTL3' .OR.
     &      CNAME .EQ. 'TC01' .OR.
     &      CNAME .EQ. 'TC02' .OR.
     &      CNAME .EQ. 'PC01' .OR.
     &      CNAME .EQ. 'PC04' .OR.
     &      CNAME .EQ. 'MS10' .OR.
     &      CNAME .EQ. 'MS13' .OR.
     &      CNAME .EQ. 'MS14' .OR.
     &      CNAME .EQ. 'MS15'      )THEN
         PRINT * , ' isl ' , isl, N_U(JGESL),N_U(JMIMP)
         iCc1=I_V(JGESL_FPL,iSL,JGESL)
         iCc2=I_V(JGESL_NPL,iSL,JGESL)-1+
     &        I_V(JGESL_FPL,iSL,JGESL)
        ipopo = iq(jmimp+2)
c         PRINT *, ' CNAME ::== ' , cNAME,N_U(JGEDE),N_U(JGESL),iCC1,icc2
c     & ,ipopo
         DO iMIMPs = 1 , N_U(JMIMP)
         imimp = imimps
c           IF( FMIMP_Z(iMIMP).LE.1300)THEN
         idet = I_V(JMIMP_GEDE,iMimp,jmimp)
         icc1=I_V(jgesl_fpl,isl,jgesl)
         iCc2=I_V(JGESL_NPL,iSL,JGESL)-1+
     &        I_V(JGESL_FPL,iSL,JGESL)
         imimp = imimps
c          print *, ' det ' ,idet, icc1, icc2
          IF( idet.LE.iCC2.and.
     &        idet.GE.iCC1)THEN
            imimp = imimps
           iMTRA = I_V(JMIMP_MTRA,iMIMP,JMIMP)
c           PRINT * , ' IMTA!!! ' , imimp , imtra,idet
           IF( iMTRA .GE. 1 .AND.
     &         iMTRA .LE. 2 ) THEN
            IF( CNAME .EQ. 'PTL1' )
     &       AAA(iMTRA,1)=AAA(iMTRA,1)+1
            IF( CNAME .EQ. 'PTL2' )
     &       AAA(iMTRA,2)=AAA(iMTRA,2)+1
            IF( CNAME .EQ. 'PTL3' )
     &       AAA(iMTRA,3)=AAA(iMTRA,3)+1
            IF( CNAME .EQ. 'MS10' )
     &       AAA(iMTRA,4)=AAA(iMTRA,4)+1
            IF( CNAME .EQ. 'PC01' )
     &       AAA(iMTRA,4)=AAA(iMTRA,4)+1
            IF( CNAME .EQ. 'MS13' )
     &       AAA(iMTRA,5)=AAA(iMTRA,5)+1
            IF( CNAME .EQ. 'PC04' )
     &       AAA(iMTRA,5)=AAA(iMTRA,5)+1
            IF( CNAME .EQ. 'MS14' )
     &       AAA(iMTRA,6)=AAA(iMTRA,6)+1
            IF( CNAME .EQ. 'TC01' )
     &       AAA(iMTRA,6)=AAA(iMTRA,6)+1
            IF( CNAME .EQ. 'MS15' )
     &       AAA(iMTRA,7)=AAA(iMTRA,7)+1
            IF( CNAME .EQ. 'TC02' )
     &       AAA(iMTRA,7)=AAA(iMTRA,7)+1
           ENDIF
          ENDIF

         ENDDO
        ENDIF
       ENDDO

       XTUPLE( 1 )  = iPairFoundPT
       XTUPLE( 2 )  = iPairFoundMass
       XTUPLE( 3 )  = iPairFoundEA
       XTUPLE( 4 )  = iPairFoundPTP
       XTUPLE( 5 )  = iPairFoundEAP
       XTUPLE( 6 )  = AAA( 1 , 1 )
       XTUPLE( 7 )  = AAA( 1 , 2 )
       XTUPLE( 8 )  = AAA( 1 , 3 )
       XTUPLE( 9 )  = AAA( 1 , 4 )
       XTUPLE( 10 ) = AAA( 1 , 5 )
       XTUPLE( 11 ) = AAA( 1 , 6 )
       XTUPLE( 12 ) = AAA( 1 , 7 )
       XTUPLE( 13 ) = AAA( 2 , 1 )
       XTUPLE( 14 ) = AAA( 2 , 2 )
       XTUPLE( 15 ) = AAA( 2 , 3 )
       XTUPLE( 16 ) = AAA( 2 , 4 )
       XTUPLE( 17 ) = AAA( 2 , 5 )
       XTUPLE( 18 ) = AAA( 2 , 6 )
       XTUPLE( 19 ) = AAA( 2 , 7 )

       CALL HFN( 4000 , XTUPLE )


 555   CONTINUE



C*    Final Loop over all combinations

      nSubmitted = 0
      nRealSubmitted = 0
      DO iCombinations = 1 , NL1PR()
C*     Only valid Combinations
       IF( IL1PR_STAT( iCombinations ) .GE. 1 ) THEN
        DO iZone = 1 , IL1PR_ZNUM( iCombinations)
C*       Loop over zones
         R = SQRT(
     &   (FL1PR_MEX0(iZone,iCOmbinations)+0.5
     &   *FL1PR_MESX(iZone,iCombinations))**2+
     &   (FL1PR_MEY0(iZone,iCOmbinations)+0.5
     &   *FL1PR_MESY(iZone,iCombinations))**2)
         IF(      R .LE.      27.0  )THEN
          nMessageX = FL1PR_MESX(iZone,iCOmbinations)
     &     / xMaxMessageSize1 + 1
          nMessageY = FL1PR_MESY(iZone,iCOmbinations)
     &     / yMaxMessageSize1 + 1
         ELSEIF(  R .LE.      50.0  )THEN
          nMessageX = FL1PR_MESX(iZone,iCOmbinations)
     &     / xMaxMessageSize2 + 1
          nMessageY = FL1PR_MESY(iZone,iCOmbinations)
     &     / yMaxMessageSize2 + 1
         ELSE
          nMessageX = FL1PR_MESX(iZone,iCOmbinations)
     &     / xMaxMessageSize3 + 1
          nMessageY = FL1PR_MESY(iZone,iCOmbinations)
     &     / yMaxMessageSize3 + 1
         ENDIF
         dyTmpMax = FL1PR_MESY(iZone,iCombinations)
     &    / nMessageY
         dxTmpMax = FL1PR_MESX(iZone,iCombinations)
     &    / nMessageX
         DO iMessageX = 1 , nMessagex
          DO iMessageY = 1 , nMessageY
C*         Get new messages
           CALL l1mesne( L1RUNcuBX , MessPo )
           IF ( MessPo .LE. 0 ) THEN
            WRITE (L1LUNprn,*) NameProg,
     &           'message storage exceeded!'
            ierr = 1
            RETURN
           ENDIF
C*         Time after pretrigger
           iTime = L1RUNcuTime + L1DEFhptTim
           L1MEstor( MessPo + L1MElast   ) = 0  ! last point was pretrigger
           L1MEstor(MessPo+L1MEcreated) = 0     ! first point was pretrigger
           L1MEstor( MessPo + L1MEactive ) = L1MEacPRE ! last processed
           L1MEstor( MessPo + L1MEnextPC ) = iP ! set active proc.
C*         Fill soft part of message
           L1MEstor( MessPo + L1MEprid ) = L1PREpipi
           L1MEstor( MessPo + L1MEprBX ) = L1RUNcuBX
           T1MEstor(MessPo+L1MEpren) = 100. ! Some
           T1MEstor(MessPo+L1MEprth) = 2. !reasonable
           T1MEstor(MessPo+L1MEpreth)= 1. ! values (for safety...)
           T1MEstor( MessPo + L1MEpreZpt  ) =
     &             FL1PR_L3Z (iCombinations)
           T1MEstor( MessPo + L1MEpreXpt  ) =
     &             FL1PR_L3X0(iCombinations)
     &     + 0.5 * FL1PR_L3SX(iCombinations)
c           T1MEstor( MessPo + L1MEpreYpt  ) =
c     &             FL1PR_L3Y0(iCombinations)
c     &     + 0.5 * FL1PR_L3SY(iCombinations)
           T1MEstor( MessPo + L1MEpreDXpt ) =
     &       0.5 * FL1PR_L3SX(iCombinations)
c           T1MEstor( MessPo + L1MEpreDYpt ) =
c     &       0.5 * FL1PR_L3SY(iCombinations)
           T1MEstor( MEssPo + L1MEbremPlus  ) = 0.0
           T1MEstor( MEssPo + L1MEbremMinus ) = 0.0
           iPath   = IL1PR_PATH( iCombinations )
           iCharge = 0
           IF(       iPath .EQ.  49   .OR.
     &               iPath .EQ.  51 )THEN
            iCharge = +1
           ELSEIF(   iPath .EQ. 149   .OR.
     &               iPath .EQ. 151 )THEN
            iCharge = -1
           ELSEIF(   iPath .EQ.  99  .AND.
     &               iZone .EQ.   1 )THEN
            iCharge = +1
           ELSEIF(   iPath .EQ.  99  .AND.
     &               iZone .EQ.   2 )THEN
            iCharge = -1
           ELSEIF(   iPath .EQ. 101  .AND.
     &               iZone .EQ.   1 )THEN
            iCharge = -1
           ELSEIF(   iPath .EQ. 101  .AND.
     &               iZone .EQ.   2 )THEN
            iCharge = +1
           ELSE
            WRITE (L1LUNprn,*) NameProg,
     &           'Wrong iPath,iZone',iPath,iZone
           ENDIF
           L1MEstor( MEssPo + L1HAcharge )
     &           = iCharge
C*
           iPoPo = MessPo + L1MEpoint( 0 )
C*
           L1MEstor( iPoPo + L1POpcpo ) = iP
           L1MEstor( iPoPo + L1POtrkn ) = 0
           L1MEstor( iPoPo + L1POtrk0 ) = 0
           L1MEstor( iPoPo + L1POtrkp ) = 0
           L1MEstor( iPoPo + L1POsup  ) =
     &                       L1DEFsupPTL3
           L1MEstor( iPoPo + L1POtime ) = iTime
C*
           iPoPo = iPoPo + L1POreg
C*
           T1MEstor( iPoPo + L1GEOINFz  ) =
     &      FL1PR_MEZ (iZone,iCombinations)
           T1MEstor( iPoPo + L1GEOINFx0 ) =
     &      FL1PR_MEX0(iZone,iCombinations)
     &     +(iMessageX-1)*dxTmpMax
           T1MEstor( iPoPo + L1GEOINFy0 ) =
     &      FL1PR_MEY0(iZone,iCombinations)
     &     +(iMessageY-1)*dyTmpMax
           T1MEstor( iPoPo + L1GEOINFsx ) =
     &      dxTmpMax
           T1MEstor( iPoPo + L1GEOINFsy ) =
     &      dyTmpMax
C*         Hardware part
           L1MEstor( MessPo + L1HAprbx ) =
     &                   L1RUNcuBX
           L1MESTOR( MEssPo + L1HAprid ) =
     &                   L1PREpipi
C* ????
           T1MEstor( MessPo + L1HAtxi    ) =
     &      T1MEstor( iPoPo + L1GEOINFx0 ) +
     &      T1MEstor( iPoPo + L1GEOINFsx ) / 2
           T1MEstor( MessPo + L1HAteta   ) =
     &      T1MEstor( iPoPo + L1GEOINFy0 ) +
     &      T1MEstor( iPoPo + L1GEOINFsy ) / 2
C*         Fill P.Pakhlov ntuple
           IF( HEXIST( L1PPTTUPnr ) ) THEN
C*          Fill the Dr.P.Pakhlov PteTrigger Table
            L1PPTTUPiEvent=I_V(L1GI_I_NBX,1,JL1GI)
            L1PPTTUPiHitPattern  = IL1PR_PATH(iCombinations)
            L1PPTTUPiParticle    = IL1PR_MTRA(iCOmbinations)
            T1PPTTUPPreTriggerZ  = FL1PR_L3Z (iCombinations)
            T1PPTTUPPreTriggerX  = FL1PR_L3X0(iCombinations)
            T1PPTTUPPreTriggerY  = FL1PR_L3Y0(iCombinations)
            T1PPTTUPPreTriggerDX = FL1PR_L3SX(iCombinations)
            T1PPTTUPPreTriggerDY = FL1PR_L3SY(iCombinations)
            T1PPTTUPMessageZ     =
     &                       FL1PR_MEZ (iZone,iCombinations)
            T1PPTTUPMessageX     =
     &                       FL1PR_MEX0(iZone,iCombinations)
            T1PPTTUPMessageY     =
     &                       FL1PR_MEY0(iZone,iCombinations)
            T1PPTTUPMessageDX     =
     &                       FL1PR_MESX(iZone,iCombinations)
            T1PPTTUPMessageDY     =
     &                       FL1PR_MESY(iZone,iCombinations)
            IF( L1PPTTUPiParticle .NE. 0 )THEN
             L1PPTTUPParticleID = I_V( 6 ,
     &                            L1PPTTUPiParticle , JMTRA )
             T1PPTTUPParticlePx = F_V( 1 ,
     &                            L1PPTTUPiParticle , JMTRA )
             T1PPTTUPParticlePy = F_V( 2 ,
     &                            L1PPTTUPiParticle , JMTRA )
             T1PPTTUPParticlePz = F_V( 3 ,
     &                            L1PPTTUPiParticle , JMTRA )
             iVERT              = I_V( 7 ,
     &                            L1PPTTUPiParticle , JMTRA )
             IF( iVERT .NE. 0 )THEN
              T1PPTTUPParticleVx = F_V( 1 , iVERT , JMVER )
              T1PPTTUPParticleVy = F_V( 2 , iVERT , JMVER )
              T1PPTTUPParticleVz = F_V( 3 , iVERT , JMVER )
             ELSE
              T1PPTTUPParticleVx = -100.0
              T1PPTTUPParticleVy = -100.0
              T1PPTTUPParticleVz = -20.0
             ENDIF
            ELSE
             L1PPTTUPParticleID =   0
             T1PPTTUPParticlePx = 0.0
             T1PPTTUPParticlePy = 0.0
             T1PPTTUPParticlePz = 0.0
            ENDIF
            CALL HFNT( L1PPTTUPnr )
           ENDIF
C*         Update message
           CALL l1mesup( MessPo , iTime , ierr ) ! update message (get ROI(s))
           IF( ierr .GE. 2 ) THEN
            WRITE (L1LUNprn,*) NameProg,
     &           'fatal error from l1mesup!'
            RETURN
           ENDIF
           IF( ierr .eq. 1 ) THEN
            WRITE (L1LUNprn,*) NameProg,
     &           'CONNECTION ERROR! x0,y0,sx,sy',
     &           T1MEstor( iPoPo + L1GEOINFx0 ) ,
     &           T1MEstor( iPoPo + L1GEOINFy0 ) ,
     &           T1MEstor( iPoPo + L1GEOINFsx ) ,
     &           T1MEstor( iPoPo + L1GEOINFsy )
            CALL l1mesde(MessPo,L1MEDEnoscr)
            ierr = 0
           ELSE
C*          Submit Job
            CALL L1JOBSB( MessPo , iTime , JobPo )
            nSubmitted = nSubmitted + 1
            IF( IL1PR_MTRA( iCombinations) .GE. 1 ) THEN
             nSubmitted = nRealSubmitted + 1
            ENDIF
            IF( L1PARprnlev .GE. 1 )THEN
            WRITE (L1LUNprn,*) NameProg,
     &           'Job Sumbitted!'
            ENDIF
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDIF
      ENDDO

      CALL HF1( 800 , FLOAT( nSubmitted ) , 1.0 )
      CALL Hf1( 801 , FLOAT( nRealSubmitted ) , 1.0 )
      RETURN

      END

************************************************************************
* End of L1PREHF
************************************************************************




