*CMZ :  2.01/01 14/11/95  20.37.50  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   05/04/95

      SUBROUTINE KALROW

************************************************************************
*
* Description: List array Q/IQ
*
* Called from: KUIP
*
* External references: LIZEBR
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEMO.fi"

      INTEGER HN,IT,IR1,IR2,IC,L
      CHARACTER CTPL*3, CN*10

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

      CN = ' '
      CALL KUGETC (CN, L)
      IF (L .EQ. 0)  THEN
        CALL MEWARC (903465, 'LROW: give a bank name!')
        GO TO 90
      END IF

      IR1 = 0
      CALL KUGETI (IR1)
      IC = 0
      CALL KUGETI (IC)
      CALL KUGETC (CTPL, L)

      CALL CHCTOH (CN, HN, 1)
      DO 10 IT = 1, NARLNK
 10   IF (HMEMO_NAME(IT) .EQ. HN)  GO TO 20
      CALL MEWARC (2346576,
     +  'LROW: bank name ' // CN(1:4) // ' is unknown')
      GO TO 90

 20   IT = JLINK(IT)
      IF (IT .EQ. 0)  THEN
        CALL MEWARC (93456123,
     +    'LROW: bank ' // CN(1:4) // ' is not booked')
        GO TO 90
      END IF

      IF (IQ(IT+2) .EQ. 0)  THEN
        CALL MEWARC (134765, 'LROW: table is empty')
        GO TO 90
      END IF

      IF (IR1 .EQ. 0)  THEN
        IR1 = 1
        IR2 = IQ(IT+2)
      ELSE
        IR2 = IR1
      END IF

      IF (IR2 .GT. IQ(IT+2))  THEN
        C78 = 'LROW: only'
        CALL CH78BI (IQ(IT+2))
        CALL CH78BC ('rows are booked')
        CALL ME78WC (1453434)
        GO TO 90
      END IF

      IF (IC .EQ. 0)  IC = IQ(IT+1)

      DO 30 L = IR1, IR2
 30   CALL LIZEBR (IT+(L-1)*IQ(IT+1)+3, IT+(L-1)*IQ(IT+1)+2+IC, CTPL)

 90   END

************************************************************************
* End of KALROW
************************************************************************
