*CMZ :  4.06/02 22/08/96  21.09.10  by  Rainer Mankel
*CMZ :  4.05/01 08/05/96  14.37.56  by  Rainer Mankel
*CMZ :  4.04/01 26/03/96  14.56.35  by  Rainer Mankel
*CMZ :  4.03/03 27/11/95  13.50.35  by  Rainer Mankel
*CMZ :  4.03/00 13/07/95  16.26.43  by  Rainer Mankel
*CMZ :  4.02/00 11/07/95  13.54.37  by  Rainer Mankel
*-- Author :    Rainer Mankel   08/05/95

      subroutine prtrac()

*     **** print MC particle bank
*     **** called by KUIP

      implicit none
#include "arte/Arte.fi"
      integer it, it1, it2, nt, mimp, mimp_close, mc, nch, ii, jj, idmc,
     +  mc_rel, jaux, n_df
      real dz, dz_close, fracmc, p_inv, p_rc, prob
      character*1 cresp
      character*40 chopt
#include "auto/RTRA.fi"
#include "auto/RTRX.fi"
#include "auto/MIMP.fi"
#include "pris/zmpack.fi"

#include "arte/Arte.ff"
#include "auto/RTRA.ff"
#include "auto/RTRX.ff"
#include "auto/MIMP.ff"

*     **** number of selected track
      call kugeti(it1)
      call kugeti(it2)
      call kugeti(idmc)
      call kugetc(chopt,nch)

*     **** fixup
      if (jrtra.le.0) then
         call mewarn('prtrac: table RTRA is not booked')
         go to 999
      endif

      if (it2.eq.0) it2 = it1
      if (it1.eq.0) then
       it1 = 1
       it2 = iq(jrtra+2)
      endif
      it1 = max(1,it1)
      it2 = min(it2,iq(jrtra+2))

      nt = 0
      do 10 it=it1,it2
         mc_rel = 0
         if (prtrx_mtra(it).gt.0) then
            jaux = prtrx_mtra(it)
            if (jaux.gt.0) then ! associated MC exists
               if (xrtrx_mtra(jaux).eq.0) then ! unambiguous
                  mc_rel = mrtrx_mtra(jaux)
               endif
            endif
         endif

         if (idmc.ne.0) then    ! locate MC particle
            if (idmc.ne.mc_rel) go to 10
         endif

         if (frtra_pf(it).ne.0.) then
            p_rc = 1./frtra_pf(it)
         else
            p_rc = 0.
         endif

         if (irtra_fit(it).le.1) then
            n_df = irtra_hou(it)- 4
         else
            n_df = irtra_hou(it) - 5
         endif
         n_df = max0(n_df,1)

         nt = nt + 1

*        **** header
         if (nt.eq.1.or.index(chopt,'M').gt.0)
     +        write(* ,'(a4,5a8,a10,a10,5a4,2a8,a6)')
     +        'it','zf','xf','yf','txf','tyf','1/p','p','hsi','hin',
     +        'hou','hmu','fit','ch2','prb','mc'
         write(* ,'(i4,5f8.2,e10.2,f10.3,5i4,f8.2,f8.4,i6)')
     +        it,frtra_zf(it),frtra_xf(it),frtra_yf(it),frtra_txf(it),
     +        frtra_tyf(it),frtra_pf(it), p_rc, irtra_hsi(it),
     +        irtra_hin(it), irtra_hou(it),irtra_hmu(it),irtra_fit(it),
     +        frtra_chi(it),prob(frtra_chi(it),n_df),mc_rel
         if (index(chopt,'C').gt.0) then
*           **** print cov matrix
            write(*,101)
     +           ((frtra_cvf(matrix_pack(ii,jj),it),jj=ii,5),ii=1,5)
 101        format(12x,5e10.2/12x,10x,4e10.2/12x,20x,3e10.2
     +           /12x,30x,2e10.2/12x,40x,1e10.2)
         endif

         if (index(chopt,'M').gt.0) then
*           **** find MC match
            call turemc(it,mc,fracmc)
            if (mc.gt.0.and.fracmc.gt.0.7) then
*              **** locate closest mimp
               dz_close = 999999.
               mimp_close = 0
               do mimp=1,iq(jmimp+2)
                  if (omimp_mtra(mimp).eq.mc) then
                     dz = abs( frtra_zf(it) - fmimp_z(mimp) )
                     if (dz.lt.dz_close) then
                        mimp_close = mimp
                        dz_close = dz
                     endif
                  endif
               enddo
               if (mimp_close.eq.0.or.dz_close.gt.20.) then
                  print *,' () prtrac: no close mimp for rc=', it,
     +                 ' mc=', mc
               else
                  dz = frtra_zf(it) - fmimp_z(mimp_close)
                  write(*,'(4x,5a8,2a10,2a6)')
     +                 'z','x','y','tx','ty','1/p','p','mc','mimp'
                  if (fmimp_p(mimp_close).ne.0.) then
                     p_inv = 1. / fmimp_p(mimp_close)
                  else
                     p_inv = 0.
                  endif
                  write(*,'(4x,5f8.2,e10.2,f10.3,2i6,(a))')
     +                 fmimp_z(mimp_close), fmimp_x(mimp_close),
     +                 fmimp_y(mimp_close), fmimp_tx(mimp_close),
     +                 fmimp_ty(mimp_close), p_inv, fmimp_p(mimp_close),
     +                 omimp_mtra(mimp_close), mimp_close,
     +                 ' <----- match'
               endif
            endif
            write(*,'(2(a))')
     +           '===========================================',
     +           '======================================='
         endif
         if (mod(nt,100).eq.0) then
            print *,' <any key to continue>'
            read(*,'(a1)') cresp
            if (cresp.eq.'q'.or.cresp.eq.'Q') go to 999
         endif
 10   continue

 999  end
