*-- Author :    Rainer Mankel   04/08/95

      subroutine diassc()

*     **** assign color index to object class
*     **** to be called by KUIP
      implicit none
#include "pris/zgraf.fi"
#include "arte/ArteFlag.fi"
      character*10 object
      integer nch, color, jcol, ii

      if (prisinit.eq.0) call dicinit() ! automatic initialization

      call kugetc(object,nch)
      call kugeti(color)

      if (object.eq.' ') then
       call dicolist('LOQ','square fill in LOGO',coloqzg)
       call dicolist('LTV','triangle fill in LOGO',coltvzg)
       call dicolist('LCV','circle fill in LOGO',colcvzg)
       call dicolist('DIS','display box fill',codiszg)
       call dicolist('TXT','text and axes',cotxtzg)
       call dicolist('WIR','wires, pads & pixels',cowirzg)
       call dicolist('MC ','MC particles',comczg)
       call dicolist('MIM','Monte Carlo impact points',comimzg)
       call dicolist('RC ','RC particles',corczg)
       call dicolist('CIR','isochrones ',cocirzg)
       call dicolist('MAV','magnet volume',comavzg)
       call dicolist('MAB','magnet border',comabzg)
       call dicolist('RIV','RICH volume',corivzg)
       call dicolist('RIB','RICH border',coribzg)
       call dicolist('PLV','plane volume',coplvzg)
       call dicolist('PLB','plane border',coplbzg)
       call dicolist('WAV','wall volume',cowavzg)
       call dicolist('WAB','wall border',cowabzg)
       call dicolist('CA1','ECAL energy 1',coca1zg)
       call dicolist('CA2','ECAL energy 2',coca2zg)
       call dicolist('CA3','ECAL energy 3',coca3zg)
       call dicolist('CA4','ECAL energy 4',coca4zg)
       call dicolist('CA5','ECAL energy 5',coca5zg)
       call dicolist('BAC','background',cobaczg)
       call dicolist('RS ','RC segments',corszg)
       call dicolist('CEV','cell volume',cocevzg)
       call dicolist('CEB','cell border',cocebzg)
       call dicolist('TAR','target',cotarzg)
       go to 999
      endif

*     **** here we might check if color is defined at all
      if (color.lt.0) then
       print *,' () diassc: bad colour,', color
       go to 999
      elseif (color.gt.7) then  ! check if color is defined
         jcol = 0
         do ii=1,ncolzg
            if (jcolzg(ii).eq.color) go to 11
         enddo
         print *,' () diassc: colour ', color,' undefined'
 11      continue
      endif

      if     (object.eq.'LOQ') then
       coloqzg = color
      elseif (object.eq.'LTV') then
       coltvzg = color
      elseif (object.eq.'LCV') then
       colcvzg = color
      elseif (object.eq.'DIS') then
       codiszg = color
      elseif (object.eq.'TXT') then
       cotxtzg = color
      elseif (object.eq.'WIR') then
       cowirzg = color
      elseif (object.eq.'MC') then
       comczg = color
      elseif (object.eq.'MIM') then
       comimzg = color
      elseif (object.eq.'RC') then
       corczg = color
      elseif (object.eq.'CIR') then
       cocirzg = color
      elseif (object.eq.'MAV') then
       comavzg = color
      elseif (object.eq.'MAB') then
       comabzg = color
      elseif (object.eq.'RIV') then
       corivzg = color
      elseif (object.eq.'RIB') then
       coribzg = color
      elseif (object.eq.'PLV') then
       coplvzg = color
      elseif (object.eq.'PLB') then
       coplbzg = color
      elseif (object.eq.'WAV') then
       cowavzg = color
      elseif (object.eq.'WAB') then
       cowabzg = color
      elseif (object.eq.'CA1') then
       coca1zg = color
      elseif (object.eq.'CA2') then
       coca2zg = color
      elseif (object.eq.'CA3') then
       coca3zg = color
      elseif (object.eq.'CA4') then
       coca4zg = color
      elseif (object.eq.'CA5') then
       coca5zg = color
      elseif (object.eq.'BAC') then
       cobaczg = color
      elseif (object.eq.'RS ') then
       corszg = color
      elseif (object.eq.'CEV') then
       cocevzg = color
      elseif (object.eq.'CEB') then
       cocebzg = color
      elseif (object.eq.'TAR') then
       cotarzg = color
      else
       print *,' () diassc: invalid object, ', object
      endif

 999  end
