*CMZ :  4.05/00 12/04/96  10.02.08  by  Rainer Mankel
*CMZ :  4.04/01 21/03/96  13.40.38  by  Rainer Mankel
*CMZ :  4.04/00 03/01/96  13.54.14  by  Rainer Mankel
*CMZ :  4.02/00 08/06/95  19.47.51  by  Rainer Mankel
*CMZ :  3.01/00 14/01/95  16.56.12  by  Rainer Mankel
*CMZ :  2.02/07 10/02/94  14.10.58  by  Rainer Mankel
*CMZ :  2.01/05 01/02/94  16.49.56  by  Rainer Mankel
*CMZ :  2.00/05 21/01/94  12.10.02  by  Rainer Mankel
*CMZ :  2.00/00 08/01/94  14.50.23  by  Rainer Mankel
*CMZU:  1.06/00 04/11/93  14.48.17  by  Rainer Mankel
*CMZ :  1.00/00 04/08/93  11.29.40  by  Rainer Mankel
*-- Author :    Rainer Mankel   28/07/93


      subroutine difram()

      implicit none
#include "pris/zgraf.fi"
#include "arte/ArteFlag.fi"
*     **** define frame
*     **** called by kuip
      character*40 chopt
      real x1, x2, y1, y2, xlow, xhigh, ylow, yhigh, xmid, ymid, xwid,
     +     ywid
      integer nch, istat, nt

      if (prisinit.eq.0) call dicinit() ! automatic initialization

*     **** frame bounds
      call kugetr(x1)
      call kugetr(x2)
      call kugetr(y1)
      call kugetr(y2)
*     **** options
      call kugetc(chopt,nch)

      if (x1.ne.0..or.x2.ne.0.) then
       istat = 1
       go to 100
      endif

      if (index(chopt,'R').gt.0) then
*      **** option R: just reset to standard window
       iframzg = 1
*      **** normalize boundaries depending on viewing angles
       call difrno()
       if (index(chopt,'N').eq.0) call didraw() !  redraw the picture
       go to 999
      endif

      if (index(chopt,'I').gt.0) then ! zoom in
         xmid = 0.5 * (x1zg + x2zg)
         ymid = 0.5 * (y1zg + y2zg)
         xwid = 0.5 * abs(x2zg - x1zg)
         ywid = 0.5 * abs(y2zg - y1zg)
         x1zg = xmid - 0.5 * xwid
         x2zg = xmid + 0.5 * xwid
         y1zg = ymid - 0.5 * ywid
         y2zg = ymid + 0.5 * ywid
         call difrset()
         ntzg = 1
         if (index(chopt,'N').eq.0) call didraw() !  redraw the picture
         go to 999
      endif

      if (index(chopt,'O').gt.0) then ! zoom out
         xmid = 0.5 * (x1zg + x2zg)
         ymid = 0.5 * (y1zg + y2zg)
         xwid = 0.5 * abs(x2zg - x1zg)
         ywid = 0.5 * abs(y2zg - y1zg)
         x1zg = xmid - 2.0 * xwid
         x2zg = xmid + 2.0 * xwid
         y1zg = ymid - 2.0 * ywid
         y2zg = ymid + 2.0 * ywid
         call difrset()
         ntzg = 1
         if (index(chopt,'N').eq.0) call didraw() !  redraw the picture
         go to 999
      endif

*     **** input new window boundaries via rubberband
      call igsa(1)
      print *,' use rubberband to select boundaries '
      call igsg(1)
      call iuwk(0,1)
      nt = nt_framzg
      call igloc2(1,nt,x1,y1,x2,y2,istat,'P')
      call igsa(1)
**      print *,' difram: locator returns nt,x1,y1,x2,y2,istat=',
**     +     nt,x1,y1,x2,y2,istat

      if (nt.le.0) then
       print *,' () difram: outside of borders ... please try again '
       print *,' nt=', nt
       go to 999
      endif

*     **** interpretation of borders
 100  continue
      xlow  = amin1(x1,x2)
      xhigh = amax1(x1,x2)
      ylow  = amin1(y1,y2)
      yhigh = amax1(y1,y2)

      if (istat.ne.1.or.xlow.ge.xhigh.or.ylow.ge.yhigh) then
       print *,' () difram: terminates due to error'
       go to 999
      endif

      x1zg = xlow
      x2zg = xhigh
      y1zg = ylow
      y2zg = yhigh
      call difrset()
      ntzg = 1

      if (index(chopt,'N').eq.0) call didraw() !  redraw the picture

 999  end







