*CMZ :  4.05/03 30/05/96  17.49.05  by  Rainer Mankel
*CMZ :  4.05/00 09/04/96  18.33.25  by  Rainer Mankel
*CMZ :  4.04/01 26/03/96  15.00.17  by  Rainer Mankel
*CMZ :  4.04/00 03/01/96  19.17.26  by  Rainer Mankel
*CMZ :  4.03/03 06/12/95  18.42.55  by  Rainer Mankel
*CMZ :  4.03/01 04/08/95  15.05.45  by  Rainer Mankel
*CMZ :  4.03/00 24/07/95  16.35.17  by  Rainer Mankel
*CMZ :  4.02/00 23/05/95  17.12.37  by  Rainer Mankel
*CMZ :  4.00/00 02/04/95  20.15.14  by  Rainer Mankel
*CMZ :  3.01/00 14/01/95  16.04.31  by  Rainer Mankel
*CMZ :  2.09/00 19/09/94  16.39.06  by  Rainer Mankel
*CMZ :  2.03/02 23/03/94  11.49.00  by  Rainer Mankel
*CMZ :  2.00/00 06/01/94  15.03.31  by  Rainer Mankel
*CMZU:  1.06/00 08/11/93  08.45.29  by  Rainer Mankel
*CMZ :  1.03/00 29/10/93  17.34.04  by  Siegmund Nowak
*CMZ :  1.00/00 27/07/93  14.37.41  by  Rainer Mankel
*-- Author : Rainer Mankel

      subroutine dighit(isl,iplan,idmc,chopt)

*     **** draw the GEANT hits (mimps)
      implicit none
      integer isl, iplan, idmc, imc, mimp, iimark, rc, jaux
      character*(*) chopt
      character*10 clabel

#include "pris/zmh.fi"
#include "arte/Arte.fi"

#include "pris/zgraf.fi"

      real*4 xxx(1), yyy(1), wcm(3)
#include "auto/GEO.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"

      if (iplan.le.0.or.iplan.gt.iq(jgede+2)) then
         print *,' () dighit: iplan=',iplan
         go to 999
      endif

      if (igept_mim1(iplan).le.0.or.igept_mimL(iplan).le.0) go to 999

      call igset('PMCI',comimzg)
      iimark = 20

      call ismk(iimark)
      call igset('MSCF',1.)      ! Scale factor
      call igset('PLCI',comimzg) ! Color
      call igset('PMCI',comimzg) ! Color

      do 30 mimp=igept_mim1(iplan),igept_mimL(iplan) ! loop over mimps
                                                       ! in plane
         if (imimp_gede(mimp).ne.iplan) go to 30
         imc = omimp_mtra(mimp) ! check MC particle
         if (idmc.gt.0.and.imc.ne.idmc) go to 30

         if (lb0zg .or. index(chopt,'B').gt.0) then ! check B0 option
            if (imc.eq.0) go to 30
            if (.not.gold_mh(imc)) go to 30
         endif

         if (index(chopt,'R').gt.0) then ! check ref option
            if (imc.eq.0) go to 30
            if (.not.ref_mh(imc)) go to 30
         endif

         wcm(1) = fmimp_x(mimp) ! hit coordinates
         wcm(2) = fmimp_y(mimp)
         wcm(3) = fmimp_z(mimp)

         call dipro(wcm,xxx(1),yyy(1)) ! projection

         if (xxx(1).lt.xminzg.or.xxx(1).gt.xmaxzg) go to 30 ! visible?
         if (yyy(1).lt.yminzg.or.yyy(1).gt.ymaxzg) go to 30 !

         call ipm(1,xxx,yyy)

         if (index(chopt,'N').gt.0) then ! MC identifier option
            
            call istxfp(0,2)
            call ischh(1.5 * uyzg)
            call igset('PASS',1.)
            call istxal(0,3)

            if (pmtrx_rtra(imc).gt.0) then ! determine (1st) rec track
               jaux = pmtrx_rtra(imc)
               rc = mmtrx_rtra(jaux)
            else
               rc = 0
            endif

            if (rc.ne.0) then
               write(clabel,'(i5,''('',i3,'')'')') imc, rc
            else
               write(clabel,'(i5)') imc
            endif

            if (rc.ne.0) then
               call difclr(xxx(1)+2.*uxzg,xxx(1)+2.*uxzg+10.*uxzg,
     +              yyy(1)-0.75*uyzg,yyy(1)+0.75*uyzg)
               call itx(xxx(1)+2.*uxzg,yyy(1),clabel(1:10))
            else
               call difclr(xxx(1)+2.*uxzg,xxx(1)+2.*uxzg+ 5.*uxzg,
     +              yyy(1)-0.75*uyzg,yyy(1)+0.75*uyzg)
               call itx(xxx(1)+2.*uxzg,yyy(1),clabel(1:5))
            endif
        
         endif

 30   continue

 999  end





