*CMZ :  4.02/00 19/07/96  13.56.47  by  Rainer Mankel
*CMZ :  4.01/01 25/02/96  20.53.02  by  Rainer Mankel
*CMZ :  4.01/00 19/01/96  10.51.42  by  Rainer Mankel
*CMZ :  4.00/01 25/07/95  17.43.30  by  Rainer Mankel
*CMZ :  4.00/00 11/07/95  17.06.59  by  Rainer Mankel
*-- Author :    Rainer Mankel   10/07/95

      subroutine tfedit()

*     **** edit geometry banks before first event
      implicit none
      integer ipl, ii, ih, wall, nrich

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"

*     **** loop over planes
      do 10 ipl=1,iq(jgede+2)
#ifdef SPECIAL
*        **** set rad thickness for MSGC
         if (igede_cmp(ipl).eq.3) then
            if (fgede_ms(ipl).eq.0.) then
               if (igede_nsl(ipl).le.1) then
                  q(jgede+2+(ipl-1)*iq(jgede+1) + jgede_ms) = 0.6750e-6
               elseif (igede_nsl(ipl).eq.2) then
                  q(jgede+2+(ipl-1)*iq(jgede+1) + jgede_ms)
     +                 = 2.*0.6750e-6
               else
                  q(jgede+2+(ipl-1)*iq(jgede+1) + jgede_ms)
     +                 = 2.*0.6750e-6
                  print *,' () tfedit: ipl, nsl=', ipl, igede_nsl(ipl)
               endif
            endif
         elseif (igede_cmp(ipl).eq.1) then ! adjust Si thickness
            q(jgede+2+(ipl-1)*iq(jgede+1) + jgede_ms) =
     +           q(jgede+2+(ipl-1)*iq(jgede+1) + jgede_ms) * 0.84**2
         endif

*        **** set sxmn/sxmx for cmp=1,8,9
         if ((igede_cmp(ipl).eq.1.or.(igede_cmp(ipl).ge.7.and.
     +        igede_cmp(ipl).le.9).or.
     +        igede_cmp(ipl).eq.0).and.ogede_gesl(ipl).gt.7) then
            if (fgede_sxmn(ipl).ne.0.0) then
               print *,' tfedit: pl, borders=',
     +              ipl, fgede_xmin(ipl), fgede_xmax(ipl),
     +              fgede_ymin(ipl), fgede_ymax(ipl)
               print *,' tfedit: ipl, fgede_sxmn(ipl)=',
     +              ipl, fgede_sxmn(ipl)
            endif
            q(jgede+2+(ipl-1)*iq(jgede+1) + jgede_sxmn)
     +           = fgede_xmin(ipl)
            q(jgede+2+(ipl-1)*iq(jgede+1) + jgede_sxmx)
     +           = fgede_xmax(ipl)
            q(jgede+2+(ipl-1)*iq(jgede+1) + jgede_symn)
     +           = fgede_ymin(ipl)
            q(jgede+2+(ipl-1)*iq(jgede+1) + jgede_symx)
     +           = fgede_ymax(ipl)
         endif
#endif

 10   continue

*     **** loop over walls
      nrich = 0
      do wall=1,iq(jgwal+2)
         if (igwal_shp(wall).eq.3) then
            if (fgwal_ms(wall).eq.0.) then
               q(jgwal+2+(wall-1)*iq(jgwal+1) + jgwal_ms) = 0.15e-4
            endif
            nrich = nrich + 1
         endif
      enddo
      if (nrich.gt.1) print *,' () tfedit: more than 1 rich?!'

      end
