*-- Author :    Rainer Mankel   27/07/95

      subroutine tffill(it,x,cx)

*     **** fill track parameters into track bank entry it
      implicit none
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/RTRA.fi"

#include "rang/zfpar.fi"
      double precision x(5), cx(5,5), d_mx, d_my, d_qpt, sq
      integer it, i_pack, i, j
#include "pris/zmpack.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/RTRA.ff"

      sq = 1.d0/ dsqrt(1.d0 + x(4)**2 / (1.d0 + x(3)**2))

*     **** fill track parameters
      q(qrtra_xf(it))  = x(1)
      q(qrtra_yf(it))  = x(2)
      q(qrtra_txf(it)) = x(3)
      q(qrtra_tyf(it)) = x(4)
      q(qrtra_pf(it))  = sq * x(5)

*      **** covariance of track parameters
      do i=1,5
         do j=i,5               ! packing
            i_pack = matrix_pack(i,j)
            q(qrtra_cvf(i_pack,it)) = 
     +           f_cov_zfpar(i) * f_cov_zfpar(j) * cx(i,j)
         enddo
      enddo

*     **** derivatives of q/p
      d_qpt = sq
      d_mx = x(5) * sq**3 * x(3) * x(4)**2
     +                                     / (1.d0 + x(3)**2)**2
      d_my = - x(5) * sq**3 * x(4) / (1.d0 + x(3)**2)

      i=5
      do j=1,4
         i_pack = matrix_pack(i,j)
         q(qrtra_cvf(i_pack,it)) =
     +        f_cov_zfpar(i) * f_cov_zfpar(j) 
     +        * (d_mx * cx(3,j) + d_my * cx(4,j) + d_qpt * cx(5,j))
      enddo
      i_pack = matrix_pack(5,5)
      q(qrtra_cvf(i_pack,it)) =
     +     f_cov_zfpar(5) * f_cov_zfpar(5) 
     +     * (d_mx**2 * cx(3,3) + d_my**2 * cx(4,4) + d_qpt**2 * cx(5,5)
     +       + 2. * d_mx * d_my * cx(3,4)
     +       + 2. * d_mx * d_qpt * cx(3,5)
     +       + 2. * d_my * d_qpt * cx(4,5))

      end
