*CMZ :  4.02/00 10/07/96  10.08.00  by  Rainer Mankel
*CMZ :  4.01/01 05/03/96  15.40.51  by  Rainer Mankel
*-- Author :    Rainer Mankel   10/02/96

      subroutine tffit(zmin,zmax)

      implicit none
#include "arte/Arte.fi"
#include "pris/zmh.fi"
#include "rang/zfmode.fi"
#include "pris/hgmagnhelp.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/RTRA.fi"
#include "auto/TOPP.fi"

      integer nmx
      parameter (nmx=20)
      integer imc, iii, evt_count, cmp, hits_cmp(3), hits_all, mimp,
     +     iih, hit_array(nmx), iso, ih, nhits, it, nt_old, iprob,
     +     hits_mag, istat, ii, ippabs, gcode
      real ptot, zmin, zmax, prob, chi2, chi2prob, pa(5), pamc(5),
     +     dpa(5), dpanorm(5), ch2mc, dpabs, dpabsnorm, ppabs
      logical init, tfcharg
      data evt_count /0/, init /.false./

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/RTRA.ff"
#include "auto/TOPP.ff"

      if (.not.init) then
         call hbook1( 1,' chi**2   ',50,0.,50.,0.)
         call hbook1( 2,' prob     ', 50,0.,1.,0.)
         call hbook1(11,' chi**2 Si',50,0.,50.,0.)
         call hbook1(12,' prob   Si', 50,0.,1.,0.)
         call hbook1(21,' chi**2 HDC',50,0.,50.,0.)
         call hbook1(22,' prob   HDC', 50,0.,1.,0.)
         call hbook1(31,' chi**2 MSGC',50,0.,50.,0.)
         call hbook1(32,' prob   MSGC', 50,0.,1.,0.)
         call hbook2(51,' p/prob ',50,0.,50.,50,0.,1.,0.)
         call hbook1(61,' chi**2 (e+-)   ',50,0.,50.,0.)
         call hbook1(62,' prob   (e+-)   ', 50,0.,1.,0.)
         call hbook1(71,' chi**2 (mip)   ',50,0.,50.,0.)
         call hbook1(72,' prob   (mip)   ', 50,0.,1.,0.)
         call hbook1(81,' chi**2 (mip) HDC ',50,0.,50.,0.)
         call hbook1(82,' prob   (mip) HDC ', 50,0.,1.,0.)
         call hbook1(91,' chi**2 (mip) MSGC',50,0.,50.,0.)
         call hbook1(92,' prob   (mip) MSGC', 50,0.,1.,0.)

         call hbook1(101,' delta(xf) electron',50,-0.02,0.02,0.)
         call hbook1(102,' delta(yf) electron',50,-0.02,0.02,0.)
         call hbook1(103,' delta(txf) electron',50,-0.004,0.004,0.)
         call hbook1(104,' delta(tyf) electron',50,-0.004,0.004,0.)
         call hbook1(105,' delta(Q/p) electron',50,-0.04,0.04,0.)
         call hbook1(106,' delta(1/p) electron',50,-0.04,0.04,0.)
         call hbook1(111,' delta(xf)/sigma(xf)  electron',50,-5.,5.,0.)
         call hbook1(112,' delta(yf)/sigma(yf)  electron',50,-5.,5.,0.)
         call hbook1(113,' delta(txf)/sigma(txf) electron',50,-5.,5.,0.)
         call hbook1(114,' delta(tyf)/sigma(tyf) electron',50,-5.,5.,0.)
         call hbook1(115,' delta(Q/p)/sigma(Q/p) electron',50,-5.,5.,0.)
         call hbook1(116,' delta(1/p)/sigma(Q/p) electron',50,-5.,5.,0.)

         call hbook1(121,' delta(xf) mip',50,-0.02,0.02,0.)
         call hbook1(122,' delta(yf)  mip',50,-0.02,0.02,0.)
         call hbook1(123,' delta(txf) mip',50,-0.004,0.004,0.)
         call hbook1(124,' delta(tyf) mip',50,-0.004,0.004,0.)
         call hbook1(125,' delta(Q/p) mip',50,-0.02,0.02,0.)
         call hbook1(126,' delta(1/p) mip',50,-0.02,0.02,0.)
         call hbook1(131,' delta(xf)/sigma(xf) mip ',50,-5.,5.,0.)
         call hbook1(132,' delta(yf)/sigma(yf)  mip',50,-5.,5.,0.)
         call hbook1(133,' delta(txf)/sigma(txf)  mip',50,-5.,5.,0.)
         call hbook1(134,' delta(tyf)/sigma(tyf)  mip',50,-5.,5.,0.)
         call hbook1(135,' delta(Q/p)/sigma(Q/p)  mip',50,-5.,5.,0.)
         call hbook1(136,' delta(1/p)/sigma(Q/p)  mip',50,-5.,5.,0.)

         call hbook1(181,' zf mip',50,0.,200.,0.)
         call hbook2(182,' xf vs yf mip',50,-5.,5.,50,-5.,5.,0.)
         call hbook1(183,' p mip',50,0.,100.,0.)
         call hbook2(191,' tx vs ty mip 1-5 GeV',50,-.1,.1,
     +        50,-.1,.1,0.)
         call hbook2(192,' tx vs ty mip 5-10 GeV',50,-.1,.1,
     +        50,-.1,.1,0.)
         call hbook2(193,' tx vs ty mip 10-20 GeV',50,-.1,.1,
     +        50,-.1,.1,0.)
         call hbook2(194,' tx vs ty mip 20-30 GeV',50,-.1,.1,
     +        50,-.1,.1,0.)
         call hbook2(195,' tx vs ty mip 20-30 GeV',50,-.1,.1,
     +        50,-.1,.1,0.)
         call hbook2(196,' tx vs ty mip 20-30 GeV',50,-.1,.1,
     +        50,-.1,.1,0.)
         call hbook2(197,' tx vs ty mip 20-30 GeV',50,-.1,.1,
     +        50,-.1,.1,0.)

         call hbook1(201,' delta(1/p) mip 1-5 GeV',50,-.01,.01,0.)
         call hbook1(202,' delta(1/p) mip 5-10 GeV',50,-.005,.005,0.)
         call hbook1(203,' delta(1/p) mip 10-20 GeV',50,-.002,.002,0.)
         call hbook1(204,' delta(1/p) mip 20-30 GeV',50,-.002,.002,0.)
         call hbook1(205,' delta(1/p) mip 30-40 GeV',50,-.002,.002,0.)
         call hbook1(206,' delta(1/p) mip 40-50 GeV',50,-.002,.002,0.)
         call hbook1(207,' delta(1/p) mip 50-60 GeV',50,-.002,.002,0.)

         call hbook1(8101,' imtrac prob lt 0.02',30,0.5,30.5,0.)
         call hbook1(8102,' imtrac prob gt 0.02',30,0.5,30.5,0.)
         call hbook1(8103,' ptot   prob lt 0.02',50,0.,50.,0.)
         call hbook1(8104,' ptot   prob gt 0.02',50,0.,50.,0.)
         init = .true.
      endif

      evt_count = evt_count + 1
      print *,' tffit: event=', evt_count

*     **** initialize /zmh/ if needed
      call tusomh()

*     **** loop over sensible MC particles
      print *,' tffit: Track fit...'
      do 10 imc=1,iq(jmtra+2)
*        **** check id
         gcode = itopp_gean(omtra_topp(imc))

         if (.not.tfcharg(imc)) go to 10

*        **** check momentum
         ptot = sqrt( fmtra_px(imc)**2 + fmtra_py(imc)**2
     +        + fmtra_pz(imc)**2 )
         if (ptot.lt.1.) go to 10

*        **** number of hits/mimps ?
         if (nmimmh(imc).le.10) go to 10

*        **** count hits for "cmp"
         do cmp=1,3
            hits_cmp(cmp) = 0
         enddo
         hits_all = 0
         hits_mag = 0
         do iso=nmimmh(imc),1,-1
            mimp = imimmh( istamh(imc) + iso )
*           **** get hits associated with mimp
            call tumimph(mimp,nmx,hit_array,nhits)
*           **** loop over associated hits
            do 30 iih=1,nhits
               ih = hit_array(iih)

*              **** check z
               if (fhitb_z(ih).lt.zmin.or.fhitb_z(ih).gt.zmax) go to 30
               cmp = igede_cmp(ihitb_gede(ih))
               if (cmp.ge.1.and.cmp.le.3) then
                  hits_cmp(cmp) = hits_cmp(cmp) + 1
               endif
               hits_all = hits_all + 1
*              **** check magnet
               if ((fmimp_x(mimp)**2+(ffeld_z(1)-fmimp_z(mimp))**2)
     +              .lt.ffeld_r(1)**2) then
                  hits_mag = hits_mag + 1
               endif
 30         continue
         enddo

         if (hits_all.le.0) go to 10

         if (mc_trap.ne.0.and.mc_trap.eq.imc) then
            print *,' tffit: trap struck for imc=', imc
            call tfwait()
         endif
         nt_old = nrtra()
         call tfidean(imc,zmin,zmax)

*        **** track analysis
         do 20 it=nt_old+1,nrtra()
            if (irtra_hou(it).ge.8) then
               chi2 = frtra_chi(it)
               chi2prob = prob(chi2,irtra_hou(it)-4)
               if (chi2.gt.-1.) then
                  call hfill(1,chi2,0.,1.)
                  call hfill(2,chi2prob,0.,1.)
               else
                  print *,' () tffit: it=',it,' chi2=',chi2
                  go to 20
               endif

               do cmp=1,3
                  if ((float(hits_cmp(cmp))/float(hits_all)).gt.0.5)
     +                 then
                     call hfill(10*cmp+1,chi2,0.,1.)
                     call hfill(10*cmp+2,chi2prob,0.,1.)
                     if (cmp.eq.1) then
                        call hfill(51,ptot,chi2prob,1.)
                     elseif (cmp.eq.3) then
                        if (chi2prob.lt.0.02) then
                           iprob = 0
                        else
                           iprob = 1
                        endif
                        call hfill(8101+iprob,float(gcode),0.,1.)
                        call hfill(8103+iprob,ptot,0.,1.)
                     endif
                  endif
               enddo

*              **** magnet analysis
               if (hits_mag.gt.9) then
                  if (hits_cmp(1).ge.0) then
                     chi2 = frtra_chi(it)
                     chi2prob = prob(chi2,irtra_hou(it)-5)
                     if (gcode.le.3) then
                        call hfill(61,chi2,0.,1.)
                        call hfill(62,chi2prob,0.,1.)
                     elseif (gcode.eq.5
     +                       .or.gcode.eq.6) then
                        call hfill(71,chi2,0.,1.)
                        call hfill(72,chi2prob,0.,1.)
                        do cmp=2,3
                           if ((float(hits_cmp(cmp))/float(hits_all))
     +                          .gt.0.8) then
                              call hfill(81+(cmp-2)*10,chi2,0.,1.)
                              call hfill(82+(cmp-2)*10,chi2prob,0.,1.)
                           endif
                        enddo
                     endif
                  endif
*                 **** track parameter analysis
                  istat = 0
                  call tftparm(it,imc,pa,pamc,dpa,dpanorm,ch2mc,istat)
                  if (istat.eq.0) then
                     do ii=1,5
                        if (gcode.le.3) then
                           call hfill(100+ii,dpa(ii),0.,1.)
                           call hfill(110+ii,dpanorm(ii),0.,1.)
                        else
                           call hfill(120+ii,dpa(ii),0.,1.)
                           call hfill(130+ii,dpanorm(ii),0.,1.)
                        endif
                     enddo
                     dpabs = abs(pa(5)) - abs(pamc(5))
                     dpabsnorm = dpabs * dpanorm(5) / dpa(5)
                     if (gcode.le.3) then
                        call hfill(100+6,dpabs,0.,1.)
                        call hfill(110+6,dpabsnorm,0.,1.)
                     elseif (gcode.eq.5
     +                       .or.gcode.eq.6) then ! mip part

                        if (abs(frtra_txf(it)).lt.0.1
     +                       .and.abs(frtra_tyf(it)).lt.0.1) then

                           call hfill(120+6,dpabs,0.,1.)
                           call hfill(130+6,dpabsnorm,0.,1.)

                           call hfill(181,frtra_zf(it),0.,1.)
                           call hfill(182,frtra_xf(it),frtra_yf(it),1.)

                           if (pa(5).ne.0.) then
                              ppabs = abs(1./pa(5))
                           else
                              ppabs = 0.
                           endif
                           call hfill(183,ppabs,0.,1.)

                           if (ppabs.gt.1.) then
                              if (ppabs.lt.5.) then
                                 call hfill(201,dpabs,0.,1.)
                                 call hfill(191,frtra_txf(it),
     +                                frtra_tyf(it),1.)
                              else
                                 ippabs = ppabs / 10. + 2
                                 if (ippabs.le.7) then
                                    call hfill(200+ippabs,dpabs,0.,1.)
                                    call hfill(190+ippabs,frtra_txf(it),
     +                                   frtra_tyf(it),1.)
                                 endif
                              endif
                           endif
                        endif
                     endif

                  endif
               elseif (hits_mag.eq.0) then
               endif
            endif
 20      continue

 10   continue

      end



