*-- Author :    Rainer Mankel   17/06/97

      real function tfmitoqp(mimp)

*     **** calculate MC Q/p from MC info in mimp
      implicit none
#include "arte/Arte.fi"
      integer mimp
**+cde,hgmagnhelp.

#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/TOPP.fi"
#include "auto/GEO.fi"
      real charge
#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/TOPP.ff"
#include "auto/GEO.ff"

      if (mimp.le.0.or.mimp.gt.iq(jmimp+2)) then
         print *,'() tfmitoqp: invalid mimp:',mimp
      else
         if (omimp_mtra(mimp).le.0.or.
     +        omimp_mtra(mimp).gt.iq(jmtra+2)) then
            print *,'() tfmitoqp: invalid mtra:',omimp_mtra(mimp)
         else
            if (omtra_topp( omimp_mtra(mimp)).le.0.or.
     +           omtra_topp( omimp_mtra(mimp)).gt.iq(jtopp+2)) then
               print *,'() tfmitoqp: invalid topp:',
     +              omtra_topp( omimp_mtra(mimp))
            endif
         endif
            
      endif

      charge = itopp_chrg(omtra_topp( omimp_mtra(mimp) )) / 3.
      tfmitoqp = charge / abs(fmimp_p(mimp))
      end
