*CMZ :  4.03/00 31/07/96  10.00.01  by  Rainer Mankel
*CMZ :  4.02/00 19/07/96  13.56.51  by  Rainer Mankel
*-- Author :    Rainer Mankel   31/05/96

      subroutine tfremcs(ind_s,nzf_s,imcass,fracmc)

      implicit none
#include "arte/Arte.fi"
#include "auto/HITB.fi"
#include "auto/MTRA.fi"
#include "auto/RTRA.fi"
#include "auto/RTRX.fi"
#include "auto/RHIT.fi"

#include "rang/zf.fi"

      integer imcass,nzf_s,ind_s(nzf_s),iizf,izf
      integer nhit,hit,imc,jaux,max_ass,nmxass,jmcass,ind_hit,iihitb
      real fracmc
      parameter (nmxass=40)
      integer mcass(nmxass),nmcass
      parameter (max_ass=40)
      integer i_ass,n_ass,ass(max_ass),count_ass(max_ass),mc_winner,
     +     count_winner

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"
#include "auto/RTRA.ff"
#include "auto/RTRX.ff"
#include "auto/RHIT.ff"


*     **** calculate for set of zf hits the
*     **** associated MC particle

      n_ass = 0

*     **** loop over hits used for track
      nhit = 0

      do 10 iizf=1,nzf_s   ! locate hits associated with track
         izf = ind_s(iizf)
         hit = hit_zf(izf)
         nhit = nhit + 1

*        **** locate MC particles associated with this hit
         call tumclo(hit,nmxass,nmcass,mcass)

*        **** loop over associated MC particles
         do jmcass=1,nmcass
            imc = mcass(jmcass)
            if (imc.lt.1.or.imc.gt.iq(jmtra+2)) then
               print *,' () tfremcs: invalid imc=', imc
               stop 'tfremcs'
            endif

            do i_ass=1,n_ass    ! check if already registered
               if (ass(i_ass).eq.imc) then
                  count_ass(i_ass) = count_ass(i_ass) + 1
                  go to 20
               endif
            enddo

            if (n_ass.lt.max_ass) then
               n_ass = n_ass + 1 ! register
               ass(n_ass) = imc
               count_ass(n_ass) = 1
            else
               print *,' () tfremcs: overflowing n_ass=', n_ass
               stop 'tfremcs'
            endif
 20         continue
         enddo

 10    continue

*      **** get maximum
       mc_winner = 0
       count_winner = 0

       do i_ass=1,n_ass
          if (count_ass(i_ass).gt.count_winner) then
             mc_winner = ass(i_ass)
             count_winner = count_ass(i_ass)
          endif
       enddo

       imcass = mc_winner
       fracmc = float( count_winner ) / float( nhit )

       end
