*-- Author :    Rainer Mankel   21/10/96

      subroutine tftranF(target_domain,dz,izf,jzf,istat)

*     **** fast version for transport matrix
      implicit none
#include "arte/Arte.fi"
      integer izf, jzf, istat, ii, jj, kk, ll,
     +        mm,iii,jjj,ndimmag,ipl,imc,mimp,nnmimp,target_domain
      parameter (ndimmag=5)
      double precision dz, z_target, z_domain, rrstart
      real pnoise, dnoise
      double precision sum, dzd
#include "rang/zf.fi"
#include "rang/zfpar.fi"
#include "rang/zfmode.fi"
#include "rang/zdomain.fi"
#include "rang/zcut.fi"

#include "pris/hgmagnhelp.fi"

#include "rang/zma.fi"
      double precision f (ndimmag,ndimmag), f1(ndimmag,ndimmag),
     +       f2(ndimmag,ndimmag)
      double precision x_border(ndimmag)

#include "auto/HITB.fi"
#include "auto/GEDE.fi"
#include "auto/GESL.fi"
#include "auto/MIMP.fi"

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/GEDE.ff"
#include "auto/GESL.ff"
#include "auto/MIMP.ff"

      istat = 0
      ipl = plane_zf(izf)

      z_target = z_zf(izf) + dz

      z_domain = z_dm(target_domain)

      dzd = z_target - z_domain

      if (abs(sngl(dzd)).gt.dzpara_mag_zfpar) then
         call tftrkut(ndimmag,x_db(1,target_domain),z_domain,z_target,
     +        xp_zf(1,jzf),f,istat)
      else
         call tftpara(ndimmag,x_db(1,target_domain),z_domain,z_target,
     +        xp_zf(1,jzf),f,istat)
      endif
      if (istat.lt.0) then
         print *,' tftranF: transport impossible (rk) '
         go to 999
      endif


*     **** step 3: propagate cov matrix
      if (hit_zf(izf).gt.0) then
         call tuhmimp(hit_zf(izf),imc,mimp,nnmimp)
         pnoise = amax1(abs( fmimp_p(mimp) ),1.)
      else
         pnoise = 5.
      endif
      if (fgede_ms(ipl).gt.0.) then
       dnoise = 1.d0 * (fault_zf(izf) + 1) * fgede_ms(ipl) / pnoise**2
      elseif (igede_cmp(ipl).eq.3) then
*      **** temporary: use old MSGC value until new value available
       dnoise = 1.d0 * (fault_zf(izf) + 1) * 0.6750e-6 / pnoise**2
      else
       print *,' () tftranF: no fgede_ms for ipl=', ipl
       dnoise = 0.
      endif
**      print *,' tftranF: izf, ih, fgede_ms, pnoise, dnoise=',
**     +          izf, hit_zf(izf), fgede_ms(ipl), pnoise, dnoise

      do ii=1,5
       do jj=ii,5
        sum = 0.
        do ll=1,5
         do mm=1,5
          if (ll.eq.mm.and.(ll.eq.3.or.ll.eq.4)) then
           sum = sum + f(ii,ll)
     +            * (cx_db(ll,mm,target_domain)+dnoise) * f(jj,mm)
          else
           sum = sum + f(ii,ll) * cx_db(ll,mm,target_domain) * f(jj,mm)
          endif
         enddo
        enddo
        cp_zf(ii,jj,jzf) = sum
        cp_zf(jj,ii,jzf) = sum
       enddo
      enddo

      if (diag_level.ge.6) then
       print *,' tftranF: dzd, izf=',dzd,izf
       print *,' tftranF: xx_zf(,izf)=',(xx_zf(iii,izf),iii=1,5)
       print *,' tftranF: cx_zf(,,izf)',
     +     ((cx_zf(iii,jjj,izf),iii=1,5),jjj=1,5)
       print *,' tftranF: xp_zf=',(xp_zf(iii,jzf),iii=1,5)
       print *,' tftranF: cp_zf=',
     +     ((cp_zf(iii,jjj,jzf),iii=1,5),jjj=1,5)
      endif

 999  end

