*CMZ :          19/08/96  18.31.43  by   Ivan Belyaev
*CMZ :  1.00/01 03/08/96  19.01.06  by   Ivan Belyaev
*CMZ :  1.04/11 12/12/95  20.07.24  by  joerg f. rieling
*CMZ :  1.04/10 22/11/95  12.36.52  by  joerg f. rieling
*CMZ :  1.04/09 08/11/95  11.29.39  by  joerg f. rieling
*CMZ :  1.04/08 07/11/95  13.40.38  by  joerg f. rieling
*-- Author :

c     -----------------------------------------------------------------
      subroutine ssimpla

      implicit none

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/SI.fi"
#include "auto/EV.fi"

c     --- common blocks
#include "susi/zsiconst.fi"
#include "susi/zsigeo.fi"
#include "susi/zsirctrk.fi"
#include "susi/zsihitmark.fi"


      INTEGER  iAUX   , jAUX , ISTAT 
      INTEGER  IHIT1 , FH1 , LH1 
      INTEGER  IHIT2 , FH2 , LH2 
      INTEGER  iPL1   , iPL2 , P1 , P2 ,i
      REAL     Z , P( 4 ) , C( 4 , 4 )
      REAL     c1 , c2 , s1 , s2 , d ,Z2 , Z1 , AC  
      REAL     x, y, tx , ty , tx1 , tx2 , ty1 , ty2  
      REAL     ZMIN, ZMAX , ZMID , DZ , MEAS1 , MEAS2 
      REAL     AC1 , AC2 , CXX, CYY , XX( 2 ) 
      REAL     ACX , ACY , ACTX , ACTY 
 
      LOGICAL  INPLANE2 
      EXTERNAL INPLANE2 
     
      INTEGER  LENOCC 
      EXTERNAL LENOCC

      LOGICAL  FIRST 
      SAVE     FIRST 

#include "susi/zsimtrx44.fi"

      DATA     FIRST /.TRUE./

c     --- common def''s / statement functions

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/SI.ff"
#include "auto/EV.ff"
#include "susi/zsigeo.ff"
#include "susi/zsihitmark.ff"


c      IF( FIRST )THEN
c       C78='SSIMPLA warning! Constants are valid for 04-01 geometry!' 
c       CALL MEMESC(109579,1,ILARGEST,C78(1:LENOCC(C78)))
c       CALL ME78AP
c       C78='Geometry version is:'
c       CALL CH78AF( FGEHD_GEOM(NGEHD()) , -4 ) 
c       CALL ME78AP 
c       C78='Constants may be not valid for this geometry!' 
c       CALL ME78AP  
c       FIRST = .FALSE. 
c      ENDIF 




      IF( JSPAR      .LE.   0 )CALL SUSIDEFV 
      IF( NSPAR()    .NE.   1 )CALL SUSIDEFV 
      IF( ISPAR_SEED(NSPAR()) .NE. 2 )RETURN 

      ISTAT = 0 
  
c     --- clear hit mark array (TMP! Another ARTE-Table?)
      CALL MMDROP(JMARK)
      IF( JHITB .GT. 0 )THEN
       CALL MMBOOK(JMARK,NHITB())
      ELSE 
       CALL MMBOOK(JMARK,0)
      ENDIF 

C*    Prepare the Arte Tables for SSIMtra 

      IF( JSTRC .NE. 0 ) CALL MMDROP( JSTRC )
      IF( JSHRC .NE. 0 ) CALL MMDROP( JSHRC )

      IF( JSTCA .NE. 0 ) CALL MMDROP( JSTCA )
      CALL MMBOOK( JSTCA , 1 )
      IF( JSHCA .NE. 0 ) CALL MMDROP( JSHCA )
      CALL MMBOOK( JSHCA , 1 )

C*    Loop over all planes in descending order, and Construct the 
C*    simple "SEED"s 

C*    Bad style , but it works, to be improved in future. 
      ZMIN = -44.0 
      ZMAX = +30.0
 
C*    Loop over all SI planes in descending order.
      DO iPL1 = NSNAV() , 1 , -1 

       FH1 = IGEPT_HIT1( plid( iPL1 ) ) 
       IF( FH1 .LE. 0   ) GO TO 20  ! no hits in the plane 
       LH1 = IGEPT_HITL( plid( iPL1 ) ) 
       IF( LH1 .LE. 0   ) GO TO 20  ! no hits in the plane 
       IF( LH1 .LT. FH1 ) GO TO 20  ! no hits in the plane 
 
       c1  = plcsr( iPL1 )               ! cos
       s1  = plsnr( iPL1 )               ! sin
       AC1 = FGEDE_ACC( plid( iPL1 ) ) ** 2 
 
C*     Loop over connected planes in the same superlayer 
       DO iPL2 = iPL1 - 1 , 1 , -1 

C*      Check the position of second plane

C*      The same GESL 
        IF( OGEDE_GESL( plid( iPL2 ) ) .NE. 
     &      OGEDE_GESL( plid( iPL1 ) ) )GO TO 10

C*      The different angle 
        s2 = plsnr( iPL2 ) 
        c2 = plcsr( iPL2 )  
        IF( c1 .EQ. c2 .AND. s1 .eq. s2 )GO TO 10 
        
        FH2 = IGEPT_HIT1( plid( iPL2 ) ) 
        IF( FH2 .LE. 0   ) GO TO 10  ! no hits in the plane 
        LH2 = IGEPT_HITL( plid( iPL2 ) ) 
        IF( LH2 .LE. 0   ) GO TO 10  ! no hits in the plane 
        IF( LH2 .LT. FH2 ) GO TO 10  ! no hits in the plane 
       
        AC2 = FGEDE_ACC( plid( iPL2 ) ) ** 2 
C*      Construct a 2-point "SEED" 
        Zmid = 0.5 * ( plz( iPL1 ) + plz( iPL2 ) )   
        DZ   = 0.5 * ( plz( iPL1 ) - plz( iPL2 ) ) 
        DZ   = ABS( DZ ) 
        IF( DZ .LE. 0.001 ) DZ = 0.001 
        
  
        D = -1.0 * ( C1*S2      - C2*S1 ) 
        
        CXX  = (AC1*S2*S2+AC2*S1*S1)/D/D 
        CYY  = (AC1*C2*C2+AC2*C1*C1)/D/D 

 1      CONTINUE 

C*      Use only nearest angle 
        IF( ABS(C1*C2-S1*S2).LT.0.8)GO TO 10 

        DO iHIT1 = FH1 , LH1
         MEAS1 = FHITB_X( iHIT1 )
         Z1    = FHITB_Z( iHIT1 ) 
         P1 = PHITB_MIMP( iHIT1 )   
         P1 = OMIMP_MTRA(MHITB_MIMP(P1))
         DO iHIT2 = FH2 , LH2
C*        Both hits are already used ???
cC        IF( HITMARK(iHIT1) .AND. HITMARK(iHIT2))GO TO 5 
          MEAS2 = FHITB_X( iHIT2 )  
          Z2    = FHITB_Z( iHIT2 ) 
          P2 = PHITB_MIMP( iHIT2 )   
          P2 = OMIMP_MTRA(MHITB_MIMP(P2))

C*        Construct the 2-point SEED 

          D = -1.0 * ( Z2*C1*S2      - Z2*C2*S1 ) 

          x = -1.0 * ( Z2*MEAS1*S2   -Z1*MEAS2*S1   )  
          y =        ( Z1*C1   *MEAS2-Z2*C2   *MEAS1)
          x = x / D 
          y = y / D
          xx( 1 ) = x 
          xx( 2 ) = y 
c*        In planes??? 

          IF(.NOT. inplane2(plxmi(iPL1),plxma(iPL1),
     &                  plymi(iPL1),plyma(iPL1),xx))GO TO 5
          IF(.NOT. inplane2(plxmi(iPL2),plxma(iPL2),
     &                  plymi(iPL2),plyma(iPL2),xx))GO TO 5

C*        Clear covariance matrix 
          DO i1  = 1 , 4
           DO i2 = 1 , 4
            C( i1, i2 ) = 0.0
           ENDDO 
          ENDDO 

          tx  = x / ( Zmid -  0.5 * ( ZMIN + ZMAX )) 
          ty  = y / ( Zmid -  0.5 * ( ZMIN + ZMAX ))
          tx1 = x / ( Zmid -          ZMIN         ) 
          ty1 = y / ( Zmid -          ZMIN         ) 
          tx2 = x / ( Zmid -                 ZMAX  )
          ty2 = y / ( Zmid -                 ZMAX  ) 

C*        Experimental sample of phenomenological constants,
C*        all of them are equal to "Infinity" with good precision.

          IF(     Z2 .LE.   5.0 )THEN 
           ACX  = 0.05**2
           ACY  = 0.05**2 
           ACTX = 0.15**2
           ACTY = 0.15**2
          ELSEIF( Z2 .LE.  12.0 )THEN
           ACX  = 0.03**2
           ACY  = 0.03**2 
           ACTX = 0.05**2
           ACTY = 0.05**2
          ELSEIF( Z2 .LE.  20.0 )THEN
           ACX  = 0.02**2
           ACY  = 0.02**2 
           ACTX = 0.02**2
           ACTY = 0.02**2
          ELSEIF( Z2 .LE.  35.0 )THEN
           ACX  = 0.01**2
           ACY  = 0.01**2 
           ACTX = 0.02**2
           ACTY = 0.02**2
          ELSEIF( Z2 .LE.  70.0 )THEN
           ACX  = 0.01**2
           ACY  = 0.01**2 
           ACTX = 0.015**2
           ACTY = 0.015**2
          ELSEIF( Z2 .LE. 120.0 )THEN
           ACX  = 0.01**2
           ACY  = 0.01**2 
           ACTX = 0.01**2
           ACTY = 0.01**2
          ELSE
           ACX  = 0.005**2
           ACY  = 0.005**2 
           ACTX = 0.01**2
           ACTY = 0.01**2
          ENDIF 
         
          C(1,1) = SQRT(ACX**2+CXX**2)*25.0
          C(2,2) = SQRT(ACY**2+CYY**2)*25.0
          C(3,3) = ACTX*16.0 
          C(4,4) = ACTY*16.0 

          Z      = z1
          P( 1 ) = x 
          P( 2 ) = y 
          P( 3 ) = tx 
          P( 4 ) = ty

          CALL SSIMtra(iPL1,iPL2,iHIT1,iHIT2,Z,P,C,.FALSE.)
          ISTAT = ISTAT + 1 

 5        CONTINUE 
         ENDDO 
        ENDDO 
 10      CONTINUE
       ENDDO  
 20    CONTINUE
      ENDDO 

C*    Remove the mirror(identical) tracks

      CALL SSIMREM

      IF( JSSTA .LE. 0 )CALL  SUSISTAT

      IF( ISTAT .LT. ISSTA_MNCP( NSSTA() ) )
     &  IQ(IQSSTA_MNCP_L()) = ISTAT
      IF( ISTAT .GT. ISSTA_MXCP( NSSTA() ) )
     &  IQ(IQSSTA_MXCP_L()) = ISTAT
      IQ(IQSSTA_NNCP_L()) = ISSTA_NNCP(NSSTA()) + ISTAT
       Q( QSSTA_YNCP_L()) = FSSTA_YNCP(NSSTA()) + ISTAT**2

C*    Drop the temporary banks:
      CALL MMDROP(JMARK)
      CALL MMDROP(JSTCA)
      CALL MMDROP(JSHCA)

      RETURN
      END




