
      SUBROUTINE SUSISTAT

************************************************************************
*
* $Source: /afs/desy.de/group/hera-b/repository/ARTE/susi/susistat.F,v $
* $Revision: 1.2 $
* $Author: hbcvs $
* $Date: 1997/11/23 23:45:46 $
*
* Created: Feb 30, 1991 by The Unknown Hacker
*
* Description: 
* Initialise the SUSi Statistical Table 
* Called from: anywhere
*
* Arguments:
* name       in/out/update Argument description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/SI.fi"

       INTEGER  LENOCC 
       EXTERNAL LENOCC 

#include "arte/Arte.ff"
#include "auto/SI.ff"
      
      IF( JSUSI .LE. 0 )THEN
       C78='SUSi Error! Impossible to modify the SUSi Statistics!'
       CALL MEMESC(2469276,ILARGEST,ILARGEST,C78(1:LENOCC(C78)))
       RETURN 
      ENDIF 
      
      IF( JSSTA .NE. 0)CALL MMDROP(JSSTA)
      CALL MMBOOK(JSSTA,1)
      IQ(IQSSTA_FRST_L( )) = NEVENTS
      IF(ISSTA_FRST(NSSTA()).EQ.0)
     &IQ(IQSSTA_FRST_L( )) = ISSTA_FRST(NSSTA())+1 
      IQ(IQSSTA_LAST_L()) = NEVENTS 
      IQ(IQSSTA_PRN_L( )) = 0 
      IQ(IQSSTA_MNPF_L()) = ILARGEST 
      IQ(IQSSTA_MNPR_L()) = ILARGEST 
      IQ(IQSSTA_MNRE_L()) = ILARGEST 
      IQ(IQSSTA_MNPT_L()) = ILARGEST 
      IQ(IQSSTA_MNEX_L()) = ILARGEST 
      IQ(IQSSTA_MNGH_L()) = ILARGEST 
      IQ(IQSSTA_MNSE_L()) = ILARGEST 
      IQ(IQSSTA_MNCP_L()) = ILARGEST 
      IQ(IQSSTA_MNRP_L()) = ILARGEST 

      C78='SUSi==> Start SUSiStat from Evt='
      CALL CH78AI( ISSTA_FRST(NSSTA()))
      CALL CH78CC('Exp/Run/Evt=')
      CALL CH78AI( NUMEXP ) 
      CALL CH78AC( '/'    ) 
      CALL CH78AI( NUMRUN ) 
      CALL CH78AC( '/'    ) 
      CALL CH78AI( NUMEVT )
      CALL MEMESC(723567,ILARGEST,ILARGEST,C78(1:LENOCC(C78))) 
    
      END
